/* Bezier.c generated by valac 0.56.3, the Vala compiler
 * generated from Bezier.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BEZIER (bezier_get_type ())
#define BEZIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BEZIER, Bezier))
#define BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BEZIER, BezierClass))
#define IS_BEZIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BEZIER))
#define IS_BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BEZIER))
#define BEZIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BEZIER, BezierClass))

typedef struct _Bezier Bezier;
typedef struct _BezierClass BezierClass;
typedef struct _BezierPrivate BezierPrivate;

#define BEZIER_TYPE_POINT (bezier_point_get_type ())
#define BEZIER_POINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BEZIER_TYPE_POINT, BezierPoint))
#define BEZIER_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BEZIER_TYPE_POINT, BezierPointClass))
#define BEZIER_IS_POINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BEZIER_TYPE_POINT))
#define BEZIER_IS_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BEZIER_TYPE_POINT))
#define BEZIER_POINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BEZIER_TYPE_POINT, BezierPointClass))

typedef struct _BezierPoint BezierPoint;
typedef struct _BezierPointClass BezierPointClass;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _bezier_point_unref0(var) ((var == NULL) ? NULL : (var = (bezier_point_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _BezierPointPrivate BezierPointPrivate;
typedef struct _BezierParamSpecPoint BezierParamSpecPoint;
typedef struct _ParamSpecBezier ParamSpecBezier;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Bezier {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BezierPrivate * priv;
};

struct _BezierClass {
	GTypeClass parent_class;
	void (*finalize) (Bezier *self);
};

struct _BezierPrivate {
	GArray* _points;
	GArray* _apoints;
	BezierPoint* _from;
	BezierPoint* _to;
};

struct _BezierPoint {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BezierPointPrivate * priv;
};

struct _BezierPointClass {
	GTypeClass parent_class;
	void (*finalize) (BezierPoint *self);
};

struct _BezierPointPrivate {
	gdouble _x;
	gdouble _y;
};

struct _BezierParamSpecPoint {
	GParamSpec parent_instance;
};

struct _ParamSpecBezier {
	GParamSpec parent_instance;
};

static gint Bezier_private_offset;
static gpointer bezier_parent_class = NULL;
static gint BezierPoint_private_offset;
static gpointer bezier_point_parent_class = NULL;

VALA_EXTERN gpointer bezier_ref (gpointer instance);
VALA_EXTERN void bezier_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_bezier (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_bezier (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_bezier (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_bezier (const GValue* value);
VALA_EXTERN GType bezier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bezier, bezier_unref)
static gpointer bezier_point_ref (gpointer instance);
static void bezier_point_unref (gpointer instance);
static GParamSpec* bezier_param_spec_point (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags) G_GNUC_UNUSED ;
static void bezier_value_set_point (GValue* value,
                             gpointer v_object) G_GNUC_UNUSED ;
static void bezier_value_take_point (GValue* value,
                              gpointer v_object) G_GNUC_UNUSED ;
static gpointer bezier_value_get_point (const GValue* value) G_GNUC_UNUSED ;
static GType bezier_point_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BezierPoint, bezier_point_unref)
static void _bezier_point_unref0_ (gpointer var);
static void _vala_BezierPoint_free_function_content_of (gpointer data);
static BezierPoint* bezier_point_new (void);
static BezierPoint* bezier_point_construct (GType object_type);
VALA_EXTERN Bezier* bezier_new (void);
VALA_EXTERN Bezier* bezier_construct (GType object_type);
VALA_EXTERN Bezier* bezier_new_with_endpoints (gdouble x0,
                                   gdouble y0,
                                   gdouble x1,
                                   gdouble y1);
VALA_EXTERN Bezier* bezier_construct_with_endpoints (GType object_type,
                                         gdouble x0,
                                         gdouble y0,
                                         gdouble x1,
                                         gdouble y1);
static void bezier_point_set_coordinate (BezierPoint* self,
                                  gdouble a,
                                  gdouble b);
VALA_EXTERN void bezier_copy (Bezier* self,
                  Bezier* b);
static gdouble bezier_point_get_x (BezierPoint* self);
static gdouble bezier_point_get_y (BezierPoint* self);
VALA_EXTERN void bezier_get_point (Bezier* self,
                       gint pindex,
                       gdouble* x,
                       gdouble* y);
VALA_EXTERN void bezier_get_from_point (Bezier* self,
                            gdouble* x,
                            gdouble* y);
VALA_EXTERN void bezier_get_to_point (Bezier* self,
                          gdouble* x,
                          gdouble* y);
VALA_EXTERN void bezier_set_point (Bezier* self,
                       gint pindex,
                       gdouble x,
                       gdouble y);
VALA_EXTERN void bezier_update_control_from_drag_handle (Bezier* self,
                                             gdouble x,
                                             gdouble y);
static gboolean bezier_is_t_within_range (Bezier* self,
                                   gdouble t);
static void bezier_align_point (Bezier* self,
                         gint pindex,
                         gdouble a,
                         gdouble tx,
                         gdouble ty);
static void bezier_align (Bezier* self,
                   gdouble lx0,
                   gdouble ly0,
                   gdouble lx1,
                   gdouble ly1);
static void bezier_get_roots (Bezier* self,
                       gdouble axis,
                       gboolean axis_is_x,
                       GArray** roots);
static gdouble* _double_dup (gdouble* self);
static gdouble bezier_get_axis (Bezier* self,
                         gdouble t,
                         gboolean axis_is_x);
VALA_EXTERN gboolean bezier_within_range (Bezier* self,
                              gdouble x,
                              gdouble y);
static void _g_free0_ (gpointer var);
static void _vala_gdouble_free_function_content_of (gpointer data);
VALA_EXTERN gdouble* bezier_get_intersecting_point (Bezier* self,
                                        gdouble axis,
                                        gboolean axis_is_x,
                                        gboolean from);
VALA_EXTERN void bezier_set_connect_point (Bezier* self,
                               gboolean from,
                               gdouble top,
                               gdouble bottom,
                               gdouble left,
                               gdouble right);
static BezierPoint* bezier_point_new_with_coordinate (gdouble a,
                                               gdouble b);
static BezierPoint* bezier_point_construct_with_coordinate (GType object_type,
                                                     gdouble a,
                                                     gdouble b);
static void bezier_point_set_x (BezierPoint* self,
                         gdouble value);
static void bezier_point_set_y (BezierPoint* self,
                         gdouble value);
static void bezier_point_finalize (BezierPoint * obj);
static GType bezier_point_get_type_once (void);
static void bezier_finalize (Bezier * obj);
static GType bezier_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
bezier_get_instance_private (Bezier* self)
{
	return G_STRUCT_MEMBER_P (self, Bezier_private_offset);
}

static void
_bezier_point_unref0_ (gpointer var)
{
#line 40 "../src/Bezier.vala"
	(var == NULL) ? NULL : (var = (bezier_point_unref (var), NULL));
#line 256 "Bezier.c"
}

static void
_vala_BezierPoint_free_function_content_of (gpointer data)
{
	BezierPoint* self;
#line 40 "../src/Bezier.vala"
	self = *((BezierPoint**) data);
#line 40 "../src/Bezier.vala"
	_bezier_point_unref0_ (self);
#line 267 "Bezier.c"
}

Bezier*
bezier_construct (GType object_type)
{
	Bezier* self = NULL;
#line 46 "../src/Bezier.vala"
	self = (Bezier*) g_type_create_instance (object_type);
#line 276 "Bezier.c"
	{
		gint i = 0;
#line 47 "../src/Bezier.vala"
		i = 0;
#line 281 "Bezier.c"
		{
			gboolean _tmp0_ = FALSE;
#line 47 "../src/Bezier.vala"
			_tmp0_ = TRUE;
#line 47 "../src/Bezier.vala"
			while (TRUE) {
#line 288 "Bezier.c"
				GArray* _tmp2_;
				BezierPoint* _tmp3_;
				GArray* _tmp4_;
				BezierPoint* _tmp5_;
#line 47 "../src/Bezier.vala"
				if (!_tmp0_) {
#line 295 "Bezier.c"
					gint _tmp1_;
#line 47 "../src/Bezier.vala"
					_tmp1_ = i;
#line 47 "../src/Bezier.vala"
					i = _tmp1_ + 1;
#line 301 "Bezier.c"
				}
#line 47 "../src/Bezier.vala"
				_tmp0_ = FALSE;
#line 47 "../src/Bezier.vala"
				if (!(i < 3)) {
#line 47 "../src/Bezier.vala"
					break;
#line 309 "Bezier.c"
				}
#line 48 "../src/Bezier.vala"
				_tmp2_ = self->priv->_points;
#line 48 "../src/Bezier.vala"
				_tmp3_ = bezier_point_new ();
#line 48 "../src/Bezier.vala"
				g_array_append_val (_tmp2_, _tmp3_);
#line 49 "../src/Bezier.vala"
				_tmp4_ = self->priv->_apoints;
#line 49 "../src/Bezier.vala"
				_tmp5_ = bezier_point_new ();
#line 49 "../src/Bezier.vala"
				g_array_append_val (_tmp4_, _tmp5_);
#line 323 "Bezier.c"
			}
		}
	}
#line 46 "../src/Bezier.vala"
	return self;
#line 329 "Bezier.c"
}

Bezier*
bezier_new (void)
{
#line 46 "../src/Bezier.vala"
	return bezier_construct (TYPE_BEZIER);
#line 337 "Bezier.c"
}

Bezier*
bezier_construct_with_endpoints (GType object_type,
                                 gdouble x0,
                                 gdouble y0,
                                 gdouble x1,
                                 gdouble y1)
{
	Bezier* self = NULL;
	GArray* _tmp6_;
	BezierPoint* _tmp7_;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	GArray* _tmp10_;
	BezierPoint* _tmp11_;
#line 54 "../src/Bezier.vala"
	self = (Bezier*) g_type_create_instance (object_type);
#line 356 "Bezier.c"
	{
		gint i = 0;
#line 55 "../src/Bezier.vala"
		i = 0;
#line 361 "Bezier.c"
		{
			gboolean _tmp0_ = FALSE;
#line 55 "../src/Bezier.vala"
			_tmp0_ = TRUE;
#line 55 "../src/Bezier.vala"
			while (TRUE) {
#line 368 "Bezier.c"
				GArray* _tmp2_;
				BezierPoint* _tmp3_;
				GArray* _tmp4_;
				BezierPoint* _tmp5_;
#line 55 "../src/Bezier.vala"
				if (!_tmp0_) {
#line 375 "Bezier.c"
					gint _tmp1_;
#line 55 "../src/Bezier.vala"
					_tmp1_ = i;
#line 55 "../src/Bezier.vala"
					i = _tmp1_ + 1;
#line 381 "Bezier.c"
				}
#line 55 "../src/Bezier.vala"
				_tmp0_ = FALSE;
#line 55 "../src/Bezier.vala"
				if (!(i < 3)) {
#line 55 "../src/Bezier.vala"
					break;
#line 389 "Bezier.c"
				}
#line 56 "../src/Bezier.vala"
				_tmp2_ = self->priv->_points;
#line 56 "../src/Bezier.vala"
				_tmp3_ = bezier_point_new ();
#line 56 "../src/Bezier.vala"
				g_array_append_val (_tmp2_, _tmp3_);
#line 57 "../src/Bezier.vala"
				_tmp4_ = self->priv->_apoints;
#line 57 "../src/Bezier.vala"
				_tmp5_ = bezier_point_new ();
#line 57 "../src/Bezier.vala"
				g_array_append_val (_tmp4_, _tmp5_);
#line 403 "Bezier.c"
			}
		}
	}
#line 59 "../src/Bezier.vala"
	_tmp6_ = self->priv->_points;
#line 59 "../src/Bezier.vala"
	_tmp7_ = g_array_index (_tmp6_, BezierPoint*, (guint) 0);
#line 59 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp7_, x0, y0);
#line 60 "../src/Bezier.vala"
	_tmp8_ = self->priv->_points;
#line 60 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) 1);
#line 60 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp9_, (x0 + x1) * 0.5, (y0 + y1) * 0.5);
#line 61 "../src/Bezier.vala"
	_tmp10_ = self->priv->_points;
#line 61 "../src/Bezier.vala"
	_tmp11_ = g_array_index (_tmp10_, BezierPoint*, (guint) 2);
#line 61 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp11_, x1, y1);
#line 54 "../src/Bezier.vala"
	return self;
#line 427 "Bezier.c"
}

Bezier*
bezier_new_with_endpoints (gdouble x0,
                           gdouble y0,
                           gdouble x1,
                           gdouble y1)
{
#line 54 "../src/Bezier.vala"
	return bezier_construct_with_endpoints (TYPE_BEZIER, x0, y0, x1, y1);
#line 438 "Bezier.c"
}

void
bezier_copy (Bezier* self,
             Bezier* b)
{
	BezierPoint* _tmp22_;
	BezierPoint* _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	BezierPoint* _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	BezierPoint* _tmp29_;
	BezierPoint* _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	BezierPoint* _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
#line 65 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/Bezier.vala"
	g_return_if_fail (b != NULL);
#line 463 "Bezier.c"
	{
		gint i = 0;
#line 66 "../src/Bezier.vala"
		i = 0;
#line 468 "Bezier.c"
		{
			gboolean _tmp0_ = FALSE;
#line 66 "../src/Bezier.vala"
			_tmp0_ = TRUE;
#line 66 "../src/Bezier.vala"
			while (TRUE) {
#line 475 "Bezier.c"
				GArray* _tmp2_;
				BezierPoint* _tmp3_;
				GArray* _tmp4_;
				BezierPoint* _tmp5_;
				gdouble _tmp6_;
				gdouble _tmp7_;
				GArray* _tmp8_;
				BezierPoint* _tmp9_;
				gdouble _tmp10_;
				gdouble _tmp11_;
				GArray* _tmp12_;
				BezierPoint* _tmp13_;
				GArray* _tmp14_;
				BezierPoint* _tmp15_;
				gdouble _tmp16_;
				gdouble _tmp17_;
				GArray* _tmp18_;
				BezierPoint* _tmp19_;
				gdouble _tmp20_;
				gdouble _tmp21_;
#line 66 "../src/Bezier.vala"
				if (!_tmp0_) {
#line 498 "Bezier.c"
					gint _tmp1_;
#line 66 "../src/Bezier.vala"
					_tmp1_ = i;
#line 66 "../src/Bezier.vala"
					i = _tmp1_ + 1;
#line 504 "Bezier.c"
				}
#line 66 "../src/Bezier.vala"
				_tmp0_ = FALSE;
#line 66 "../src/Bezier.vala"
				if (!(i < 3)) {
#line 66 "../src/Bezier.vala"
					break;
#line 512 "Bezier.c"
				}
#line 67 "../src/Bezier.vala"
				_tmp2_ = self->priv->_points;
#line 67 "../src/Bezier.vala"
				_tmp3_ = g_array_index (_tmp2_, BezierPoint*, (guint) i);
#line 67 "../src/Bezier.vala"
				_tmp4_ = b->priv->_points;
#line 67 "../src/Bezier.vala"
				_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) i);
#line 67 "../src/Bezier.vala"
				_tmp6_ = bezier_point_get_x (_tmp5_);
#line 67 "../src/Bezier.vala"
				_tmp7_ = _tmp6_;
#line 67 "../src/Bezier.vala"
				_tmp8_ = b->priv->_points;
#line 67 "../src/Bezier.vala"
				_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) i);
#line 67 "../src/Bezier.vala"
				_tmp10_ = bezier_point_get_y (_tmp9_);
#line 67 "../src/Bezier.vala"
				_tmp11_ = _tmp10_;
#line 67 "../src/Bezier.vala"
				bezier_point_set_coordinate (_tmp3_, _tmp7_, _tmp11_);
#line 68 "../src/Bezier.vala"
				_tmp12_ = self->priv->_apoints;
#line 68 "../src/Bezier.vala"
				_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) i);
#line 68 "../src/Bezier.vala"
				_tmp14_ = b->priv->_apoints;
#line 68 "../src/Bezier.vala"
				_tmp15_ = g_array_index (_tmp14_, BezierPoint*, (guint) i);
#line 68 "../src/Bezier.vala"
				_tmp16_ = bezier_point_get_x (_tmp15_);
#line 68 "../src/Bezier.vala"
				_tmp17_ = _tmp16_;
#line 68 "../src/Bezier.vala"
				_tmp18_ = b->priv->_apoints;
#line 68 "../src/Bezier.vala"
				_tmp19_ = g_array_index (_tmp18_, BezierPoint*, (guint) i);
#line 68 "../src/Bezier.vala"
				_tmp20_ = bezier_point_get_y (_tmp19_);
#line 68 "../src/Bezier.vala"
				_tmp21_ = _tmp20_;
#line 68 "../src/Bezier.vala"
				bezier_point_set_coordinate (_tmp13_, _tmp17_, _tmp21_);
#line 558 "Bezier.c"
			}
		}
	}
#line 70 "../src/Bezier.vala"
	_tmp22_ = self->priv->_from;
#line 70 "../src/Bezier.vala"
	_tmp23_ = b->priv->_from;
#line 70 "../src/Bezier.vala"
	_tmp24_ = bezier_point_get_x (_tmp23_);
#line 70 "../src/Bezier.vala"
	_tmp25_ = _tmp24_;
#line 70 "../src/Bezier.vala"
	_tmp26_ = b->priv->_from;
#line 70 "../src/Bezier.vala"
	_tmp27_ = bezier_point_get_y (_tmp26_);
#line 70 "../src/Bezier.vala"
	_tmp28_ = _tmp27_;
#line 70 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp22_, _tmp25_, _tmp28_);
#line 71 "../src/Bezier.vala"
	_tmp29_ = self->priv->_to;
#line 71 "../src/Bezier.vala"
	_tmp30_ = b->priv->_to;
#line 71 "../src/Bezier.vala"
	_tmp31_ = bezier_point_get_x (_tmp30_);
#line 71 "../src/Bezier.vala"
	_tmp32_ = _tmp31_;
#line 71 "../src/Bezier.vala"
	_tmp33_ = b->priv->_to;
#line 71 "../src/Bezier.vala"
	_tmp34_ = bezier_point_get_y (_tmp33_);
#line 71 "../src/Bezier.vala"
	_tmp35_ = _tmp34_;
#line 71 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp29_, _tmp32_, _tmp35_);
#line 594 "Bezier.c"
}

void
bezier_get_point (Bezier* self,
                  gint pindex,
                  gdouble* x,
                  gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
#line 75 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 76 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) pindex);
#line 76 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 76 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 76 "../src/Bezier.vala"
	_vala_x = _tmp3_;
#line 77 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 77 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) pindex);
#line 77 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_y (_tmp5_);
#line 77 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 77 "../src/Bezier.vala"
	_vala_y = _tmp7_;
#line 75 "../src/Bezier.vala"
	if (x) {
#line 75 "../src/Bezier.vala"
		*x = _vala_x;
#line 639 "Bezier.c"
	}
#line 75 "../src/Bezier.vala"
	if (y) {
#line 75 "../src/Bezier.vala"
		*y = _vala_y;
#line 645 "Bezier.c"
	}
}

void
bezier_get_from_point (Bezier* self,
                       gdouble* x,
                       gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	BezierPoint* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	BezierPoint* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 80 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/Bezier.vala"
	_tmp0_ = self->priv->_from;
#line 81 "../src/Bezier.vala"
	_tmp1_ = bezier_point_get_x (_tmp0_);
#line 81 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 81 "../src/Bezier.vala"
	_vala_x = _tmp2_;
#line 82 "../src/Bezier.vala"
	_tmp3_ = self->priv->_from;
#line 82 "../src/Bezier.vala"
	_tmp4_ = bezier_point_get_y (_tmp3_);
#line 82 "../src/Bezier.vala"
	_tmp5_ = _tmp4_;
#line 82 "../src/Bezier.vala"
	_vala_y = _tmp5_;
#line 80 "../src/Bezier.vala"
	if (x) {
#line 80 "../src/Bezier.vala"
		*x = _vala_x;
#line 684 "Bezier.c"
	}
#line 80 "../src/Bezier.vala"
	if (y) {
#line 80 "../src/Bezier.vala"
		*y = _vala_y;
#line 690 "Bezier.c"
	}
}

void
bezier_get_to_point (Bezier* self,
                     gdouble* x,
                     gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	BezierPoint* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	BezierPoint* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 85 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/Bezier.vala"
	_tmp0_ = self->priv->_to;
#line 86 "../src/Bezier.vala"
	_tmp1_ = bezier_point_get_x (_tmp0_);
#line 86 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 86 "../src/Bezier.vala"
	_vala_x = _tmp2_;
#line 87 "../src/Bezier.vala"
	_tmp3_ = self->priv->_to;
#line 87 "../src/Bezier.vala"
	_tmp4_ = bezier_point_get_y (_tmp3_);
#line 87 "../src/Bezier.vala"
	_tmp5_ = _tmp4_;
#line 87 "../src/Bezier.vala"
	_vala_y = _tmp5_;
#line 85 "../src/Bezier.vala"
	if (x) {
#line 85 "../src/Bezier.vala"
		*x = _vala_x;
#line 729 "Bezier.c"
	}
#line 85 "../src/Bezier.vala"
	if (y) {
#line 85 "../src/Bezier.vala"
		*y = _vala_y;
#line 735 "Bezier.c"
	}
}

void
bezier_set_point (Bezier* self,
                  gint pindex,
                  gdouble x,
                  gdouble y)
{
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
#line 91 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 92 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) pindex);
#line 92 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp1_, x, y);
#line 755 "Bezier.c"
}

void
bezier_update_control_from_drag_handle (Bezier* self,
                                        gdouble x,
                                        gdouble y)
{
	gdouble cx = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble cy = 0.0;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
#line 95 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 96 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) 0);
#line 96 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 96 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 96 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 96 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) 2);
#line 96 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_x (_tmp5_);
#line 96 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 96 "../src/Bezier.vala"
	cx = x - (((_tmp3_ + _tmp7_) * 0.5) - x);
#line 97 "../src/Bezier.vala"
	_tmp8_ = self->priv->_points;
#line 97 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) 0);
#line 97 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_y (_tmp9_);
#line 97 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 97 "../src/Bezier.vala"
	_tmp12_ = self->priv->_points;
#line 97 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) 2);
#line 97 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 97 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 97 "../src/Bezier.vala"
	cy = y - (((_tmp11_ + _tmp15_) * 0.5) - y);
#line 98 "../src/Bezier.vala"
	bezier_set_point (self, 1, cx, cy);
#line 821 "Bezier.c"
}

static gboolean
bezier_is_t_within_range (Bezier* self,
                          gdouble t)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 102 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 103 "../src/Bezier.vala"
	if (((gdouble) 0) <= t) {
#line 103 "../src/Bezier.vala"
		_tmp0_ = t <= ((gdouble) 1);
#line 836 "Bezier.c"
	} else {
#line 103 "../src/Bezier.vala"
		_tmp0_ = FALSE;
#line 840 "Bezier.c"
	}
#line 103 "../src/Bezier.vala"
	result = _tmp0_;
#line 103 "../src/Bezier.vala"
	return result;
#line 846 "Bezier.c"
}

static void
bezier_align_point (Bezier* self,
                    gint pindex,
                    gdouble a,
                    gdouble tx,
                    gdouble ty)
{
	gdouble x = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble y = 0.0;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	GArray* _tmp16_;
	BezierPoint* _tmp17_;
#line 107 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 108 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) pindex);
#line 108 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 108 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 108 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 108 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) pindex);
#line 108 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_y (_tmp5_);
#line 108 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 108 "../src/Bezier.vala"
	x = ((_tmp3_ - tx) * cos (a)) - ((_tmp7_ - ty) * sin (a));
#line 109 "../src/Bezier.vala"
	_tmp8_ = self->priv->_points;
#line 109 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) pindex);
#line 109 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_x (_tmp9_);
#line 109 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 109 "../src/Bezier.vala"
	_tmp12_ = self->priv->_points;
#line 109 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) pindex);
#line 109 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 109 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 109 "../src/Bezier.vala"
	y = ((_tmp11_ - tx) * sin (a)) + ((_tmp15_ - ty) * cos (a));
#line 110 "../src/Bezier.vala"
	_tmp16_ = self->priv->_apoints;
#line 110 "../src/Bezier.vala"
	_tmp17_ = g_array_index (_tmp16_, BezierPoint*, (guint) pindex);
#line 110 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp17_, x, y);
#line 920 "Bezier.c"
}

static void
bezier_align (Bezier* self,
              gdouble lx0,
              gdouble ly0,
              gdouble lx1,
              gdouble ly1)
{
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble a = 0.0;
#line 114 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/Bezier.vala"
	tx = lx0;
#line 117 "../src/Bezier.vala"
	ty = ly0;
#line 118 "../src/Bezier.vala"
	a = -atan2 (ly1 - ty, lx1 - tx);
#line 941 "Bezier.c"
	{
		gint i = 0;
#line 120 "../src/Bezier.vala"
		i = 0;
#line 946 "Bezier.c"
		{
			gboolean _tmp0_ = FALSE;
#line 120 "../src/Bezier.vala"
			_tmp0_ = TRUE;
#line 120 "../src/Bezier.vala"
			while (TRUE) {
#line 120 "../src/Bezier.vala"
				if (!_tmp0_) {
#line 955 "Bezier.c"
					gint _tmp1_;
#line 120 "../src/Bezier.vala"
					_tmp1_ = i;
#line 120 "../src/Bezier.vala"
					i = _tmp1_ + 1;
#line 961 "Bezier.c"
				}
#line 120 "../src/Bezier.vala"
				_tmp0_ = FALSE;
#line 120 "../src/Bezier.vala"
				if (!(i < 3)) {
#line 120 "../src/Bezier.vala"
					break;
#line 969 "Bezier.c"
				}
#line 121 "../src/Bezier.vala"
				bezier_align_point (self, i, a, tx, ty);
#line 973 "Bezier.c"
			}
		}
	}
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 145 "../src/Bezier.vala"
	dup = g_new0 (gdouble, 1);
#line 145 "../src/Bezier.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 145 "../src/Bezier.vala"
	return dup;
#line 989 "Bezier.c"
}

static gpointer
__double_dup0 (gpointer self)
{
#line 145 "../src/Bezier.vala"
	return self ? _double_dup (self) : NULL;
#line 997 "Bezier.c"
}

static void
bezier_get_roots (Bezier* self,
                  gdouble axis,
                  gboolean axis_is_x,
                  GArray** roots)
{
	gdouble _tmp0_ = 0.0;
	gdouble lx0 = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble ly0 = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble lx1 = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble ly1 = 0.0;
	gdouble a = 0.0;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble b = 0.0;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble c = 0.0;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble d = 0.0;
#line 127 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/Bezier.vala"
	g_return_if_fail (*roots != NULL);
#line 129 "../src/Bezier.vala"
	if (axis_is_x) {
#line 129 "../src/Bezier.vala"
		_tmp0_ = axis;
#line 1038 "Bezier.c"
	} else {
#line 129 "../src/Bezier.vala"
		_tmp0_ = (gdouble) 0;
#line 1042 "Bezier.c"
	}
#line 129 "../src/Bezier.vala"
	lx0 = _tmp0_;
#line 130 "../src/Bezier.vala"
	if (axis_is_x) {
#line 130 "../src/Bezier.vala"
		_tmp1_ = (gdouble) 0;
#line 1050 "Bezier.c"
	} else {
#line 130 "../src/Bezier.vala"
		_tmp1_ = axis;
#line 1054 "Bezier.c"
	}
#line 130 "../src/Bezier.vala"
	ly0 = _tmp1_;
#line 131 "../src/Bezier.vala"
	if (axis_is_x) {
#line 131 "../src/Bezier.vala"
		_tmp2_ = axis;
#line 1062 "Bezier.c"
	} else {
#line 131 "../src/Bezier.vala"
		_tmp2_ = (gdouble) 1000000;
#line 1066 "Bezier.c"
	}
#line 131 "../src/Bezier.vala"
	lx1 = _tmp2_;
#line 132 "../src/Bezier.vala"
	if (axis_is_x) {
#line 132 "../src/Bezier.vala"
		_tmp3_ = (gdouble) 1000000;
#line 1074 "Bezier.c"
	} else {
#line 132 "../src/Bezier.vala"
		_tmp3_ = axis;
#line 1078 "Bezier.c"
	}
#line 132 "../src/Bezier.vala"
	ly1 = _tmp3_;
#line 133 "../src/Bezier.vala"
	bezier_align (self, lx0, ly0, lx1, ly1);
#line 135 "../src/Bezier.vala"
	_tmp4_ = self->priv->_apoints;
#line 135 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) 0);
#line 135 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_y (_tmp5_);
#line 135 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 135 "../src/Bezier.vala"
	a = _tmp7_;
#line 136 "../src/Bezier.vala"
	_tmp8_ = self->priv->_apoints;
#line 136 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) 1);
#line 136 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_y (_tmp9_);
#line 136 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 136 "../src/Bezier.vala"
	b = _tmp11_;
#line 137 "../src/Bezier.vala"
	_tmp12_ = self->priv->_apoints;
#line 137 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) 2);
#line 137 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 137 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 137 "../src/Bezier.vala"
	c = _tmp15_;
#line 138 "../src/Bezier.vala"
	d = (a - (2 * b)) + c;
#line 140 "../src/Bezier.vala"
	if (d != ((gdouble) 0)) {
#line 1118 "Bezier.c"
		gdouble m1 = 0.0;
		gdouble m2 = 0.0;
		gdouble v1 = 0.0;
		gdouble v2 = 0.0;
#line 141 "../src/Bezier.vala"
		m1 = -sqrt ((b * b) - (a * c));
#line 142 "../src/Bezier.vala"
		m2 = (-a) + b;
#line 143 "../src/Bezier.vala"
		v1 = (-(m1 + m2)) / d;
#line 144 "../src/Bezier.vala"
		v2 = (-((-m1) + m2)) / d;
#line 145 "../src/Bezier.vala"
		if (bezier_is_t_within_range (self, v1)) {
#line 1133 "Bezier.c"
			gdouble* _tmp16_;
#line 145 "../src/Bezier.vala"
			_tmp16_ = __double_dup0 (&v1);
#line 145 "../src/Bezier.vala"
			g_array_append_val (*roots, _tmp16_);
#line 1139 "Bezier.c"
		}
#line 146 "../src/Bezier.vala"
		if (bezier_is_t_within_range (self, v2)) {
#line 1143 "Bezier.c"
			gdouble* _tmp17_;
#line 146 "../src/Bezier.vala"
			_tmp17_ = __double_dup0 (&v2);
#line 146 "../src/Bezier.vala"
			g_array_append_val (*roots, _tmp17_);
#line 1149 "Bezier.c"
		}
	} else {
#line 147 "../src/Bezier.vala"
		if (b != c) {
#line 1154 "Bezier.c"
			gdouble v = 0.0;
#line 148 "../src/Bezier.vala"
			v = ((2 * b) - c) / (2 * (b - c));
#line 149 "../src/Bezier.vala"
			if (bezier_is_t_within_range (self, v)) {
#line 1160 "Bezier.c"
				gdouble* _tmp18_;
#line 149 "../src/Bezier.vala"
				_tmp18_ = __double_dup0 (&v);
#line 149 "../src/Bezier.vala"
				g_array_append_val (*roots, _tmp18_);
#line 1166 "Bezier.c"
			}
		}
	}
}

static gdouble
bezier_get_axis (Bezier* self,
                 gdouble t,
                 gboolean axis_is_x)
{
	gdouble mt = 0.0;
	gdouble mt2 = 0.0;
	gdouble t2 = 0.0;
	gdouble a = 0.0;
	gdouble b = 0.0;
	gdouble c = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble axis = 0.0;
	gdouble result;
#line 154 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 156 "../src/Bezier.vala"
	mt = 1 - t;
#line 157 "../src/Bezier.vala"
	mt2 = mt * mt;
#line 158 "../src/Bezier.vala"
	t2 = t * t;
#line 159 "../src/Bezier.vala"
	a = mt2;
#line 160 "../src/Bezier.vala"
	b = (mt * t) * 2;
#line 161 "../src/Bezier.vala"
	c = t2;
#line 162 "../src/Bezier.vala"
	if (axis_is_x) {
#line 1204 "Bezier.c"
		GArray* _tmp1_;
		BezierPoint* _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 162 "../src/Bezier.vala"
		_tmp1_ = self->priv->_points;
#line 162 "../src/Bezier.vala"
		_tmp2_ = g_array_index (_tmp1_, BezierPoint*, (guint) 0);
#line 162 "../src/Bezier.vala"
		_tmp3_ = bezier_point_get_y (_tmp2_);
#line 162 "../src/Bezier.vala"
		_tmp4_ = _tmp3_;
#line 162 "../src/Bezier.vala"
		_tmp0_ = _tmp4_;
#line 1219 "Bezier.c"
	} else {
		GArray* _tmp5_;
		BezierPoint* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
#line 162 "../src/Bezier.vala"
		_tmp5_ = self->priv->_points;
#line 162 "../src/Bezier.vala"
		_tmp6_ = g_array_index (_tmp5_, BezierPoint*, (guint) 0);
#line 162 "../src/Bezier.vala"
		_tmp7_ = bezier_point_get_x (_tmp6_);
#line 162 "../src/Bezier.vala"
		_tmp8_ = _tmp7_;
#line 162 "../src/Bezier.vala"
		_tmp0_ = _tmp8_;
#line 1235 "Bezier.c"
	}
#line 163 "../src/Bezier.vala"
	if (axis_is_x) {
#line 1239 "Bezier.c"
		GArray* _tmp10_;
		BezierPoint* _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
#line 163 "../src/Bezier.vala"
		_tmp10_ = self->priv->_points;
#line 163 "../src/Bezier.vala"
		_tmp11_ = g_array_index (_tmp10_, BezierPoint*, (guint) 1);
#line 163 "../src/Bezier.vala"
		_tmp12_ = bezier_point_get_y (_tmp11_);
#line 163 "../src/Bezier.vala"
		_tmp13_ = _tmp12_;
#line 163 "../src/Bezier.vala"
		_tmp9_ = _tmp13_;
#line 1254 "Bezier.c"
	} else {
		GArray* _tmp14_;
		BezierPoint* _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
#line 163 "../src/Bezier.vala"
		_tmp14_ = self->priv->_points;
#line 163 "../src/Bezier.vala"
		_tmp15_ = g_array_index (_tmp14_, BezierPoint*, (guint) 1);
#line 163 "../src/Bezier.vala"
		_tmp16_ = bezier_point_get_x (_tmp15_);
#line 163 "../src/Bezier.vala"
		_tmp17_ = _tmp16_;
#line 163 "../src/Bezier.vala"
		_tmp9_ = _tmp17_;
#line 1270 "Bezier.c"
	}
#line 164 "../src/Bezier.vala"
	if (axis_is_x) {
#line 1274 "Bezier.c"
		GArray* _tmp19_;
		BezierPoint* _tmp20_;
		gdouble _tmp21_;
		gdouble _tmp22_;
#line 164 "../src/Bezier.vala"
		_tmp19_ = self->priv->_points;
#line 164 "../src/Bezier.vala"
		_tmp20_ = g_array_index (_tmp19_, BezierPoint*, (guint) 2);
#line 164 "../src/Bezier.vala"
		_tmp21_ = bezier_point_get_y (_tmp20_);
#line 164 "../src/Bezier.vala"
		_tmp22_ = _tmp21_;
#line 164 "../src/Bezier.vala"
		_tmp18_ = _tmp22_;
#line 1289 "Bezier.c"
	} else {
		GArray* _tmp23_;
		BezierPoint* _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
#line 164 "../src/Bezier.vala"
		_tmp23_ = self->priv->_points;
#line 164 "../src/Bezier.vala"
		_tmp24_ = g_array_index (_tmp23_, BezierPoint*, (guint) 2);
#line 164 "../src/Bezier.vala"
		_tmp25_ = bezier_point_get_x (_tmp24_);
#line 164 "../src/Bezier.vala"
		_tmp26_ = _tmp25_;
#line 164 "../src/Bezier.vala"
		_tmp18_ = _tmp26_;
#line 1305 "Bezier.c"
	}
#line 162 "../src/Bezier.vala"
	axis = ((a * _tmp0_) + (b * _tmp9_)) + (c * _tmp18_);
#line 166 "../src/Bezier.vala"
	result = axis;
#line 166 "../src/Bezier.vala"
	return result;
#line 1313 "Bezier.c"
}

static void
_g_free0_ (gpointer var)
{
#line 173 "../src/Bezier.vala"
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
#line 1321 "Bezier.c"
}

static void
_vala_gdouble_free_function_content_of (gpointer data)
{
	gdouble* self;
#line 173 "../src/Bezier.vala"
	self = *((gdouble**) data);
#line 173 "../src/Bezier.vala"
	_g_free0_ (self);
#line 1332 "Bezier.c"
}

static gpointer*
vala_g_array_remove_range (GArray* self,
                           guint index,
                           guint length,
                           gint* result_length1)
{
	gpointer* ga = NULL;
	gpointer* _tmp0_;
	gint ga_length1;
	gint _ga_size_;
	gpointer* _tmp6_;
	gint _tmp6__length1;
	gpointer* result;
#line 6037 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 6038 "glib-2.0.vapi"
	_vala_assert (self->len >= (index + length), "this.length >= index + length");
#line 6039 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gpointer, length);
#line 6039 "glib-2.0.vapi"
	ga = _tmp0_;
#line 6039 "glib-2.0.vapi"
	ga_length1 = length;
#line 6039 "glib-2.0.vapi"
	_ga_size_ = ga_length1;
#line 1360 "Bezier.c"
	{
		guint i = 0U;
#line 6040 "glib-2.0.vapi"
		i = (guint) 0;
#line 1365 "Bezier.c"
		{
			gboolean _tmp1_ = FALSE;
#line 6040 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 6040 "glib-2.0.vapi"
			while (TRUE) {
#line 1372 "Bezier.c"
				gpointer* _tmp3_;
				gint _tmp3__length1;
				gpointer* _tmp4_;
				gint _tmp4__length1;
				gpointer _tmp5_;
#line 6040 "glib-2.0.vapi"
				if (!_tmp1_) {
#line 1380 "Bezier.c"
					guint _tmp2_;
#line 6040 "glib-2.0.vapi"
					_tmp2_ = i;
#line 6040 "glib-2.0.vapi"
					i = _tmp2_ + 1;
#line 1386 "Bezier.c"
				}
#line 6040 "glib-2.0.vapi"
				_tmp1_ = FALSE;
#line 6040 "glib-2.0.vapi"
				if (!(i < length)) {
#line 6040 "glib-2.0.vapi"
					break;
#line 1394 "Bezier.c"
				}
#line 6041 "glib-2.0.vapi"
				_tmp3_ = ga;
#line 6041 "glib-2.0.vapi"
				_tmp3__length1 = ga_length1;
#line 6041 "glib-2.0.vapi"
				_tmp4_ = self->data;
#line 6041 "glib-2.0.vapi"
				_tmp4__length1 = self->len;
#line 6041 "glib-2.0.vapi"
				_tmp5_ = _tmp4_[i + index];
#line 6041 "glib-2.0.vapi"
				_tmp4_[i + index] = NULL;
#line 6041 "glib-2.0.vapi"
				_tmp3_[i] = _tmp5_;
#line 1410 "Bezier.c"
			}
		}
	}
#line 6043 "glib-2.0.vapi"
	g_array_remove_range (self, index, length);
#line 6044 "glib-2.0.vapi"
	_tmp6_ = ga;
#line 6044 "glib-2.0.vapi"
	_tmp6__length1 = ga_length1;
#line 6044 "glib-2.0.vapi"
	if (result_length1) {
#line 6044 "glib-2.0.vapi"
		*result_length1 = _tmp6__length1;
#line 1424 "Bezier.c"
	}
#line 6044 "glib-2.0.vapi"
	result = _tmp6_;
#line 6044 "glib-2.0.vapi"
	return result;
#line 1430 "Bezier.c"
}

gboolean
bezier_within_range (Bezier* self,
                     gdouble x,
                     gdouble y)
{
	GArray* roots = NULL;
	GArray* _tmp0_;
	gdouble tolerance = 0.0;
	GArray* _tmp1_;
	GArray* _tmp7_;
	GArray* _tmp8_;
	gint _tmp9_ = 0;
	gpointer* _tmp10_;
	gdouble** _tmp11_;
	gint _tmp11__length1;
	gboolean result;
#line 171 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 173 "../src/Bezier.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gdouble*));
#line 173 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_gdouble_free_function_content_of);
#line 173 "../src/Bezier.vala"
	roots = _tmp0_;
#line 174 "../src/Bezier.vala"
	tolerance = (gdouble) 10;
#line 177 "../src/Bezier.vala"
	bezier_get_roots (self, x, TRUE, &roots);
#line 179 "../src/Bezier.vala"
	_tmp1_ = roots;
#line 179 "../src/Bezier.vala"
	if (_tmp1_->len > ((guint) 0)) {
#line 1465 "Bezier.c"
		{
			gint i = 0;
#line 180 "../src/Bezier.vala"
			i = 0;
#line 1470 "Bezier.c"
			{
				gboolean _tmp2_ = FALSE;
#line 180 "../src/Bezier.vala"
				_tmp2_ = TRUE;
#line 180 "../src/Bezier.vala"
				while (TRUE) {
#line 1477 "Bezier.c"
					GArray* _tmp4_;
					gdouble curve_y = 0.0;
					GArray* _tmp5_;
					gboolean _tmp6_ = FALSE;
#line 180 "../src/Bezier.vala"
					if (!_tmp2_) {
#line 1484 "Bezier.c"
						gint _tmp3_;
#line 180 "../src/Bezier.vala"
						_tmp3_ = i;
#line 180 "../src/Bezier.vala"
						i = _tmp3_ + 1;
#line 1490 "Bezier.c"
					}
#line 180 "../src/Bezier.vala"
					_tmp2_ = FALSE;
#line 180 "../src/Bezier.vala"
					_tmp4_ = roots;
#line 180 "../src/Bezier.vala"
					if (!(((guint) i) < _tmp4_->len)) {
#line 180 "../src/Bezier.vala"
						break;
#line 1500 "Bezier.c"
					}
#line 181 "../src/Bezier.vala"
					_tmp5_ = roots;
#line 181 "../src/Bezier.vala"
					curve_y = bezier_get_axis (self, *g_array_index (_tmp5_, gdouble*, (guint) i), TRUE);
#line 182 "../src/Bezier.vala"
					if ((curve_y - tolerance) <= y) {
#line 182 "../src/Bezier.vala"
						_tmp6_ = y <= (curve_y + tolerance);
#line 1510 "Bezier.c"
					} else {
#line 182 "../src/Bezier.vala"
						_tmp6_ = FALSE;
#line 1514 "Bezier.c"
					}
#line 182 "../src/Bezier.vala"
					if (_tmp6_) {
#line 183 "../src/Bezier.vala"
						result = TRUE;
#line 183 "../src/Bezier.vala"
						_g_array_unref0 (roots);
#line 183 "../src/Bezier.vala"
						return result;
#line 1524 "Bezier.c"
					}
				}
			}
		}
	}
#line 189 "../src/Bezier.vala"
	_tmp7_ = roots;
#line 189 "../src/Bezier.vala"
	_tmp8_ = roots;
#line 189 "../src/Bezier.vala"
	_tmp10_ = vala_g_array_remove_range (_tmp7_, (guint) 0, _tmp8_->len, &_tmp9_);
#line 189 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 189 "../src/Bezier.vala"
	_tmp11__length1 = _tmp9_;
#line 189 "../src/Bezier.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 190 "../src/Bezier.vala"
	bezier_get_roots (self, y, FALSE, &roots);
#line 1544 "Bezier.c"
	{
		gint i = 0;
#line 192 "../src/Bezier.vala"
		i = 0;
#line 1549 "Bezier.c"
		{
			gboolean _tmp12_ = FALSE;
#line 192 "../src/Bezier.vala"
			_tmp12_ = TRUE;
#line 192 "../src/Bezier.vala"
			while (TRUE) {
#line 1556 "Bezier.c"
				GArray* _tmp14_;
				gdouble curve_x = 0.0;
				GArray* _tmp15_;
				gboolean _tmp16_ = FALSE;
#line 192 "../src/Bezier.vala"
				if (!_tmp12_) {
#line 1563 "Bezier.c"
					gint _tmp13_;
#line 192 "../src/Bezier.vala"
					_tmp13_ = i;
#line 192 "../src/Bezier.vala"
					i = _tmp13_ + 1;
#line 1569 "Bezier.c"
				}
#line 192 "../src/Bezier.vala"
				_tmp12_ = FALSE;
#line 192 "../src/Bezier.vala"
				_tmp14_ = roots;
#line 192 "../src/Bezier.vala"
				if (!(((guint) i) < _tmp14_->len)) {
#line 192 "../src/Bezier.vala"
					break;
#line 1579 "Bezier.c"
				}
#line 193 "../src/Bezier.vala"
				_tmp15_ = roots;
#line 193 "../src/Bezier.vala"
				curve_x = bezier_get_axis (self, *g_array_index (_tmp15_, gdouble*, (guint) i), FALSE);
#line 194 "../src/Bezier.vala"
				if ((curve_x - tolerance) <= x) {
#line 194 "../src/Bezier.vala"
					_tmp16_ = x <= (curve_x + tolerance);
#line 1589 "Bezier.c"
				} else {
#line 194 "../src/Bezier.vala"
					_tmp16_ = FALSE;
#line 1593 "Bezier.c"
				}
#line 194 "../src/Bezier.vala"
				if (_tmp16_) {
#line 195 "../src/Bezier.vala"
					result = TRUE;
#line 195 "../src/Bezier.vala"
					_g_array_unref0 (roots);
#line 195 "../src/Bezier.vala"
					return result;
#line 1603 "Bezier.c"
				}
			}
		}
	}
#line 199 "../src/Bezier.vala"
	result = FALSE;
#line 199 "../src/Bezier.vala"
	_g_array_unref0 (roots);
#line 199 "../src/Bezier.vala"
	return result;
#line 1614 "Bezier.c"
}

gdouble*
bezier_get_intersecting_point (Bezier* self,
                               gdouble axis,
                               gboolean axis_is_x,
                               gboolean from)
{
	GArray* roots = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	gdouble* result;
#line 204 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 206 "../src/Bezier.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gdouble*));
#line 206 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_gdouble_free_function_content_of);
#line 206 "../src/Bezier.vala"
	roots = _tmp0_;
#line 208 "../src/Bezier.vala"
	bezier_get_roots (self, axis, axis_is_x, &roots);
#line 210 "../src/Bezier.vala"
	_tmp1_ = roots;
#line 210 "../src/Bezier.vala"
	switch (_tmp1_->len) {
#line 210 "../src/Bezier.vala"
		case 0:
#line 1643 "Bezier.c"
		{
#line 211 "../src/Bezier.vala"
			result = NULL;
#line 211 "../src/Bezier.vala"
			_g_array_unref0 (roots);
#line 211 "../src/Bezier.vala"
			return result;
#line 1651 "Bezier.c"
		}
#line 210 "../src/Bezier.vala"
		case 1:
#line 1655 "Bezier.c"
		{
			GArray* _tmp2_;
			gdouble _tmp3_;
			gdouble* _tmp4_;
#line 213 "../src/Bezier.vala"
			_tmp2_ = roots;
#line 213 "../src/Bezier.vala"
			_tmp3_ = bezier_get_axis (self, *g_array_index (_tmp2_, gdouble*, (guint) 0), axis_is_x);
#line 213 "../src/Bezier.vala"
			_tmp4_ = __double_dup0 (&_tmp3_);
#line 213 "../src/Bezier.vala"
			result = _tmp4_;
#line 213 "../src/Bezier.vala"
			_g_array_unref0 (roots);
#line 213 "../src/Bezier.vala"
			return result;
#line 1672 "Bezier.c"
		}
		default:
		{
#line 215 "../src/Bezier.vala"
			if (from) {
#line 1678 "Bezier.c"
				gdouble max = 0.0;
				gdouble _tmp10_;
				gdouble* _tmp11_;
#line 216 "../src/Bezier.vala"
				max = (gdouble) 1000000;
#line 1684 "Bezier.c"
				{
					gint i = 0;
#line 217 "../src/Bezier.vala"
					i = 0;
#line 1689 "Bezier.c"
					{
						gboolean _tmp5_ = FALSE;
#line 217 "../src/Bezier.vala"
						_tmp5_ = TRUE;
#line 217 "../src/Bezier.vala"
						while (TRUE) {
#line 1696 "Bezier.c"
							GArray* _tmp7_;
							GArray* _tmp8_;
#line 217 "../src/Bezier.vala"
							if (!_tmp5_) {
#line 1701 "Bezier.c"
								gint _tmp6_;
#line 217 "../src/Bezier.vala"
								_tmp6_ = i;
#line 217 "../src/Bezier.vala"
								i = _tmp6_ + 1;
#line 1707 "Bezier.c"
							}
#line 217 "../src/Bezier.vala"
							_tmp5_ = FALSE;
#line 217 "../src/Bezier.vala"
							_tmp7_ = roots;
#line 217 "../src/Bezier.vala"
							if (!(((guint) i) < _tmp7_->len)) {
#line 217 "../src/Bezier.vala"
								break;
#line 1717 "Bezier.c"
							}
#line 218 "../src/Bezier.vala"
							_tmp8_ = roots;
#line 218 "../src/Bezier.vala"
							if ((*g_array_index (_tmp8_, gdouble*, (guint) i)) < max) {
#line 1723 "Bezier.c"
								GArray* _tmp9_;
#line 219 "../src/Bezier.vala"
								_tmp9_ = roots;
#line 219 "../src/Bezier.vala"
								max = *g_array_index (_tmp9_, gdouble*, (guint) i);
#line 1729 "Bezier.c"
							}
						}
					}
				}
#line 222 "../src/Bezier.vala"
				_tmp10_ = bezier_get_axis (self, max, axis_is_x);
#line 222 "../src/Bezier.vala"
				_tmp11_ = __double_dup0 (&_tmp10_);
#line 222 "../src/Bezier.vala"
				result = _tmp11_;
#line 222 "../src/Bezier.vala"
				_g_array_unref0 (roots);
#line 222 "../src/Bezier.vala"
				return result;
#line 1744 "Bezier.c"
			} else {
				gdouble min = 0.0;
				gdouble _tmp17_;
				gdouble* _tmp18_;
#line 224 "../src/Bezier.vala"
				min = (gdouble) 0;
#line 1751 "Bezier.c"
				{
					gint i = 0;
#line 225 "../src/Bezier.vala"
					i = 0;
#line 1756 "Bezier.c"
					{
						gboolean _tmp12_ = FALSE;
#line 225 "../src/Bezier.vala"
						_tmp12_ = TRUE;
#line 225 "../src/Bezier.vala"
						while (TRUE) {
#line 1763 "Bezier.c"
							GArray* _tmp14_;
							GArray* _tmp15_;
#line 225 "../src/Bezier.vala"
							if (!_tmp12_) {
#line 1768 "Bezier.c"
								gint _tmp13_;
#line 225 "../src/Bezier.vala"
								_tmp13_ = i;
#line 225 "../src/Bezier.vala"
								i = _tmp13_ + 1;
#line 1774 "Bezier.c"
							}
#line 225 "../src/Bezier.vala"
							_tmp12_ = FALSE;
#line 225 "../src/Bezier.vala"
							_tmp14_ = roots;
#line 225 "../src/Bezier.vala"
							if (!(((guint) i) < _tmp14_->len)) {
#line 225 "../src/Bezier.vala"
								break;
#line 1784 "Bezier.c"
							}
#line 226 "../src/Bezier.vala"
							_tmp15_ = roots;
#line 226 "../src/Bezier.vala"
							if ((*g_array_index (_tmp15_, gdouble*, (guint) i)) > min) {
#line 1790 "Bezier.c"
								GArray* _tmp16_;
#line 227 "../src/Bezier.vala"
								_tmp16_ = roots;
#line 227 "../src/Bezier.vala"
								min = *g_array_index (_tmp16_, gdouble*, (guint) i);
#line 1796 "Bezier.c"
							}
						}
					}
				}
#line 230 "../src/Bezier.vala"
				_tmp17_ = bezier_get_axis (self, min, axis_is_x);
#line 230 "../src/Bezier.vala"
				_tmp18_ = __double_dup0 (&_tmp17_);
#line 230 "../src/Bezier.vala"
				result = _tmp18_;
#line 230 "../src/Bezier.vala"
				_g_array_unref0 (roots);
#line 230 "../src/Bezier.vala"
				return result;
#line 1811 "Bezier.c"
			}
		}
	}
}

void
bezier_set_connect_point (Bezier* self,
                          gboolean from,
                          gdouble top,
                          gdouble bottom,
                          gdouble left,
                          gdouble right)
{
	gdouble* isect = NULL;
	gdouble* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gdouble* _tmp3_;
	gdouble* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gdouble* _tmp13_;
	gdouble* _tmp20_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gdouble* _tmp23_;
	gdouble* _tmp30_;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gdouble* _tmp33_;
#line 237 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/Bezier.vala"
	_tmp0_ = bezier_get_intersecting_point (self, top, FALSE, from);
#line 242 "../src/Bezier.vala"
	_g_free0 (isect);
#line 242 "../src/Bezier.vala"
	isect = _tmp0_;
#line 243 "../src/Bezier.vala"
	_tmp3_ = isect;
#line 243 "../src/Bezier.vala"
	if (_tmp3_ != NULL) {
#line 1854 "Bezier.c"
		gdouble* _tmp4_;
#line 243 "../src/Bezier.vala"
		_tmp4_ = isect;
#line 243 "../src/Bezier.vala"
		_tmp2_ = left <= (*_tmp4_);
#line 1860 "Bezier.c"
	} else {
#line 243 "../src/Bezier.vala"
		_tmp2_ = FALSE;
#line 1864 "Bezier.c"
	}
#line 243 "../src/Bezier.vala"
	if (_tmp2_) {
#line 1868 "Bezier.c"
		gdouble* _tmp5_;
#line 243 "../src/Bezier.vala"
		_tmp5_ = isect;
#line 243 "../src/Bezier.vala"
		_tmp1_ = (*_tmp5_) <= right;
#line 1874 "Bezier.c"
	} else {
#line 243 "../src/Bezier.vala"
		_tmp1_ = FALSE;
#line 1878 "Bezier.c"
	}
#line 243 "../src/Bezier.vala"
	if (_tmp1_) {
#line 244 "../src/Bezier.vala"
		if (from) {
#line 1884 "Bezier.c"
			BezierPoint* _tmp6_;
			gdouble* _tmp7_;
#line 244 "../src/Bezier.vala"
			_tmp6_ = self->priv->_from;
#line 244 "../src/Bezier.vala"
			_tmp7_ = isect;
#line 244 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp6_, *_tmp7_, top);
#line 1893 "Bezier.c"
		} else {
			BezierPoint* _tmp8_;
			gdouble* _tmp9_;
#line 244 "../src/Bezier.vala"
			_tmp8_ = self->priv->_to;
#line 244 "../src/Bezier.vala"
			_tmp9_ = isect;
#line 244 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp8_, *_tmp9_, top);
#line 1903 "Bezier.c"
		}
#line 245 "../src/Bezier.vala"
		_g_free0 (isect);
#line 245 "../src/Bezier.vala"
		return;
#line 1909 "Bezier.c"
	}
#line 249 "../src/Bezier.vala"
	_tmp10_ = bezier_get_intersecting_point (self, bottom, FALSE, from);
#line 249 "../src/Bezier.vala"
	_g_free0 (isect);
#line 249 "../src/Bezier.vala"
	isect = _tmp10_;
#line 250 "../src/Bezier.vala"
	_tmp13_ = isect;
#line 250 "../src/Bezier.vala"
	if (_tmp13_ != NULL) {
#line 1921 "Bezier.c"
		gdouble* _tmp14_;
#line 250 "../src/Bezier.vala"
		_tmp14_ = isect;
#line 250 "../src/Bezier.vala"
		_tmp12_ = left <= (*_tmp14_);
#line 1927 "Bezier.c"
	} else {
#line 250 "../src/Bezier.vala"
		_tmp12_ = FALSE;
#line 1931 "Bezier.c"
	}
#line 250 "../src/Bezier.vala"
	if (_tmp12_) {
#line 1935 "Bezier.c"
		gdouble* _tmp15_;
#line 250 "../src/Bezier.vala"
		_tmp15_ = isect;
#line 250 "../src/Bezier.vala"
		_tmp11_ = (*_tmp15_) <= right;
#line 1941 "Bezier.c"
	} else {
#line 250 "../src/Bezier.vala"
		_tmp11_ = FALSE;
#line 1945 "Bezier.c"
	}
#line 250 "../src/Bezier.vala"
	if (_tmp11_) {
#line 251 "../src/Bezier.vala"
		if (from) {
#line 1951 "Bezier.c"
			BezierPoint* _tmp16_;
			gdouble* _tmp17_;
#line 251 "../src/Bezier.vala"
			_tmp16_ = self->priv->_from;
#line 251 "../src/Bezier.vala"
			_tmp17_ = isect;
#line 251 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp16_, *_tmp17_, bottom);
#line 1960 "Bezier.c"
		} else {
			BezierPoint* _tmp18_;
			gdouble* _tmp19_;
#line 251 "../src/Bezier.vala"
			_tmp18_ = self->priv->_to;
#line 251 "../src/Bezier.vala"
			_tmp19_ = isect;
#line 251 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp18_, *_tmp19_, bottom);
#line 1970 "Bezier.c"
		}
#line 252 "../src/Bezier.vala"
		_g_free0 (isect);
#line 252 "../src/Bezier.vala"
		return;
#line 1976 "Bezier.c"
	}
#line 256 "../src/Bezier.vala"
	_tmp20_ = bezier_get_intersecting_point (self, left, TRUE, from);
#line 256 "../src/Bezier.vala"
	_g_free0 (isect);
#line 256 "../src/Bezier.vala"
	isect = _tmp20_;
#line 257 "../src/Bezier.vala"
	_tmp23_ = isect;
#line 257 "../src/Bezier.vala"
	if (_tmp23_ != NULL) {
#line 1988 "Bezier.c"
		gdouble* _tmp24_;
#line 257 "../src/Bezier.vala"
		_tmp24_ = isect;
#line 257 "../src/Bezier.vala"
		_tmp22_ = top <= (*_tmp24_);
#line 1994 "Bezier.c"
	} else {
#line 257 "../src/Bezier.vala"
		_tmp22_ = FALSE;
#line 1998 "Bezier.c"
	}
#line 257 "../src/Bezier.vala"
	if (_tmp22_) {
#line 2002 "Bezier.c"
		gdouble* _tmp25_;
#line 257 "../src/Bezier.vala"
		_tmp25_ = isect;
#line 257 "../src/Bezier.vala"
		_tmp21_ = (*_tmp25_) <= bottom;
#line 2008 "Bezier.c"
	} else {
#line 257 "../src/Bezier.vala"
		_tmp21_ = FALSE;
#line 2012 "Bezier.c"
	}
#line 257 "../src/Bezier.vala"
	if (_tmp21_) {
#line 258 "../src/Bezier.vala"
		if (from) {
#line 2018 "Bezier.c"
			BezierPoint* _tmp26_;
			gdouble* _tmp27_;
#line 258 "../src/Bezier.vala"
			_tmp26_ = self->priv->_from;
#line 258 "../src/Bezier.vala"
			_tmp27_ = isect;
#line 258 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp26_, left, *_tmp27_);
#line 2027 "Bezier.c"
		} else {
			BezierPoint* _tmp28_;
			gdouble* _tmp29_;
#line 258 "../src/Bezier.vala"
			_tmp28_ = self->priv->_to;
#line 258 "../src/Bezier.vala"
			_tmp29_ = isect;
#line 258 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp28_, left, *_tmp29_);
#line 2037 "Bezier.c"
		}
#line 259 "../src/Bezier.vala"
		_g_free0 (isect);
#line 259 "../src/Bezier.vala"
		return;
#line 2043 "Bezier.c"
	}
#line 263 "../src/Bezier.vala"
	_tmp30_ = bezier_get_intersecting_point (self, right, TRUE, from);
#line 263 "../src/Bezier.vala"
	_g_free0 (isect);
#line 263 "../src/Bezier.vala"
	isect = _tmp30_;
#line 264 "../src/Bezier.vala"
	_tmp33_ = isect;
#line 264 "../src/Bezier.vala"
	if (_tmp33_ != NULL) {
#line 2055 "Bezier.c"
		gdouble* _tmp34_;
#line 264 "../src/Bezier.vala"
		_tmp34_ = isect;
#line 264 "../src/Bezier.vala"
		_tmp32_ = top <= (*_tmp34_);
#line 2061 "Bezier.c"
	} else {
#line 264 "../src/Bezier.vala"
		_tmp32_ = FALSE;
#line 2065 "Bezier.c"
	}
#line 264 "../src/Bezier.vala"
	if (_tmp32_) {
#line 2069 "Bezier.c"
		gdouble* _tmp35_;
#line 264 "../src/Bezier.vala"
		_tmp35_ = isect;
#line 264 "../src/Bezier.vala"
		_tmp31_ = (*_tmp35_) <= bottom;
#line 2075 "Bezier.c"
	} else {
#line 264 "../src/Bezier.vala"
		_tmp31_ = FALSE;
#line 2079 "Bezier.c"
	}
#line 264 "../src/Bezier.vala"
	if (_tmp31_) {
#line 265 "../src/Bezier.vala"
		if (from) {
#line 2085 "Bezier.c"
			BezierPoint* _tmp36_;
			gdouble* _tmp37_;
#line 265 "../src/Bezier.vala"
			_tmp36_ = self->priv->_from;
#line 265 "../src/Bezier.vala"
			_tmp37_ = isect;
#line 265 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp36_, right, *_tmp37_);
#line 2094 "Bezier.c"
		} else {
			BezierPoint* _tmp38_;
			gdouble* _tmp39_;
#line 265 "../src/Bezier.vala"
			_tmp38_ = self->priv->_to;
#line 265 "../src/Bezier.vala"
			_tmp39_ = isect;
#line 265 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp38_, right, *_tmp39_);
#line 2104 "Bezier.c"
		}
#line 266 "../src/Bezier.vala"
		_g_free0 (isect);
#line 266 "../src/Bezier.vala"
		return;
#line 2110 "Bezier.c"
	}
#line 269 "../src/Bezier.vala"
	if (from) {
#line 2114 "Bezier.c"
		BezierPoint* _tmp40_;
		GArray* _tmp41_;
		BezierPoint* _tmp42_;
		gdouble _tmp43_;
		gdouble _tmp44_;
		GArray* _tmp45_;
		BezierPoint* _tmp46_;
		gdouble _tmp47_;
		gdouble _tmp48_;
#line 270 "../src/Bezier.vala"
		_tmp40_ = self->priv->_from;
#line 270 "../src/Bezier.vala"
		_tmp41_ = self->priv->_points;
#line 270 "../src/Bezier.vala"
		_tmp42_ = g_array_index (_tmp41_, BezierPoint*, (guint) 0);
#line 270 "../src/Bezier.vala"
		_tmp43_ = bezier_point_get_x (_tmp42_);
#line 270 "../src/Bezier.vala"
		_tmp44_ = _tmp43_;
#line 270 "../src/Bezier.vala"
		_tmp45_ = self->priv->_points;
#line 270 "../src/Bezier.vala"
		_tmp46_ = g_array_index (_tmp45_, BezierPoint*, (guint) 0);
#line 270 "../src/Bezier.vala"
		_tmp47_ = bezier_point_get_y (_tmp46_);
#line 270 "../src/Bezier.vala"
		_tmp48_ = _tmp47_;
#line 270 "../src/Bezier.vala"
		bezier_point_set_coordinate (_tmp40_, _tmp44_, _tmp48_);
#line 2144 "Bezier.c"
	} else {
		BezierPoint* _tmp49_;
		GArray* _tmp50_;
		BezierPoint* _tmp51_;
		gdouble _tmp52_;
		gdouble _tmp53_;
		GArray* _tmp54_;
		BezierPoint* _tmp55_;
		gdouble _tmp56_;
		gdouble _tmp57_;
#line 272 "../src/Bezier.vala"
		_tmp49_ = self->priv->_to;
#line 272 "../src/Bezier.vala"
		_tmp50_ = self->priv->_points;
#line 272 "../src/Bezier.vala"
		_tmp51_ = g_array_index (_tmp50_, BezierPoint*, (guint) 2);
#line 272 "../src/Bezier.vala"
		_tmp52_ = bezier_point_get_x (_tmp51_);
#line 272 "../src/Bezier.vala"
		_tmp53_ = _tmp52_;
#line 272 "../src/Bezier.vala"
		_tmp54_ = self->priv->_points;
#line 272 "../src/Bezier.vala"
		_tmp55_ = g_array_index (_tmp54_, BezierPoint*, (guint) 2);
#line 272 "../src/Bezier.vala"
		_tmp56_ = bezier_point_get_y (_tmp55_);
#line 272 "../src/Bezier.vala"
		_tmp57_ = _tmp56_;
#line 272 "../src/Bezier.vala"
		bezier_point_set_coordinate (_tmp49_, _tmp53_, _tmp57_);
#line 2175 "Bezier.c"
	}
#line 237 "../src/Bezier.vala"
	_g_free0 (isect);
#line 2179 "Bezier.c"
}

static inline gpointer
bezier_point_get_instance_private (BezierPoint* self)
{
	return G_STRUCT_MEMBER_P (self, BezierPoint_private_offset);
}

static BezierPoint*
bezier_point_construct (GType object_type)
{
	BezierPoint* self = NULL;
#line 29 "../src/Bezier.vala"
	self = (BezierPoint*) g_type_create_instance (object_type);
#line 29 "../src/Bezier.vala"
	return self;
#line 2196 "Bezier.c"
}

static BezierPoint*
bezier_point_new (void)
{
#line 29 "../src/Bezier.vala"
	return bezier_point_construct (BEZIER_TYPE_POINT);
#line 2204 "Bezier.c"
}

static BezierPoint*
bezier_point_construct_with_coordinate (GType object_type,
                                        gdouble a,
                                        gdouble b)
{
	BezierPoint* self = NULL;
#line 30 "../src/Bezier.vala"
	self = (BezierPoint*) g_type_create_instance (object_type);
#line 31 "../src/Bezier.vala"
	bezier_point_set_x (self, a);
#line 32 "../src/Bezier.vala"
	bezier_point_set_y (self, b);
#line 30 "../src/Bezier.vala"
	return self;
#line 2221 "Bezier.c"
}

static BezierPoint*
bezier_point_new_with_coordinate (gdouble a,
                                  gdouble b)
{
#line 30 "../src/Bezier.vala"
	return bezier_point_construct_with_coordinate (BEZIER_TYPE_POINT, a, b);
#line 2230 "Bezier.c"
}

static void
bezier_point_set_coordinate (BezierPoint* self,
                             gdouble a,
                             gdouble b)
{
#line 34 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Bezier.vala"
	bezier_point_set_x (self, a);
#line 36 "../src/Bezier.vala"
	bezier_point_set_y (self, b);
#line 2244 "Bezier.c"
}

static gdouble
bezier_point_get_x (BezierPoint* self)
{
	gdouble result;
#line 27 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 27 "../src/Bezier.vala"
	result = self->priv->_x;
#line 27 "../src/Bezier.vala"
	return result;
#line 2257 "Bezier.c"
}

static void
bezier_point_set_x (BezierPoint* self,
                    gdouble value)
{
#line 27 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Bezier.vala"
	self->priv->_x = value;
#line 2268 "Bezier.c"
}

static gdouble
bezier_point_get_y (BezierPoint* self)
{
	gdouble result;
#line 28 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 28 "../src/Bezier.vala"
	result = self->priv->_y;
#line 28 "../src/Bezier.vala"
	return result;
#line 2281 "Bezier.c"
}

static void
bezier_point_set_y (BezierPoint* self,
                    gdouble value)
{
#line 28 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Bezier.vala"
	self->priv->_y = value;
#line 2292 "Bezier.c"
}

static void
bezier_value_point_init (GValue* value)
{
#line 26 "../src/Bezier.vala"
	value->data[0].v_pointer = NULL;
#line 2300 "Bezier.c"
}

static void
bezier_value_point_free_value (GValue* value)
{
#line 26 "../src/Bezier.vala"
	if (value->data[0].v_pointer) {
#line 26 "../src/Bezier.vala"
		bezier_point_unref (value->data[0].v_pointer);
#line 2310 "Bezier.c"
	}
}

static void
bezier_value_point_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 26 "../src/Bezier.vala"
	if (src_value->data[0].v_pointer) {
#line 26 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = bezier_point_ref (src_value->data[0].v_pointer);
#line 2322 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2326 "Bezier.c"
	}
}

static gpointer
bezier_value_point_peek_pointer (const GValue* value)
{
#line 26 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2335 "Bezier.c"
}

static gchar*
bezier_value_point_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 26 "../src/Bezier.vala"
	if (collect_values[0].v_pointer) {
#line 2346 "Bezier.c"
		BezierPoint * object;
		object = collect_values[0].v_pointer;
#line 26 "../src/Bezier.vala"
		if (object->parent_instance.g_class == NULL) {
#line 26 "../src/Bezier.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2353 "Bezier.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 26 "../src/Bezier.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2357 "Bezier.c"
		}
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = bezier_point_ref (object);
#line 2361 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2365 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	return NULL;
#line 2369 "Bezier.c"
}

static gchar*
bezier_value_point_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	BezierPoint ** object_p;
	object_p = collect_values[0].v_pointer;
#line 26 "../src/Bezier.vala"
	if (!object_p) {
#line 26 "../src/Bezier.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2384 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	if (!value->data[0].v_pointer) {
#line 26 "../src/Bezier.vala"
		*object_p = NULL;
#line 2390 "Bezier.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 26 "../src/Bezier.vala"
		*object_p = value->data[0].v_pointer;
#line 2394 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		*object_p = bezier_point_ref (value->data[0].v_pointer);
#line 2398 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	return NULL;
#line 2402 "Bezier.c"
}

static GParamSpec*
bezier_param_spec_point (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	BezierParamSpecPoint* spec;
#line 26 "../src/Bezier.vala"
	g_return_val_if_fail (g_type_is_a (object_type, BEZIER_TYPE_POINT), NULL);
#line 26 "../src/Bezier.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 26 "../src/Bezier.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 26 "../src/Bezier.vala"
	return G_PARAM_SPEC (spec);
#line 2421 "Bezier.c"
}

static gpointer
bezier_value_get_point (const GValue* value)
{
#line 26 "../src/Bezier.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BEZIER_TYPE_POINT), NULL);
#line 26 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2431 "Bezier.c"
}

static void
bezier_value_set_point (GValue* value,
                        gpointer v_object)
{
	BezierPoint * old;
#line 26 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/Bezier.vala"
	if (v_object) {
#line 26 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 26 "../src/Bezier.vala"
		bezier_point_ref (value->data[0].v_pointer);
#line 2453 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2457 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	if (old) {
#line 26 "../src/Bezier.vala"
		bezier_point_unref (old);
#line 2463 "Bezier.c"
	}
}

static void
bezier_value_take_point (GValue* value,
                         gpointer v_object)
{
	BezierPoint * old;
#line 26 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/Bezier.vala"
	if (v_object) {
#line 26 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 2484 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2488 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	if (old) {
#line 26 "../src/Bezier.vala"
		bezier_point_unref (old);
#line 2494 "Bezier.c"
	}
}

static void
bezier_point_class_init (BezierPointClass * klass,
                         gpointer klass_data)
{
#line 26 "../src/Bezier.vala"
	bezier_point_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Bezier.vala"
	((BezierPointClass *) klass)->finalize = bezier_point_finalize;
#line 26 "../src/Bezier.vala"
	g_type_class_adjust_private_offset (klass, &BezierPoint_private_offset);
#line 2508 "Bezier.c"
}

static void
bezier_point_instance_init (BezierPoint * self,
                            gpointer klass)
{
#line 26 "../src/Bezier.vala"
	self->priv = bezier_point_get_instance_private (self);
#line 27 "../src/Bezier.vala"
	self->priv->_x = (gdouble) 0;
#line 28 "../src/Bezier.vala"
	self->priv->_y = (gdouble) 0;
#line 26 "../src/Bezier.vala"
	self->ref_count = 1;
#line 2523 "Bezier.c"
}

static void
bezier_point_finalize (BezierPoint * obj)
{
	BezierPoint * self;
#line 26 "../src/Bezier.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BEZIER_TYPE_POINT, BezierPoint);
#line 26 "../src/Bezier.vala"
	g_signal_handlers_destroy (self);
#line 2534 "Bezier.c"
}

static GType
bezier_point_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { bezier_value_point_init, bezier_value_point_free_value, bezier_value_point_copy_value, bezier_value_point_peek_pointer, "p", bezier_value_point_collect_value, "p", bezier_value_point_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BezierPointClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bezier_point_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BezierPoint), 0, (GInstanceInitFunc) bezier_point_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType bezier_point_type_id;
	bezier_point_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BezierPoint", &g_define_type_info, &g_define_type_fundamental_info, 0);
	BezierPoint_private_offset = g_type_add_instance_private (bezier_point_type_id, sizeof (BezierPointPrivate));
	return bezier_point_type_id;
}

static GType
bezier_point_get_type (void)
{
	static volatile gsize bezier_point_type_id__once = 0;
	if (g_once_init_enter (&bezier_point_type_id__once)) {
		GType bezier_point_type_id;
		bezier_point_type_id = bezier_point_get_type_once ();
		g_once_init_leave (&bezier_point_type_id__once, bezier_point_type_id);
	}
	return bezier_point_type_id__once;
}

static gpointer
bezier_point_ref (gpointer instance)
{
	BezierPoint * self;
	self = instance;
#line 26 "../src/Bezier.vala"
	g_atomic_int_inc (&self->ref_count);
#line 26 "../src/Bezier.vala"
	return instance;
#line 2570 "Bezier.c"
}

static void
bezier_point_unref (gpointer instance)
{
	BezierPoint * self;
	self = instance;
#line 26 "../src/Bezier.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 26 "../src/Bezier.vala"
		BEZIER_POINT_GET_CLASS (self)->finalize (self);
#line 26 "../src/Bezier.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2584 "Bezier.c"
	}
}

static void
value_bezier_init (GValue* value)
{
#line 24 "../src/Bezier.vala"
	value->data[0].v_pointer = NULL;
#line 2593 "Bezier.c"
}

static void
value_bezier_free_value (GValue* value)
{
#line 24 "../src/Bezier.vala"
	if (value->data[0].v_pointer) {
#line 24 "../src/Bezier.vala"
		bezier_unref (value->data[0].v_pointer);
#line 2603 "Bezier.c"
	}
}

static void
value_bezier_copy_value (const GValue* src_value,
                         GValue* dest_value)
{
#line 24 "../src/Bezier.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = bezier_ref (src_value->data[0].v_pointer);
#line 2615 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2619 "Bezier.c"
	}
}

static gpointer
value_bezier_peek_pointer (const GValue* value)
{
#line 24 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2628 "Bezier.c"
}

static gchar*
value_bezier_collect_value (GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
#line 24 "../src/Bezier.vala"
	if (collect_values[0].v_pointer) {
#line 2639 "Bezier.c"
		Bezier * object;
		object = collect_values[0].v_pointer;
#line 24 "../src/Bezier.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "../src/Bezier.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2646 "Bezier.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "../src/Bezier.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2650 "Bezier.c"
		}
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = bezier_ref (object);
#line 2654 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2658 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	return NULL;
#line 2662 "Bezier.c"
}

static gchar*
value_bezier_lcopy_value (const GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
	Bezier ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "../src/Bezier.vala"
	if (!object_p) {
#line 24 "../src/Bezier.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2677 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	if (!value->data[0].v_pointer) {
#line 24 "../src/Bezier.vala"
		*object_p = NULL;
#line 2683 "Bezier.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "../src/Bezier.vala"
		*object_p = value->data[0].v_pointer;
#line 2687 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		*object_p = bezier_ref (value->data[0].v_pointer);
#line 2691 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	return NULL;
#line 2695 "Bezier.c"
}

GParamSpec*
param_spec_bezier (const gchar* name,
                   const gchar* nick,
                   const gchar* blurb,
                   GType object_type,
                   GParamFlags flags)
{
	ParamSpecBezier* spec;
#line 24 "../src/Bezier.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BEZIER), NULL);
#line 24 "../src/Bezier.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "../src/Bezier.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "../src/Bezier.vala"
	return G_PARAM_SPEC (spec);
#line 2714 "Bezier.c"
}

gpointer
value_get_bezier (const GValue* value)
{
#line 24 "../src/Bezier.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BEZIER), NULL);
#line 24 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2724 "Bezier.c"
}

void
value_set_bezier (GValue* value,
                  gpointer v_object)
{
	Bezier * old;
#line 24 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/Bezier.vala"
	if (v_object) {
#line 24 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 24 "../src/Bezier.vala"
		bezier_ref (value->data[0].v_pointer);
#line 2746 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2750 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	if (old) {
#line 24 "../src/Bezier.vala"
		bezier_unref (old);
#line 2756 "Bezier.c"
	}
}

void
value_take_bezier (GValue* value,
                   gpointer v_object)
{
	Bezier * old;
#line 24 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/Bezier.vala"
	if (v_object) {
#line 24 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 2777 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2781 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	if (old) {
#line 24 "../src/Bezier.vala"
		bezier_unref (old);
#line 2787 "Bezier.c"
	}
}

static void
bezier_class_init (BezierClass * klass,
                   gpointer klass_data)
{
#line 24 "../src/Bezier.vala"
	bezier_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Bezier.vala"
	((BezierClass *) klass)->finalize = bezier_finalize;
#line 24 "../src/Bezier.vala"
	g_type_class_adjust_private_offset (klass, &Bezier_private_offset);
#line 2801 "Bezier.c"
}

static void
bezier_instance_init (Bezier * self,
                      gpointer klass)
{
	GArray* _tmp0_;
	GArray* _tmp1_;
	BezierPoint* _tmp2_;
	BezierPoint* _tmp3_;
#line 24 "../src/Bezier.vala"
	self->priv = bezier_get_instance_private (self);
#line 40 "../src/Bezier.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (BezierPoint*));
#line 40 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_BezierPoint_free_function_content_of);
#line 40 "../src/Bezier.vala"
	self->priv->_points = _tmp0_;
#line 41 "../src/Bezier.vala"
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (BezierPoint*));
#line 41 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_BezierPoint_free_function_content_of);
#line 41 "../src/Bezier.vala"
	self->priv->_apoints = _tmp1_;
#line 42 "../src/Bezier.vala"
	_tmp2_ = bezier_point_new ();
#line 42 "../src/Bezier.vala"
	self->priv->_from = _tmp2_;
#line 43 "../src/Bezier.vala"
	_tmp3_ = bezier_point_new ();
#line 43 "../src/Bezier.vala"
	self->priv->_to = _tmp3_;
#line 24 "../src/Bezier.vala"
	self->ref_count = 1;
#line 2836 "Bezier.c"
}

static void
bezier_finalize (Bezier * obj)
{
	Bezier * self;
#line 24 "../src/Bezier.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BEZIER, Bezier);
#line 24 "../src/Bezier.vala"
	g_signal_handlers_destroy (self);
#line 40 "../src/Bezier.vala"
	_g_array_unref0 (self->priv->_points);
#line 41 "../src/Bezier.vala"
	_g_array_unref0 (self->priv->_apoints);
#line 42 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_from);
#line 43 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_to);
#line 2855 "Bezier.c"
}

static GType
bezier_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_bezier_init, value_bezier_free_value, value_bezier_copy_value, value_bezier_peek_pointer, "p", value_bezier_collect_value, "p", value_bezier_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BezierClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bezier_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bezier), 0, (GInstanceInitFunc) bezier_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType bezier_type_id;
	bezier_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Bezier", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Bezier_private_offset = g_type_add_instance_private (bezier_type_id, sizeof (BezierPrivate));
	return bezier_type_id;
}

GType
bezier_get_type (void)
{
	static volatile gsize bezier_type_id__once = 0;
	if (g_once_init_enter (&bezier_type_id__once)) {
		GType bezier_type_id;
		bezier_type_id = bezier_get_type_once ();
		g_once_init_leave (&bezier_type_id__once, bezier_type_id);
	}
	return bezier_type_id__once;
}

gpointer
bezier_ref (gpointer instance)
{
	Bezier * self;
	self = instance;
#line 24 "../src/Bezier.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "../src/Bezier.vala"
	return instance;
#line 2891 "Bezier.c"
}

void
bezier_unref (gpointer instance)
{
	Bezier * self;
	self = instance;
#line 24 "../src/Bezier.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "../src/Bezier.vala"
		BEZIER_GET_CLASS (self)->finalize (self);
#line 24 "../src/Bezier.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2905 "Bezier.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

