/* Document.c generated by valac 0.56.3, the Vala compiler
 * generated from Document.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <handy.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DOCUMENT (document_get_type ())
#define DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT, Document))
#define DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT, DocumentClass))
#define IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT))
#define IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT))
#define DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT, DocumentClass))

typedef struct _Document Document;
typedef struct _DocumentClass DocumentClass;
typedef struct _DocumentPrivate DocumentPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_IMAGE_MANAGER (image_manager_get_type ())
#define IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_MANAGER, ImageManager))
#define IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_MANAGER, ImageManagerClass))
#define IS_IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_MANAGER))
#define IS_IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_MANAGER))
#define IMAGE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_MANAGER, ImageManagerClass))

typedef struct _ImageManager ImageManager;
typedef struct _ImageManagerClass ImageManagerClass;
enum  {
	DOCUMENT_0_PROPERTY,
	DOCUMENT_FILENAME_PROPERTY,
	DOCUMENT_LABEL_PROPERTY,
	DOCUMENT_SAVE_NEEDED_PROPERTY,
	DOCUMENT_NUM_PROPERTIES
};
static GParamSpec* document_properties[DOCUMENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _image_manager_unref0(var) ((var == NULL) ? NULL : (var = (image_manager_unref (var), NULL)))
#define _xmlFreeDoc0(var) ((var == NULL) ? NULL : (var = (xmlFreeDoc (var), NULL)))

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _Document {
	GObject parent_instance;
	DocumentPrivate * priv;
};

struct _DocumentClass {
	GObjectClass parent_class;
};

struct _DocumentPrivate {
	DrawArea* _da;
	gchar* _filename;
	gboolean _from_user;
	ImageManager* _image_manager;
	gchar* _etag;
	gboolean _save_needed;
};

static gint Document_private_offset;
static gpointer document_parent_class = NULL;
VALA_EXTERN gchar* minder_version;

VALA_EXTERN GType document_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Document, g_object_unref)
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN gpointer image_manager_ref (gpointer instance);
VALA_EXTERN void image_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_image_manager (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_image_manager (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_image_manager (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_image_manager (const GValue* value);
VALA_EXTERN GType image_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ImageManager, image_manager_unref)
VALA_EXTERN Document* document_new (DrawArea* da);
VALA_EXTERN Document* document_construct (GType object_type,
                              DrawArea* da);
static gchar* document_generate_etag (Document* self);
VALA_EXTERN ImageManager* image_manager_new (void);
VALA_EXTERN ImageManager* image_manager_construct (GType object_type);
static void document_canvas_changed (Document* self);
static void _document_canvas_changed_draw_area_changed (DrawArea* _sender,
                                                 gpointer self);
static void document_set_save_needed (Document* self,
                               gboolean value);
VALA_EXTERN void document_auto_save (Document* self);
VALA_EXTERN void document_load_filename (Document* self,
                             const gchar* fname,
                             gboolean saved);
VALA_EXTERN void document_set_filename (Document* self,
                            const gchar* value);
VALA_EXTERN gboolean document_is_saved (Document* self);
VALA_EXTERN gboolean document_xml_find (const gchar* fname,
                            gint id,
                            gchar** name);
VALA_EXTERN gboolean draw_area_xml_find (xmlNode* n,
                             gint id,
                             gchar** name);
static xmlDoc* document_load_raw (Document* self);
VALA_EXTERN const gchar* document_get_filename (Document* self);
static gchar* document_get_etag (Document* self,
                          xmlDoc* doc);
VALA_EXTERN gboolean document_load (Document* self);
VALA_EXTERN void draw_area_load (DrawArea* self,
                     xmlNode* n);
VALA_EXTERN gboolean document_save (Document* self);
VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN MainWindow* draw_area_get_win (DrawArea* self);
VALA_EXTERN gboolean main_window_ask_modified_overwrite (MainWindow* self,
                                             DrawArea* da);
static gboolean document_save_internal (Document* self,
                                 const gchar* dest_filename,
                                 gboolean bump_etag);
VALA_EXTERN gboolean draw_area_save (DrawArea* self,
                         xmlNode* parent);
VALA_EXTERN gboolean document_remove (Document* self);
VALA_EXTERN gboolean document_get_save_needed (Document* self);
VALA_EXTERN gchar* document_get_label (Document* self);
static void document_finalize (GObject * obj);
static GType document_get_type_once (void);
static void _vala_document_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_document_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
document_get_instance_private (Document* self)
{
	return G_STRUCT_MEMBER_P (self, Document_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "../src/Document.vala"
	return self ? g_object_ref (self) : NULL;
#line 211 "Document.c"
}

static void
_document_canvas_changed_draw_area_changed (DrawArea* _sender,
                                            gpointer self)
{
#line 78 "../src/Document.vala"
	document_canvas_changed ((Document*) self);
#line 220 "Document.c"
}

Document*
document_construct (GType object_type,
                    DrawArea* da)
{
	Document * self = NULL;
	DrawArea* _tmp0_;
	gchar* _tmp1_;
	gchar* dir = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	ImageManager* _tmp14_;
	DrawArea* _tmp15_;
#line 57 "../src/Document.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 57 "../src/Document.vala"
	self = (Document*) g_object_new (object_type, NULL);
#line 59 "../src/Document.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 59 "../src/Document.vala"
	_g_object_unref0 (self->priv->_da);
#line 59 "../src/Document.vala"
	self->priv->_da = _tmp0_;
#line 62 "../src/Document.vala"
	_tmp1_ = document_generate_etag (self);
#line 62 "../src/Document.vala"
	_g_free0 (self->priv->_etag);
#line 62 "../src/Document.vala"
	self->priv->_etag = _tmp1_;
#line 65 "../src/Document.vala"
	_tmp2_ = g_get_user_data_dir ();
#line 65 "../src/Document.vala"
	_tmp3_ = g_build_filename (_tmp2_, "minder", NULL);
#line 65 "../src/Document.vala"
	dir = _tmp3_;
#line 66 "../src/Document.vala"
	_tmp4_ = dir;
#line 66 "../src/Document.vala"
	if (g_mkdir_with_parents (_tmp4_, 0775) == 0) {
#line 262 "Document.c"
		gint i = 0;
#line 67 "../src/Document.vala"
		i = 1;
#line 266 "Document.c"
		{
			gboolean _tmp5_ = FALSE;
#line 68 "../src/Document.vala"
			_tmp5_ = TRUE;
#line 68 "../src/Document.vala"
			while (TRUE) {
#line 273 "Document.c"
				const gchar* _tmp7_;
				gint _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
#line 68 "../src/Document.vala"
				if (!_tmp5_) {
#line 283 "Document.c"
					const gchar* _tmp6_;
#line 70 "../src/Document.vala"
					_tmp6_ = self->priv->_filename;
#line 70 "../src/Document.vala"
					if (!g_file_test (_tmp6_, G_FILE_TEST_EXISTS)) {
#line 70 "../src/Document.vala"
						break;
#line 291 "Document.c"
					}
				}
#line 68 "../src/Document.vala"
				_tmp5_ = FALSE;
#line 69 "../src/Document.vala"
				_tmp7_ = dir;
#line 69 "../src/Document.vala"
				_tmp8_ = i;
#line 69 "../src/Document.vala"
				i = _tmp8_ + 1;
#line 69 "../src/Document.vala"
				_tmp9_ = g_strdup_printf ("%d.minder", _tmp8_);
#line 69 "../src/Document.vala"
				_tmp10_ = _tmp9_;
#line 69 "../src/Document.vala"
				_tmp11_ = g_strconcat (_ ("unnamed"), _tmp10_, NULL);
#line 69 "../src/Document.vala"
				_tmp12_ = _tmp11_;
#line 69 "../src/Document.vala"
				_tmp13_ = g_build_filename (_tmp7_, _tmp12_, NULL);
#line 69 "../src/Document.vala"
				_g_free0 (self->priv->_filename);
#line 69 "../src/Document.vala"
				self->priv->_filename = _tmp13_;
#line 69 "../src/Document.vala"
				_g_free0 (_tmp12_);
#line 69 "../src/Document.vala"
				_g_free0 (_tmp10_);
#line 320 "Document.c"
			}
		}
#line 71 "../src/Document.vala"
		self->priv->_from_user = FALSE;
#line 325 "Document.c"
	}
#line 75 "../src/Document.vala"
	_tmp14_ = image_manager_new ();
#line 75 "../src/Document.vala"
	_image_manager_unref0 (self->priv->_image_manager);
#line 75 "../src/Document.vala"
	self->priv->_image_manager = _tmp14_;
#line 78 "../src/Document.vala"
	_tmp15_ = self->priv->_da;
#line 78 "../src/Document.vala"
	g_signal_connect_object (_tmp15_, "changed", (GCallback) _document_canvas_changed_draw_area_changed, self, 0);
#line 57 "../src/Document.vala"
	_g_free0 (dir);
#line 57 "../src/Document.vala"
	return self;
#line 341 "Document.c"
}

Document*
document_new (DrawArea* da)
{
#line 57 "../src/Document.vala"
	return document_construct (TYPE_DOCUMENT, da);
#line 349 "Document.c"
}

static gchar*
document_generate_etag (Document* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 83 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../src/Document.vala"
	_tmp0_ = g_strdup_printf ("%u", g_random_int ());
#line 84 "../src/Document.vala"
	result = _tmp0_;
#line 84 "../src/Document.vala"
	return result;
#line 365 "Document.c"
}

static void
document_canvas_changed (Document* self)
{
#line 88 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/Document.vala"
	document_set_save_needed (self, TRUE);
#line 90 "../src/Document.vala"
	document_auto_save (self);
#line 377 "Document.c"
}

void
document_load_filename (Document* self,
                        const gchar* fname,
                        gboolean saved)
{
#line 94 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/Document.vala"
	g_return_if_fail (fname != NULL);
#line 95 "../src/Document.vala"
	document_set_filename (self, fname);
#line 96 "../src/Document.vala"
	self->priv->_from_user = saved;
#line 393 "Document.c"
}

gboolean
document_is_saved (Document* self)
{
	gboolean result;
#line 100 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 101 "../src/Document.vala"
	result = self->priv->_from_user;
#line 101 "../src/Document.vala"
	return result;
#line 406 "Document.c"
}

gboolean
document_xml_find (const gchar* fname,
                   gint id,
                   gchar** name)
{
	xmlDoc* doc = NULL;
	xmlDoc* _tmp0_;
	gboolean found = FALSE;
	xmlDoc* _tmp1_;
	xmlDoc* _tmp2_;
	xmlNode* _tmp3_;
	gboolean _tmp4_;
	xmlDoc* _tmp5_;
	gboolean result;
#line 108 "../src/Document.vala"
	g_return_val_if_fail (fname != NULL, FALSE);
#line 108 "../src/Document.vala"
	g_return_val_if_fail (*name != NULL, FALSE);
#line 109 "../src/Document.vala"
	_tmp0_ = xmlReadFile (fname, NULL, (gint) XML_PARSE_HUGE);
#line 109 "../src/Document.vala"
	doc = _tmp0_;
#line 110 "../src/Document.vala"
	found = FALSE;
#line 111 "../src/Document.vala"
	_tmp1_ = doc;
#line 111 "../src/Document.vala"
	if (_tmp1_ == NULL) {
#line 112 "../src/Document.vala"
		result = FALSE;
#line 112 "../src/Document.vala"
		return result;
#line 441 "Document.c"
	}
#line 114 "../src/Document.vala"
	_tmp2_ = doc;
#line 114 "../src/Document.vala"
	_tmp3_ = xmlDocGetRootElement (_tmp2_);
#line 114 "../src/Document.vala"
	_tmp4_ = draw_area_xml_find (_tmp3_, id, name);
#line 114 "../src/Document.vala"
	found = _tmp4_;
#line 115 "../src/Document.vala"
	_tmp5_ = doc;
#line 115 "../src/Document.vala"
	_xmlFreeDoc0 (_tmp5_);
#line 116 "../src/Document.vala"
	result = found;
#line 116 "../src/Document.vala"
	return result;
#line 459 "Document.c"
}

static xmlDoc*
document_load_raw (Document* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	xmlDoc* _tmp2_;
	xmlDoc* result;
#line 119 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "../src/Document.vala"
	_tmp0_ = document_get_filename (self);
#line 120 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 120 "../src/Document.vala"
	_tmp2_ = xmlReadFile (_tmp1_, NULL, (gint) XML_PARSE_HUGE);
#line 120 "../src/Document.vala"
	result = _tmp2_;
#line 120 "../src/Document.vala"
	return result;
#line 481 "Document.c"
}

static gchar*
document_get_etag (Document* self,
                   xmlDoc* doc)
{
	gchar* _tmp14_;
	gchar* result;
#line 123 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 492 "Document.c"
	{
		xmlAttr* prop = NULL;
		xmlNode* _tmp0_;
		xmlAttr* _tmp1_;
#line 124 "../src/Document.vala"
		_tmp0_ = xmlDocGetRootElement (doc);
#line 124 "../src/Document.vala"
		_tmp1_ = _tmp0_->properties;
#line 124 "../src/Document.vala"
		prop = _tmp1_;
#line 503 "Document.c"
		{
			gboolean _tmp2_ = FALSE;
#line 124 "../src/Document.vala"
			_tmp2_ = TRUE;
#line 124 "../src/Document.vala"
			while (TRUE) {
#line 510 "Document.c"
				xmlAttr* _tmp5_;
				gchar* attr_name = NULL;
				xmlAttr* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				const gchar* _tmp9_;
				xmlAttr* _tmp10_;
				xmlNode* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 124 "../src/Document.vala"
				if (!_tmp2_) {
#line 523 "Document.c"
					xmlAttr* _tmp3_;
					xmlAttr* _tmp4_;
#line 124 "../src/Document.vala"
					_tmp3_ = prop;
#line 124 "../src/Document.vala"
					_tmp4_ = _tmp3_->next;
#line 124 "../src/Document.vala"
					prop = _tmp4_;
#line 532 "Document.c"
				}
#line 124 "../src/Document.vala"
				_tmp2_ = FALSE;
#line 124 "../src/Document.vala"
				_tmp5_ = prop;
#line 124 "../src/Document.vala"
				if (!(_tmp5_ != NULL)) {
#line 124 "../src/Document.vala"
					break;
#line 542 "Document.c"
				}
#line 125 "../src/Document.vala"
				_tmp6_ = prop;
#line 125 "../src/Document.vala"
				_tmp7_ = _tmp6_->name;
#line 125 "../src/Document.vala"
				_tmp8_ = g_strdup (_tmp7_);
#line 125 "../src/Document.vala"
				attr_name = _tmp8_;
#line 126 "../src/Document.vala"
				_tmp9_ = attr_name;
#line 126 "../src/Document.vala"
				if (g_strcmp0 (_tmp9_, "etag") != 0) {
#line 127 "../src/Document.vala"
					_g_free0 (attr_name);
#line 127 "../src/Document.vala"
					continue;
#line 560 "Document.c"
				}
#line 130 "../src/Document.vala"
				_tmp10_ = prop;
#line 130 "../src/Document.vala"
				_tmp11_ = _tmp10_->children;
#line 130 "../src/Document.vala"
				_tmp12_ = _tmp11_->content;
#line 130 "../src/Document.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 130 "../src/Document.vala"
				result = _tmp13_;
#line 130 "../src/Document.vala"
				_g_free0 (attr_name);
#line 130 "../src/Document.vala"
				return result;
#line 576 "Document.c"
			}
		}
	}
#line 132 "../src/Document.vala"
	_tmp14_ = document_generate_etag (self);
#line 132 "../src/Document.vala"
	result = _tmp14_;
#line 132 "../src/Document.vala"
	return result;
#line 586 "Document.c"
}

gboolean
document_load (Document* self)
{
	xmlDoc* doc = NULL;
	xmlDoc* _tmp0_;
	xmlDoc* _tmp1_;
	xmlDoc* _tmp2_;
	gchar* _tmp3_;
	DrawArea* _tmp4_;
	xmlDoc* _tmp5_;
	xmlNode* _tmp6_;
	xmlDoc* _tmp7_;
	gboolean result;
#line 136 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 137 "../src/Document.vala"
	_tmp0_ = document_load_raw (self);
#line 137 "../src/Document.vala"
	doc = _tmp0_;
#line 138 "../src/Document.vala"
	_tmp1_ = doc;
#line 138 "../src/Document.vala"
	if (_tmp1_ == NULL) {
#line 139 "../src/Document.vala"
		result = FALSE;
#line 139 "../src/Document.vala"
		return result;
#line 616 "Document.c"
	}
#line 143 "../src/Document.vala"
	_tmp2_ = doc;
#line 143 "../src/Document.vala"
	_tmp3_ = document_get_etag (self, _tmp2_);
#line 143 "../src/Document.vala"
	_g_free0 (self->priv->_etag);
#line 143 "../src/Document.vala"
	self->priv->_etag = _tmp3_;
#line 145 "../src/Document.vala"
	_tmp4_ = self->priv->_da;
#line 145 "../src/Document.vala"
	_tmp5_ = doc;
#line 145 "../src/Document.vala"
	_tmp6_ = xmlDocGetRootElement (_tmp5_);
#line 145 "../src/Document.vala"
	draw_area_load (_tmp4_, _tmp6_);
#line 146 "../src/Document.vala"
	_tmp7_ = doc;
#line 146 "../src/Document.vala"
	_xmlFreeDoc0 (_tmp7_);
#line 147 "../src/Document.vala"
	result = TRUE;
#line 147 "../src/Document.vala"
	return result;
#line 642 "Document.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 664 "Document.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 668 "Document.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 674 "Document.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 678 "Document.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 682 "Document.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 690 "Document.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 718 "Document.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 727 "Document.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 741 "Document.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 750 "Document.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 764 "Document.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 773 "Document.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 782 "Document.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3320 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3321 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3321 "glib-2.0.vapi"
	result = _tmp0_;
#line 3321 "glib-2.0.vapi"
	return result;
#line 798 "Document.c"
}

gboolean
document_save (Document* self)
{
	xmlDoc* doc = NULL;
	xmlDoc* _tmp0_;
	xmlDoc* _tmp1_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gboolean result;
#line 151 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 152 "../src/Document.vala"
	_tmp0_ = document_load_raw (self);
#line 152 "../src/Document.vala"
	doc = _tmp0_;
#line 153 "../src/Document.vala"
	_tmp1_ = doc;
#line 153 "../src/Document.vala"
	if (_tmp1_ != NULL) {
#line 820 "Document.c"
		gchar* file_etag = NULL;
		xmlDoc* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 155 "../src/Document.vala"
		_tmp2_ = doc;
#line 155 "../src/Document.vala"
		_tmp3_ = document_get_etag (self, _tmp2_);
#line 155 "../src/Document.vala"
		file_etag = _tmp3_;
#line 156 "../src/Document.vala"
		_tmp4_ = self->priv->_etag;
#line 156 "../src/Document.vala"
		_tmp5_ = file_etag;
#line 156 "../src/Document.vala"
		if (g_strcmp0 (_tmp4_, _tmp5_) != 0) {
#line 838 "Document.c"
			DrawArea* _tmp6_;
			MainWindow* _tmp7_;
			MainWindow* _tmp8_;
			DrawArea* _tmp9_;
#line 158 "../src/Document.vala"
			_tmp6_ = self->priv->_da;
#line 158 "../src/Document.vala"
			_tmp7_ = draw_area_get_win (_tmp6_);
#line 158 "../src/Document.vala"
			_tmp8_ = _tmp7_;
#line 158 "../src/Document.vala"
			_tmp9_ = self->priv->_da;
#line 158 "../src/Document.vala"
			if (main_window_ask_modified_overwrite (_tmp8_, _tmp9_)) {
#line 853 "Document.c"
				xmlDoc* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				GDateTime* _tmp13_;
				GDateTime* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 159 "../src/Document.vala"
				_tmp10_ = doc;
#line 159 "../src/Document.vala"
				_tmp11_ = document_get_filename (self);
#line 159 "../src/Document.vala"
				_tmp12_ = _tmp11_;
#line 159 "../src/Document.vala"
				_tmp13_ = g_date_time_new_now_local ();
#line 159 "../src/Document.vala"
				_tmp14_ = _tmp13_;
#line 159 "../src/Document.vala"
				_tmp15_ = g_date_time_to_string (_tmp14_);
#line 159 "../src/Document.vala"
				_tmp16_ = _tmp15_;
#line 159 "../src/Document.vala"
				_tmp17_ = file_etag;
#line 159 "../src/Document.vala"
				_tmp18_ = g_strdup_printf ("-backup-%s-%s.mind", _tmp16_, _tmp17_);
#line 159 "../src/Document.vala"
				_tmp19_ = _tmp18_;
#line 159 "../src/Document.vala"
				_tmp20_ = string_replace (_tmp12_, ".mind", _tmp19_);
#line 159 "../src/Document.vala"
				_tmp21_ = _tmp20_;
#line 159 "../src/Document.vala"
				xmlSaveFormatFile (_tmp21_, _tmp10_, 1);
#line 159 "../src/Document.vala"
				_g_free0 (_tmp21_);
#line 159 "../src/Document.vala"
				_g_free0 (_tmp19_);
#line 159 "../src/Document.vala"
				_g_free0 (_tmp16_);
#line 159 "../src/Document.vala"
				_g_date_time_unref0 (_tmp14_);
#line 900 "Document.c"
			} else {
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				GDateTime* _tmp24_;
				GDateTime* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				const gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
#line 161 "../src/Document.vala"
				_tmp22_ = document_get_filename (self);
#line 161 "../src/Document.vala"
				_tmp23_ = _tmp22_;
#line 161 "../src/Document.vala"
				_tmp24_ = g_date_time_new_now_local ();
#line 161 "../src/Document.vala"
				_tmp25_ = _tmp24_;
#line 161 "../src/Document.vala"
				_tmp26_ = g_date_time_to_string (_tmp25_);
#line 161 "../src/Document.vala"
				_tmp27_ = _tmp26_;
#line 161 "../src/Document.vala"
				_tmp28_ = self->priv->_etag;
#line 161 "../src/Document.vala"
				_tmp29_ = g_strdup_printf ("-backup-%s-%s.mind", _tmp27_, _tmp28_);
#line 161 "../src/Document.vala"
				_tmp30_ = _tmp29_;
#line 161 "../src/Document.vala"
				_tmp31_ = string_replace (_tmp23_, ".mind", _tmp30_);
#line 161 "../src/Document.vala"
				_tmp32_ = _tmp31_;
#line 161 "../src/Document.vala"
				document_save_internal (self, _tmp32_, FALSE);
#line 161 "../src/Document.vala"
				_g_free0 (_tmp32_);
#line 161 "../src/Document.vala"
				_g_free0 (_tmp30_);
#line 161 "../src/Document.vala"
				_g_free0 (_tmp27_);
#line 161 "../src/Document.vala"
				_g_date_time_unref0 (_tmp25_);
#line 162 "../src/Document.vala"
				document_load (self);
#line 163 "../src/Document.vala"
				result = FALSE;
#line 163 "../src/Document.vala"
				_g_free0 (file_etag);
#line 163 "../src/Document.vala"
				return result;
#line 953 "Document.c"
			}
		}
#line 153 "../src/Document.vala"
		_g_free0 (file_etag);
#line 958 "Document.c"
	}
#line 168 "../src/Document.vala"
	_tmp33_ = document_get_filename (self);
#line 168 "../src/Document.vala"
	_tmp34_ = _tmp33_;
#line 168 "../src/Document.vala"
	result = document_save_internal (self, _tmp34_, TRUE);
#line 168 "../src/Document.vala"
	return result;
#line 968 "Document.c"
}

static gboolean
document_save_internal (Document* self,
                        const gchar* dest_filename,
                        gboolean bump_etag)
{
	xmlDoc* doc = NULL;
	xmlDoc* _tmp0_;
	xmlNode* root = NULL;
	xmlNode* _tmp1_;
	xmlNode* _tmp2_;
	const gchar* _tmp3_;
	xmlNode* _tmp7_;
	const gchar* _tmp8_;
	xmlDoc* _tmp9_;
	xmlNode* _tmp10_;
	DrawArea* _tmp11_;
	xmlNode* _tmp12_;
	xmlDoc* _tmp13_;
	xmlDoc* _tmp14_;
	gboolean result;
#line 171 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/Document.vala"
	g_return_val_if_fail (dest_filename != NULL, FALSE);
#line 172 "../src/Document.vala"
	_tmp0_ = xmlNewDoc ((xmlChar*) "1.0");
#line 172 "../src/Document.vala"
	doc = _tmp0_;
#line 173 "../src/Document.vala"
	_tmp1_ = xmlNewNode (NULL, (xmlChar*) "minder");
#line 173 "../src/Document.vala"
	root = _tmp1_;
#line 174 "../src/Document.vala"
	_tmp2_ = root;
#line 174 "../src/Document.vala"
	_tmp3_ = minder_version;
#line 174 "../src/Document.vala"
	xmlSetProp (_tmp2_, (xmlChar*) "version", (xmlChar*) _tmp3_);
#line 176 "../src/Document.vala"
	if (bump_etag) {
#line 1011 "Document.c"
		xmlNode* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 178 "../src/Document.vala"
		_tmp4_ = root;
#line 178 "../src/Document.vala"
		_tmp5_ = self->priv->_etag;
#line 178 "../src/Document.vala"
		xmlSetProp (_tmp4_, (xmlChar*) "parent-etag", (xmlChar*) _tmp5_);
#line 181 "../src/Document.vala"
		_tmp6_ = document_generate_etag (self);
#line 181 "../src/Document.vala"
		_g_free0 (self->priv->_etag);
#line 181 "../src/Document.vala"
		self->priv->_etag = _tmp6_;
#line 1027 "Document.c"
	}
#line 184 "../src/Document.vala"
	_tmp7_ = root;
#line 184 "../src/Document.vala"
	_tmp8_ = self->priv->_etag;
#line 184 "../src/Document.vala"
	xmlSetProp (_tmp7_, (xmlChar*) "etag", (xmlChar*) _tmp8_);
#line 186 "../src/Document.vala"
	_tmp9_ = doc;
#line 186 "../src/Document.vala"
	_tmp10_ = root;
#line 186 "../src/Document.vala"
	xmlDocSetRootElement (_tmp9_, _tmp10_);
#line 187 "../src/Document.vala"
	_tmp11_ = self->priv->_da;
#line 187 "../src/Document.vala"
	_tmp12_ = root;
#line 187 "../src/Document.vala"
	draw_area_save (_tmp11_, _tmp12_);
#line 188 "../src/Document.vala"
	_tmp13_ = doc;
#line 188 "../src/Document.vala"
	xmlSaveFormatFile (dest_filename, _tmp13_, 1);
#line 189 "../src/Document.vala"
	_tmp14_ = doc;
#line 189 "../src/Document.vala"
	_xmlFreeDoc0 (_tmp14_);
#line 190 "../src/Document.vala"
	document_set_save_needed (self, FALSE);
#line 191 "../src/Document.vala"
	result = TRUE;
#line 191 "../src/Document.vala"
	return result;
#line 1061 "Document.c"
}

gboolean
document_remove (Document* self)
{
	gboolean result;
#line 195 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "../src/Document.vala"
	if (!self->priv->_from_user) {
#line 1072 "Document.c"
		const gchar* _tmp0_;
#line 197 "../src/Document.vala"
		_tmp0_ = self->priv->_filename;
#line 197 "../src/Document.vala"
		g_unlink (_tmp0_);
#line 1078 "Document.c"
	}
#line 199 "../src/Document.vala"
	result = TRUE;
#line 199 "../src/Document.vala"
	return result;
#line 1084 "Document.c"
}

void
document_auto_save (Document* self)
{
	gboolean _tmp0_;
#line 203 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/Document.vala"
	_tmp0_ = self->priv->_save_needed;
#line 204 "../src/Document.vala"
	if (_tmp0_) {
#line 205 "../src/Document.vala"
		document_save (self);
#line 1099 "Document.c"
	}
}

const gchar*
document_get_filename (Document* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 45 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/Document.vala"
	_tmp0_ = self->priv->_filename;
#line 46 "../src/Document.vala"
	result = _tmp0_;
#line 46 "../src/Document.vala"
	return result;
#line 1116 "Document.c"
}

void
document_set_filename (Document* self,
                       const gchar* value)
{
	const gchar* _tmp0_;
#line 36 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Document.vala"
	_tmp0_ = self->priv->_filename;
#line 37 "../src/Document.vala"
	if (g_strcmp0 (_tmp0_, value) != 0) {
#line 1130 "Document.c"
		gchar* _tmp2_;
#line 38 "../src/Document.vala"
		if (!self->priv->_from_user) {
#line 1134 "Document.c"
			const gchar* _tmp1_;
#line 39 "../src/Document.vala"
			_tmp1_ = self->priv->_filename;
#line 39 "../src/Document.vala"
			g_unlink (_tmp1_);
#line 1140 "Document.c"
		}
#line 41 "../src/Document.vala"
		_tmp2_ = g_strdup (value);
#line 41 "../src/Document.vala"
		_g_free0 (self->priv->_filename);
#line 41 "../src/Document.vala"
		self->priv->_filename = _tmp2_;
#line 42 "../src/Document.vala"
		self->priv->_from_user = TRUE;
#line 1150 "Document.c"
	}
#line 36 "../src/Document.vala"
	g_object_notify_by_pspec ((GObject *) self, document_properties[DOCUMENT_FILENAME_PROPERTY]);
#line 1154 "Document.c"
}

gchar*
document_get_label (Document* self)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 50 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/Document.vala"
	_tmp0_ = self->priv->_filename;
#line 51 "../src/Document.vala"
	_tmp1_ = g_path_get_basename (_tmp0_);
#line 51 "../src/Document.vala"
	result = _tmp1_;
#line 51 "../src/Document.vala"
	return result;
#line 1173 "Document.c"
}

gboolean
document_get_save_needed (Document* self)
{
	gboolean result;
#line 54 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/Document.vala"
	result = self->priv->_save_needed;
#line 54 "../src/Document.vala"
	return result;
#line 1186 "Document.c"
}

static void
document_set_save_needed (Document* self,
                          gboolean value)
{
	gboolean old_value;
#line 54 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/Document.vala"
	old_value = document_get_save_needed (self);
#line 54 "../src/Document.vala"
	if (old_value != value) {
#line 54 "../src/Document.vala"
		self->priv->_save_needed = value;
#line 54 "../src/Document.vala"
		g_object_notify_by_pspec ((GObject *) self, document_properties[DOCUMENT_SAVE_NEEDED_PROPERTY]);
#line 1204 "Document.c"
	}
}

static void
document_class_init (DocumentClass * klass,
                     gpointer klass_data)
{
#line 26 "../src/Document.vala"
	document_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Document.vala"
	g_type_class_adjust_private_offset (klass, &Document_private_offset);
#line 26 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_document_get_property;
#line 26 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_document_set_property;
#line 26 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->finalize = document_finalize;
#line 26 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_FILENAME_PROPERTY, document_properties[DOCUMENT_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_LABEL_PROPERTY, document_properties[DOCUMENT_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_SAVE_NEEDED_PROPERTY, document_properties[DOCUMENT_SAVE_NEEDED_PROPERTY] = g_param_spec_boolean ("save-needed", "save-needed", "save-needed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1228 "Document.c"
}

static void
document_instance_init (Document * self,
                        gpointer klass)
{
#line 26 "../src/Document.vala"
	self->priv = document_get_instance_private (self);
#line 54 "../src/Document.vala"
	self->priv->_save_needed = FALSE;
#line 1239 "Document.c"
}

static void
document_finalize (GObject * obj)
{
	Document * self;
#line 26 "../src/Document.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DOCUMENT, Document);
#line 28 "../src/Document.vala"
	_g_object_unref0 (self->priv->_da);
#line 29 "../src/Document.vala"
	_g_free0 (self->priv->_filename);
#line 31 "../src/Document.vala"
	_image_manager_unref0 (self->priv->_image_manager);
#line 32 "../src/Document.vala"
	_g_free0 (self->priv->_etag);
#line 26 "../src/Document.vala"
	G_OBJECT_CLASS (document_parent_class)->finalize (obj);
#line 1258 "Document.c"
}

static GType
document_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DocumentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) document_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Document), 0, (GInstanceInitFunc) document_instance_init, NULL };
	GType document_type_id;
	document_type_id = g_type_register_static (G_TYPE_OBJECT, "Document", &g_define_type_info, 0);
	Document_private_offset = g_type_add_instance_private (document_type_id, sizeof (DocumentPrivate));
	return document_type_id;
}

GType
document_get_type (void)
{
	static volatile gsize document_type_id__once = 0;
	if (g_once_init_enter (&document_type_id__once)) {
		GType document_type_id;
		document_type_id = document_get_type_once ();
		g_once_init_leave (&document_type_id__once, document_type_id);
	}
	return document_type_id__once;
}

static void
_vala_document_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	Document * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DOCUMENT, Document);
#line 26 "../src/Document.vala"
	switch (property_id) {
#line 26 "../src/Document.vala"
		case DOCUMENT_FILENAME_PROPERTY:
#line 26 "../src/Document.vala"
		g_value_set_string (value, document_get_filename (self));
#line 26 "../src/Document.vala"
		break;
#line 26 "../src/Document.vala"
		case DOCUMENT_LABEL_PROPERTY:
#line 26 "../src/Document.vala"
		g_value_take_string (value, document_get_label (self));
#line 26 "../src/Document.vala"
		break;
#line 26 "../src/Document.vala"
		case DOCUMENT_SAVE_NEEDED_PROPERTY:
#line 26 "../src/Document.vala"
		g_value_set_boolean (value, document_get_save_needed (self));
#line 26 "../src/Document.vala"
		break;
#line 1311 "Document.c"
		default:
#line 26 "../src/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/Document.vala"
		break;
#line 1317 "Document.c"
	}
}

static void
_vala_document_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	Document * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DOCUMENT, Document);
#line 26 "../src/Document.vala"
	switch (property_id) {
#line 26 "../src/Document.vala"
		case DOCUMENT_FILENAME_PROPERTY:
#line 26 "../src/Document.vala"
		document_set_filename (self, g_value_get_string (value));
#line 26 "../src/Document.vala"
		break;
#line 26 "../src/Document.vala"
		case DOCUMENT_SAVE_NEEDED_PROPERTY:
#line 26 "../src/Document.vala"
		document_set_save_needed (self, g_value_get_boolean (value));
#line 26 "../src/Document.vala"
		break;
#line 1343 "Document.c"
		default:
#line 26 "../src/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/Document.vala"
		break;
#line 1349 "Document.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

