/* Export.c generated by valac 0.56.3, the Vala compiler
 * generated from Export.vala, do not modify */

/*
* Copyright (c) 2020 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <libxml/tree.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_EXPORT (export_get_type ())
#define EXPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORT, Export))
#define EXPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORT, ExportClass))
#define IS_EXPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORT))
#define IS_EXPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORT))
#define EXPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORT, ExportClass))

typedef struct _Export Export;
typedef struct _ExportClass ExportClass;
typedef struct _ExportPrivate ExportPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecExport ParamSpecExport;
enum  {
	EXPORT_SETTINGS_CHANGED_SIGNAL,
	EXPORT_NUM_SIGNALS
};
static guint export_signals[EXPORT_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Export {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ExportPrivate * priv;
};

struct _ExportClass {
	GTypeClass parent_class;
	void (*finalize) (Export *self);
	gboolean (*export) (Export* self, const gchar* fname, DrawArea* da);
	gboolean (*import) (Export* self, const gchar* fname, DrawArea* da);
	void (*add_settings) (Export* self, GtkGrid* grid);
	void (*save_settings) (Export* self, xmlNode* node);
	void (*load_settings) (Export* self, xmlNode* node);
};

struct _ExportPrivate {
	GeeHashMap* _settings;
	gchar* _name;
	gchar* _label;
	gchar** _extensions;
	gint _extensions_length1;
	gint __extensions_size_;
	gboolean _importable;
	gboolean _exportable;
};

struct _ParamSpecExport {
	GParamSpec parent_instance;
};

static gint Export_private_offset;
static gpointer export_parent_class = NULL;

VALA_EXTERN gpointer export_ref (gpointer instance);
VALA_EXTERN void export_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_export (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_export (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_export (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_export (const GValue* value);
VALA_EXTERN GType export_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Export, export_unref)
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN gboolean export_export (Export* self,
                        const gchar* fname,
                        DrawArea* da);
VALA_EXTERN gboolean export_import (Export* self,
                        const gchar* fname,
                        DrawArea* da);
VALA_EXTERN void export_add_settings (Export* self,
                          GtkGrid* grid);
VALA_EXTERN void export_save_settings (Export* self,
                           xmlNode* node);
VALA_EXTERN void export_load_settings (Export* self,
                           xmlNode* node);
VALA_EXTERN Export* export_new (const gchar* name,
                    const gchar* label,
                    gchar** extensions,
                    gint extensions_length1,
                    gboolean exportable,
                    gboolean importable);
VALA_EXTERN Export* export_construct (GType object_type,
                          const gchar* name,
                          const gchar* label,
                          gchar** extensions,
                          gint extensions_length1,
                          gboolean exportable,
                          gboolean importable);
static void export_set_name (Export* self,
                      const gchar* value);
static void export_set_label (Export* self,
                       const gchar* value);
static void export_set_extensions (Export* self,
                            gchar** value,
                            gint value_length1);
static void export_set_exportable (Export* self,
                            gboolean value);
static void export_set_importable (Export* self,
                            gboolean value);
static gboolean export_real_export (Export* self,
                             const gchar* fname,
                             DrawArea* da);
static gboolean export_real_import (Export* self,
                             const gchar* fname,
                             DrawArea* da);
VALA_EXTERN gboolean export_settings_available (Export* self);
static void export_real_add_settings (Export* self,
                               GtkGrid* grid);
static GtkLabel* export_make_help (Export* self,
                            const gchar* help);
VALA_EXTERN void export_add_setting_bool (Export* self,
                              const gchar* name,
                              GtkGrid* grid,
                              const gchar* label,
                              const gchar* help,
                              gboolean dflt);
VALA_EXTERN gchar* utils_make_title (const gchar* str);
static void __lambda35_ (Export* self);
static void ___lambda35__gtk_switch_activate (GtkSwitch* _sender,
                                       gpointer self);
VALA_EXTERN void export_add_setting_scale (Export* self,
                               const gchar* name,
                               GtkGrid* grid,
                               const gchar* label,
                               const gchar* help,
                               gint min,
                               gint max,
                               gint step,
                               gint dflt);
static void __lambda36_ (Export* self);
static void ___lambda36__gtk_range_value_changed (GtkRange* _sender,
                                           gpointer self);
VALA_EXTERN void export_set_bool (Export* self,
                      const gchar* name,
                      gboolean value);
VALA_EXTERN gboolean export_get_bool (Export* self,
                          const gchar* name);
VALA_EXTERN void export_set_scale (Export* self,
                       const gchar* name,
                       gint value);
VALA_EXTERN gint export_get_scale (Export* self,
                       const gchar* name);
static void export_real_save_settings (Export* self,
                                xmlNode* node);
static void export_real_load_settings (Export* self,
                                xmlNode* node);
VALA_EXTERN gboolean export_filename_matches (Export* self,
                                  const gchar* fname,
                                  gchar** basename);
VALA_EXTERN gchar** export_get_extensions (Export* self,
                               gint* result_length1);
VALA_EXTERN xmlNode* export_save (Export* self);
VALA_EXTERN const gchar* export_get_name (Export* self);
VALA_EXTERN void export_load (Export* self,
                  xmlNode* node);
VALA_EXTERN const gchar* export_get_label (Export* self);
static gchar** _vala_array_dup5 (gchar** self,
                          gssize length);
VALA_EXTERN gboolean export_get_importable (Export* self);
VALA_EXTERN gboolean export_get_exportable (Export* self);
static void export_finalize (Export * obj);
static GType export_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
export_get_instance_private (Export* self)
{
	return G_STRUCT_MEMBER_P (self, Export_private_offset);
}

Export*
export_construct (GType object_type,
                  const gchar* name,
                  const gchar* label,
                  gchar** extensions,
                  gint extensions_length1,
                  gboolean exportable,
                  gboolean importable)
{
	Export* self = NULL;
	GeeHashMap* _tmp0_;
#line 36 "../src/Export.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 36 "../src/Export.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 36 "../src/Export.vala"
	self = (Export*) g_type_create_instance (object_type);
#line 37 "../src/Export.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, gtk_widget_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 37 "../src/Export.vala"
	_g_object_unref0 (self->priv->_settings);
#line 37 "../src/Export.vala"
	self->priv->_settings = _tmp0_;
#line 38 "../src/Export.vala"
	export_set_name (self, name);
#line 39 "../src/Export.vala"
	export_set_label (self, label);
#line 40 "../src/Export.vala"
	export_set_extensions (self, extensions, extensions_length1);
#line 41 "../src/Export.vala"
	export_set_exportable (self, exportable);
#line 42 "../src/Export.vala"
	export_set_importable (self, importable);
#line 36 "../src/Export.vala"
	return self;
#line 280 "Export.c"
}

Export*
export_new (const gchar* name,
            const gchar* label,
            gchar** extensions,
            gint extensions_length1,
            gboolean exportable,
            gboolean importable)
{
#line 36 "../src/Export.vala"
	return export_construct (TYPE_EXPORT, name, label, extensions, extensions_length1, exportable, importable);
#line 293 "Export.c"
}

static gboolean
export_real_export (Export* self,
                    const gchar* fname,
                    DrawArea* da)
{
	gboolean result;
#line 48 "../src/Export.vala"
	g_return_val_if_fail (fname != NULL, FALSE);
#line 48 "../src/Export.vala"
	g_return_val_if_fail (da != NULL, FALSE);
#line 49 "../src/Export.vala"
	result = FALSE;
#line 49 "../src/Export.vala"
	return result;
#line 310 "Export.c"
}

gboolean
export_export (Export* self,
               const gchar* fname,
               DrawArea* da)
{
	ExportClass* _klass_;
#line 48 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/Export.vala"
	_klass_ = EXPORT_GET_CLASS (self);
#line 48 "../src/Export.vala"
	if (_klass_->export) {
#line 48 "../src/Export.vala"
		return _klass_->export (self, fname, da);
#line 327 "Export.c"
	}
#line 48 "../src/Export.vala"
	return FALSE;
#line 331 "Export.c"
}

static gboolean
export_real_import (Export* self,
                    const gchar* fname,
                    DrawArea* da)
{
	gboolean result;
#line 53 "../src/Export.vala"
	g_return_val_if_fail (fname != NULL, FALSE);
#line 53 "../src/Export.vala"
	g_return_val_if_fail (da != NULL, FALSE);
#line 54 "../src/Export.vala"
	result = FALSE;
#line 54 "../src/Export.vala"
	return result;
#line 348 "Export.c"
}

gboolean
export_import (Export* self,
               const gchar* fname,
               DrawArea* da)
{
	ExportClass* _klass_;
#line 53 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 53 "../src/Export.vala"
	_klass_ = EXPORT_GET_CLASS (self);
#line 53 "../src/Export.vala"
	if (_klass_->import) {
#line 53 "../src/Export.vala"
		return _klass_->import (self, fname, da);
#line 365 "Export.c"
	}
#line 53 "../src/Export.vala"
	return FALSE;
#line 369 "Export.c"
}

gboolean
export_settings_available (Export* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 57 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../src/Export.vala"
	_tmp0_ = self->priv->_settings;
#line 58 "../src/Export.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 58 "../src/Export.vala"
	_tmp2_ = _tmp1_;
#line 58 "../src/Export.vala"
	result = _tmp2_ > 0;
#line 58 "../src/Export.vala"
	return result;
#line 391 "Export.c"
}

static void
export_real_add_settings (Export* self,
                          GtkGrid* grid)
{
#line 62 "../src/Export.vala"
	g_return_if_fail (grid != NULL);
#line 400 "Export.c"
}

void
export_add_settings (Export* self,
                     GtkGrid* grid)
{
	ExportClass* _klass_;
#line 62 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/Export.vala"
	_klass_ = EXPORT_GET_CLASS (self);
#line 62 "../src/Export.vala"
	if (_klass_->add_settings) {
#line 62 "../src/Export.vala"
		_klass_->add_settings (self, grid);
#line 416 "Export.c"
	}
}

static GtkLabel*
export_make_help (Export* self,
                  const gchar* help)
{
	GtkLabel* lbl = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* result;
#line 64 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../src/Export.vala"
	g_return_val_if_fail (help != NULL, NULL);
#line 66 "../src/Export.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (help);
#line 66 "../src/Export.vala"
	g_object_ref_sink (_tmp0_);
#line 66 "../src/Export.vala"
	lbl = _tmp0_;
#line 67 "../src/Export.vala"
	gtk_widget_set_margin_left ((GtkWidget*) lbl, 10);
#line 68 "../src/Export.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) lbl, 10);
#line 69 "../src/Export.vala"
	gtk_label_set_xalign (lbl, (gfloat) 0);
#line 70 "../src/Export.vala"
	gtk_label_set_justify (lbl, GTK_JUSTIFY_LEFT);
#line 71 "../src/Export.vala"
	gtk_label_set_max_width_chars (lbl, 40);
#line 72 "../src/Export.vala"
	g_object_set (lbl, "wrap-mode", PANGO_WRAP_WORD, NULL);
#line 73 "../src/Export.vala"
	gtk_label_set_line_wrap (lbl, TRUE);
#line 75 "../src/Export.vala"
	result = lbl;
#line 75 "../src/Export.vala"
	return result;
#line 455 "Export.c"
}

static void
__lambda35_ (Export* self)
{
#line 91 "../src/Export.vala"
	g_signal_emit (self, export_signals[EXPORT_SETTINGS_CHANGED_SIGNAL], 0);
#line 463 "Export.c"
}

static void
___lambda35__gtk_switch_activate (GtkSwitch* _sender,
                                  gpointer self)
{
#line 90 "../src/Export.vala"
	__lambda35_ ((Export*) self);
#line 472 "Export.c"
}

void
export_add_setting_bool (Export* self,
                         const gchar* name,
                         GtkGrid* grid,
                         const gchar* label,
                         const gchar* help,
                         gboolean dflt)
{
	gint row = 0;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkLabel* lbl = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkSwitch* sw = NULL;
	GtkSwitch* _tmp9_;
	GtkSwitch* _tmp10_;
	GtkSwitch* _tmp11_;
	GtkSwitch* _tmp12_;
	GtkLabel* _tmp13_;
	GtkSwitch* _tmp14_;
	GeeHashMap* _tmp17_;
	GtkSwitch* _tmp18_;
#line 79 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/Export.vala"
	g_return_if_fail (name != NULL);
#line 79 "../src/Export.vala"
	g_return_if_fail (grid != NULL);
#line 79 "../src/Export.vala"
	g_return_if_fail (label != NULL);
#line 81 "../src/Export.vala"
	_tmp0_ = self->priv->_settings;
#line 81 "../src/Export.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 81 "../src/Export.vala"
	_tmp2_ = _tmp1_;
#line 81 "../src/Export.vala"
	row = _tmp2_ * 2;
#line 83 "../src/Export.vala"
	_tmp3_ = utils_make_title (label);
#line 83 "../src/Export.vala"
	_tmp4_ = _tmp3_;
#line 83 "../src/Export.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 83 "../src/Export.vala"
	g_object_ref_sink (_tmp5_);
#line 83 "../src/Export.vala"
	_tmp6_ = _tmp5_;
#line 83 "../src/Export.vala"
	_g_free0 (_tmp4_);
#line 83 "../src/Export.vala"
	lbl = _tmp6_;
#line 84 "../src/Export.vala"
	_tmp7_ = lbl;
#line 84 "../src/Export.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 85 "../src/Export.vala"
	_tmp8_ = lbl;
#line 85 "../src/Export.vala"
	gtk_label_set_use_markup (_tmp8_, TRUE);
#line 87 "../src/Export.vala"
	_tmp9_ = (GtkSwitch*) gtk_switch_new ();
#line 87 "../src/Export.vala"
	g_object_ref_sink (_tmp9_);
#line 87 "../src/Export.vala"
	sw = _tmp9_;
#line 88 "../src/Export.vala"
	_tmp10_ = sw;
#line 88 "../src/Export.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_END);
#line 89 "../src/Export.vala"
	_tmp11_ = sw;
#line 89 "../src/Export.vala"
	g_object_set ((GtkWidget*) _tmp11_, "expand", TRUE, NULL);
#line 90 "../src/Export.vala"
	_tmp12_ = sw;
#line 90 "../src/Export.vala"
	g_signal_connect (_tmp12_, "activate", (GCallback) ___lambda35__gtk_switch_activate, self);
#line 94 "../src/Export.vala"
	_tmp13_ = lbl;
#line 94 "../src/Export.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp13_, 0, row, 1, 1);
#line 95 "../src/Export.vala"
	_tmp14_ = sw;
#line 95 "../src/Export.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp14_, 1, row, 1, 1);
#line 97 "../src/Export.vala"
	if (help != NULL) {
#line 569 "Export.c"
		GtkLabel* hlp = NULL;
		GtkLabel* _tmp15_;
		GtkLabel* _tmp16_;
#line 98 "../src/Export.vala"
		_tmp15_ = export_make_help (self, help);
#line 98 "../src/Export.vala"
		hlp = _tmp15_;
#line 99 "../src/Export.vala"
		_tmp16_ = hlp;
#line 99 "../src/Export.vala"
		gtk_grid_attach (grid, (GtkWidget*) _tmp16_, 0, row + 1, 1, 1);
#line 97 "../src/Export.vala"
		_g_object_unref0 (hlp);
#line 583 "Export.c"
	}
#line 102 "../src/Export.vala"
	_tmp17_ = self->priv->_settings;
#line 102 "../src/Export.vala"
	_tmp18_ = sw;
#line 102 "../src/Export.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, name, (GtkWidget*) _tmp18_);
#line 79 "../src/Export.vala"
	_g_object_unref0 (sw);
#line 79 "../src/Export.vala"
	_g_object_unref0 (lbl);
#line 595 "Export.c"
}

static void
__lambda36_ (Export* self)
{
#line 120 "../src/Export.vala"
	g_signal_emit (self, export_signals[EXPORT_SETTINGS_CHANGED_SIGNAL], 0);
#line 603 "Export.c"
}

static void
___lambda36__gtk_range_value_changed (GtkRange* _sender,
                                      gpointer self)
{
#line 119 "../src/Export.vala"
	__lambda36_ ((Export*) self);
#line 612 "Export.c"
}

void
export_add_setting_scale (Export* self,
                          const gchar* name,
                          GtkGrid* grid,
                          const gchar* label,
                          const gchar* help,
                          gint min,
                          gint max,
                          gint step,
                          gint dflt)
{
	gint row = 0;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkLabel* lbl = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkScale* scale = NULL;
	GtkScale* _tmp9_;
	GtkScale* _tmp10_;
	GtkScale* _tmp11_;
	GtkScale* _tmp12_;
	GtkScale* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkScale* _tmp16_;
	GtkScale* _tmp17_;
	GtkLabel* _tmp18_;
	GtkScale* _tmp19_;
	GeeHashMap* _tmp22_;
	GtkScale* _tmp23_;
#line 106 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/Export.vala"
	g_return_if_fail (name != NULL);
#line 106 "../src/Export.vala"
	g_return_if_fail (grid != NULL);
#line 106 "../src/Export.vala"
	g_return_if_fail (label != NULL);
#line 108 "../src/Export.vala"
	_tmp0_ = self->priv->_settings;
#line 108 "../src/Export.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 108 "../src/Export.vala"
	_tmp2_ = _tmp1_;
#line 108 "../src/Export.vala"
	row = _tmp2_ * 2;
#line 110 "../src/Export.vala"
	_tmp3_ = utils_make_title (label);
#line 110 "../src/Export.vala"
	_tmp4_ = _tmp3_;
#line 110 "../src/Export.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 110 "../src/Export.vala"
	g_object_ref_sink (_tmp5_);
#line 110 "../src/Export.vala"
	_tmp6_ = _tmp5_;
#line 110 "../src/Export.vala"
	_g_free0 (_tmp4_);
#line 110 "../src/Export.vala"
	lbl = _tmp6_;
#line 111 "../src/Export.vala"
	_tmp7_ = lbl;
#line 111 "../src/Export.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 112 "../src/Export.vala"
	_tmp8_ = lbl;
#line 112 "../src/Export.vala"
	gtk_label_set_use_markup (_tmp8_, TRUE);
#line 114 "../src/Export.vala"
	_tmp9_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) min, (gdouble) max, (gdouble) step);
#line 114 "../src/Export.vala"
	g_object_ref_sink (_tmp9_);
#line 114 "../src/Export.vala"
	scale = _tmp9_;
#line 115 "../src/Export.vala"
	_tmp10_ = scale;
#line 115 "../src/Export.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_END);
#line 116 "../src/Export.vala"
	_tmp11_ = scale;
#line 116 "../src/Export.vala"
	g_object_set ((GtkWidget*) _tmp11_, "expand", TRUE, NULL);
#line 117 "../src/Export.vala"
	_tmp12_ = scale;
#line 117 "../src/Export.vala"
	gtk_scale_set_draw_value (_tmp12_, TRUE);
#line 118 "../src/Export.vala"
	_tmp13_ = scale;
#line 118 "../src/Export.vala"
	_tmp14_ = g_strdup_printf ("%i", max);
#line 118 "../src/Export.vala"
	_tmp15_ = _tmp14_;
#line 118 "../src/Export.vala"
	gtk_range_set_round_digits ((GtkRange*) _tmp13_, g_utf8_strlen (_tmp15_, (gssize) -1));
#line 118 "../src/Export.vala"
	_g_free0 (_tmp15_);
#line 119 "../src/Export.vala"
	_tmp16_ = scale;
#line 119 "../src/Export.vala"
	g_signal_connect ((GtkRange*) _tmp16_, "value-changed", (GCallback) ___lambda36__gtk_range_value_changed, self);
#line 122 "../src/Export.vala"
	_tmp17_ = scale;
#line 122 "../src/Export.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp17_, 150, -1);
#line 124 "../src/Export.vala"
	_tmp18_ = lbl;
#line 124 "../src/Export.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp18_, 0, row, 1, 1);
#line 125 "../src/Export.vala"
	_tmp19_ = scale;
#line 125 "../src/Export.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp19_, 1, row, 1, 1);
#line 127 "../src/Export.vala"
	if (help != NULL) {
#line 735 "Export.c"
		GtkLabel* hlp = NULL;
		GtkLabel* _tmp20_;
		GtkLabel* _tmp21_;
#line 128 "../src/Export.vala"
		_tmp20_ = export_make_help (self, help);
#line 128 "../src/Export.vala"
		hlp = _tmp20_;
#line 129 "../src/Export.vala"
		_tmp21_ = hlp;
#line 129 "../src/Export.vala"
		gtk_grid_attach (grid, (GtkWidget*) _tmp21_, 0, row + 1, 1, 1);
#line 127 "../src/Export.vala"
		_g_object_unref0 (hlp);
#line 749 "Export.c"
	}
#line 132 "../src/Export.vala"
	_tmp22_ = self->priv->_settings;
#line 132 "../src/Export.vala"
	_tmp23_ = scale;
#line 132 "../src/Export.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, name, (GtkWidget*) _tmp23_);
#line 106 "../src/Export.vala"
	_g_object_unref0 (scale);
#line 106 "../src/Export.vala"
	_g_object_unref0 (lbl);
#line 761 "Export.c"
}

void
export_set_bool (Export* self,
                 const gchar* name,
                 gboolean value)
{
	GeeHashMap* _tmp0_;
	GtkSwitch* sw = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
#line 136 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/Export.vala"
	g_return_if_fail (name != NULL);
#line 137 "../src/Export.vala"
	_tmp0_ = self->priv->_settings;
#line 137 "../src/Export.vala"
	_vala_assert (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, name), "_settings.has_key( name )");
#line 138 "../src/Export.vala"
	_tmp1_ = self->priv->_settings;
#line 138 "../src/Export.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, name);
#line 138 "../src/Export.vala"
	sw = G_TYPE_CHECK_INSTANCE_CAST ((GtkWidget*) _tmp2_, gtk_switch_get_type (), GtkSwitch);
#line 139 "../src/Export.vala"
	gtk_switch_set_active (sw, value);
#line 136 "../src/Export.vala"
	_g_object_unref0 (sw);
#line 791 "Export.c"
}

gboolean
export_get_bool (Export* self,
                 const gchar* name)
{
	GeeHashMap* _tmp0_;
	GtkSwitch* sw = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 142 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "../src/Export.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 143 "../src/Export.vala"
	_tmp0_ = self->priv->_settings;
#line 143 "../src/Export.vala"
	_vala_assert (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, name), "_settings.has_key( name )");
#line 144 "../src/Export.vala"
	_tmp1_ = self->priv->_settings;
#line 144 "../src/Export.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, name);
#line 144 "../src/Export.vala"
	sw = G_TYPE_CHECK_INSTANCE_CAST ((GtkWidget*) _tmp2_, gtk_switch_get_type (), GtkSwitch);
#line 145 "../src/Export.vala"
	_tmp3_ = gtk_switch_get_active (sw);
#line 145 "../src/Export.vala"
	_tmp4_ = _tmp3_;
#line 145 "../src/Export.vala"
	result = _tmp4_;
#line 145 "../src/Export.vala"
	_g_object_unref0 (sw);
#line 145 "../src/Export.vala"
	return result;
#line 829 "Export.c"
}

void
export_set_scale (Export* self,
                  const gchar* name,
                  gint value)
{
	GeeHashMap* _tmp0_;
	GtkScale* scale = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	gdouble double_value = 0.0;
#line 148 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/Export.vala"
	g_return_if_fail (name != NULL);
#line 149 "../src/Export.vala"
	_tmp0_ = self->priv->_settings;
#line 149 "../src/Export.vala"
	_vala_assert (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, name), "_settings.has_key( name )");
#line 150 "../src/Export.vala"
	_tmp1_ = self->priv->_settings;
#line 150 "../src/Export.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, name);
#line 150 "../src/Export.vala"
	scale = G_TYPE_CHECK_INSTANCE_CAST ((GtkWidget*) _tmp2_, gtk_scale_get_type (), GtkScale);
#line 151 "../src/Export.vala"
	double_value = (gdouble) value;
#line 152 "../src/Export.vala"
	gtk_range_set_value ((GtkRange*) scale, double_value);
#line 148 "../src/Export.vala"
	_g_object_unref0 (scale);
#line 862 "Export.c"
}

gint
export_get_scale (Export* self,
                  const gchar* name)
{
	GeeHashMap* _tmp0_;
	GtkScale* scale = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	gint result;
#line 155 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 155 "../src/Export.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 156 "../src/Export.vala"
	_tmp0_ = self->priv->_settings;
#line 156 "../src/Export.vala"
	_vala_assert (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, name), "_settings.has_key( name )");
#line 157 "../src/Export.vala"
	_tmp1_ = self->priv->_settings;
#line 157 "../src/Export.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, name);
#line 157 "../src/Export.vala"
	scale = G_TYPE_CHECK_INSTANCE_CAST ((GtkWidget*) _tmp2_, gtk_scale_get_type (), GtkScale);
#line 158 "../src/Export.vala"
	result = (gint) gtk_range_get_value ((GtkRange*) scale);
#line 158 "../src/Export.vala"
	_g_object_unref0 (scale);
#line 158 "../src/Export.vala"
	return result;
#line 894 "Export.c"
}

static void
export_real_save_settings (Export* self,
                           xmlNode* node)
{
}

void
export_save_settings (Export* self,
                      xmlNode* node)
{
	ExportClass* _klass_;
#line 162 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/Export.vala"
	_klass_ = EXPORT_GET_CLASS (self);
#line 162 "../src/Export.vala"
	if (_klass_->save_settings) {
#line 162 "../src/Export.vala"
		_klass_->save_settings (self, node);
#line 916 "Export.c"
	}
}

static void
export_real_load_settings (Export* self,
                           xmlNode* node)
{
}

void
export_load_settings (Export* self,
                      xmlNode* node)
{
	ExportClass* _klass_;
#line 165 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/Export.vala"
	_klass_ = EXPORT_GET_CLASS (self);
#line 165 "../src/Export.vala"
	if (_klass_->load_settings) {
#line 165 "../src/Export.vala"
		_klass_->load_settings (self, node);
#line 939 "Export.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 967 "Export.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 973 "Export.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 979 "Export.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 983 "Export.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 991 "Export.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 995 "Export.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 1007 "Export.c"
}

gboolean
export_filename_matches (Export* self,
                         const gchar* fname,
                         gchar** basename)
{
	gchar* _vala_basename = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 168 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 168 "../src/Export.vala"
	g_return_val_if_fail (fname != NULL, FALSE);
#line 169 "../src/Export.vala"
	_tmp0_ = export_get_extensions (self, &_tmp1_);
#line 169 "../src/Export.vala"
	_tmp0__length1 = _tmp1_;
#line 169 "../src/Export.vala"
	_tmp2_ = _tmp0_;
#line 169 "../src/Export.vala"
	_tmp2__length1 = _tmp0__length1;
#line 1034 "Export.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 169 "../src/Export.vala"
		extension_collection = _tmp2_;
#line 169 "../src/Export.vala"
		extension_collection_length1 = _tmp2__length1;
#line 169 "../src/Export.vala"
		for (extension_it = 0; extension_it < extension_collection_length1; extension_it = extension_it + 1) {
#line 1046 "Export.c"
			gchar* _tmp3_;
			gchar* extension = NULL;
#line 169 "../src/Export.vala"
			_tmp3_ = g_strdup (extension_collection[extension_it]);
#line 169 "../src/Export.vala"
			extension = _tmp3_;
#line 1053 "Export.c"
			{
				const gchar* _tmp4_;
#line 170 "../src/Export.vala"
				_tmp4_ = extension;
#line 170 "../src/Export.vala"
				if (g_str_has_suffix (fname, _tmp4_)) {
#line 1060 "Export.c"
					gint _tmp5_;
					gint _tmp6_;
					const gchar* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					gchar* _tmp10_;
#line 171 "../src/Export.vala"
					_tmp5_ = strlen (fname);
#line 171 "../src/Export.vala"
					_tmp6_ = _tmp5_;
#line 171 "../src/Export.vala"
					_tmp7_ = extension;
#line 171 "../src/Export.vala"
					_tmp8_ = strlen (_tmp7_);
#line 171 "../src/Export.vala"
					_tmp9_ = _tmp8_;
#line 171 "../src/Export.vala"
					_tmp10_ = string_slice (fname, (glong) 0, (glong) (_tmp6_ - _tmp9_));
#line 171 "../src/Export.vala"
					_g_free0 (_vala_basename);
#line 171 "../src/Export.vala"
					_vala_basename = _tmp10_;
#line 172 "../src/Export.vala"
					result = TRUE;
#line 172 "../src/Export.vala"
					_g_free0 (extension);
#line 172 "../src/Export.vala"
					if (basename) {
#line 172 "../src/Export.vala"
						*basename = _vala_basename;
#line 1091 "Export.c"
					} else {
#line 172 "../src/Export.vala"
						_g_free0 (_vala_basename);
#line 1095 "Export.c"
					}
#line 172 "../src/Export.vala"
					return result;
#line 1099 "Export.c"
				}
#line 169 "../src/Export.vala"
				_g_free0 (extension);
#line 1103 "Export.c"
			}
		}
	}
#line 175 "../src/Export.vala"
	result = FALSE;
#line 175 "../src/Export.vala"
	if (basename) {
#line 175 "../src/Export.vala"
		*basename = _vala_basename;
#line 1113 "Export.c"
	} else {
#line 175 "../src/Export.vala"
		_g_free0 (_vala_basename);
#line 1117 "Export.c"
	}
#line 175 "../src/Export.vala"
	return result;
#line 1121 "Export.c"
}

xmlNode*
export_save (Export* self)
{
	xmlNode* node = NULL;
	xmlNode* _tmp0_;
	const gchar* _tmp1_;
	xmlNode* result;
#line 179 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 180 "../src/Export.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "export");
#line 180 "../src/Export.vala"
	node = _tmp0_;
#line 181 "../src/Export.vala"
	_tmp1_ = self->priv->_name;
#line 181 "../src/Export.vala"
	xmlSetProp (node, (xmlChar*) "name", (xmlChar*) _tmp1_);
#line 182 "../src/Export.vala"
	export_save_settings (self, node);
#line 183 "../src/Export.vala"
	result = node;
#line 183 "../src/Export.vala"
	return result;
#line 1147 "Export.c"
}

void
export_load (Export* self,
             xmlNode* node)
{
#line 187 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/Export.vala"
	export_load_settings (self, node);
#line 1158 "Export.c"
}

const gchar*
export_get_name (Export* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Export.vala"
	_tmp0_ = self->priv->_name;
#line 29 "../src/Export.vala"
	result = _tmp0_;
#line 29 "../src/Export.vala"
	return result;
#line 1174 "Export.c"
}

static void
export_set_name (Export* self,
                 const gchar* value)
{
	gchar* _tmp0_;
#line 29 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Export.vala"
	_tmp0_ = g_strdup (value);
#line 29 "../src/Export.vala"
	_g_free0 (self->priv->_name);
#line 29 "../src/Export.vala"
	self->priv->_name = _tmp0_;
#line 1190 "Export.c"
}

const gchar*
export_get_label (Export* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Export.vala"
	_tmp0_ = self->priv->_label;
#line 30 "../src/Export.vala"
	result = _tmp0_;
#line 30 "../src/Export.vala"
	return result;
#line 1206 "Export.c"
}

static void
export_set_label (Export* self,
                  const gchar* value)
{
	gchar* _tmp0_;
#line 30 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Export.vala"
	_tmp0_ = g_strdup (value);
#line 30 "../src/Export.vala"
	_g_free0 (self->priv->_label);
#line 30 "../src/Export.vala"
	self->priv->_label = _tmp0_;
#line 1222 "Export.c"
}

gchar**
export_get_extensions (Export* self,
                       gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 31 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Export.vala"
	_tmp0_ = self->priv->_extensions;
#line 31 "../src/Export.vala"
	_tmp0__length1 = self->priv->_extensions_length1;
#line 31 "../src/Export.vala"
	_tmp1_ = _tmp0_;
#line 31 "../src/Export.vala"
	_tmp1__length1 = _tmp0__length1;
#line 31 "../src/Export.vala"
	if (result_length1) {
#line 31 "../src/Export.vala"
		*result_length1 = _tmp1__length1;
#line 1248 "Export.c"
	}
#line 31 "../src/Export.vala"
	result = _tmp1_;
#line 31 "../src/Export.vala"
	return result;
#line 1254 "Export.c"
}

static gchar**
_vala_array_dup5 (gchar** self,
                  gssize length)
{
#line 31 "../src/Export.vala"
	if (length >= 0) {
#line 1263 "Export.c"
		gchar** result;
		gssize i;
#line 31 "../src/Export.vala"
		result = g_new0 (gchar*, length + 1);
#line 31 "../src/Export.vala"
		for (i = 0; i < length; i++) {
#line 1270 "Export.c"
			gchar* _tmp0_;
#line 31 "../src/Export.vala"
			_tmp0_ = g_strdup (self[i]);
#line 31 "../src/Export.vala"
			result[i] = _tmp0_;
#line 1276 "Export.c"
		}
#line 31 "../src/Export.vala"
		return result;
#line 1280 "Export.c"
	}
#line 31 "../src/Export.vala"
	return NULL;
#line 1284 "Export.c"
}

static void
export_set_extensions (Export* self,
                       gchar** value,
                       gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 31 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Export.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup5 (value, value_length1) : value;
#line 31 "../src/Export.vala"
	_tmp0__length1 = value_length1;
#line 31 "../src/Export.vala"
	self->priv->_extensions = (_vala_array_free (self->priv->_extensions, self->priv->_extensions_length1, (GDestroyNotify) g_free), NULL);
#line 31 "../src/Export.vala"
	self->priv->_extensions = _tmp0_;
#line 31 "../src/Export.vala"
	self->priv->_extensions_length1 = _tmp0__length1;
#line 31 "../src/Export.vala"
	self->priv->__extensions_size_ = self->priv->_extensions_length1;
#line 1308 "Export.c"
}

gboolean
export_get_importable (Export* self)
{
	gboolean result;
#line 32 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/Export.vala"
	result = self->priv->_importable;
#line 32 "../src/Export.vala"
	return result;
#line 1321 "Export.c"
}

static void
export_set_importable (Export* self,
                       gboolean value)
{
#line 32 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Export.vala"
	self->priv->_importable = value;
#line 1332 "Export.c"
}

gboolean
export_get_exportable (Export* self)
{
	gboolean result;
#line 33 "../src/Export.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/Export.vala"
	result = self->priv->_exportable;
#line 33 "../src/Export.vala"
	return result;
#line 1345 "Export.c"
}

static void
export_set_exportable (Export* self,
                       gboolean value)
{
#line 33 "../src/Export.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Export.vala"
	self->priv->_exportable = value;
#line 1356 "Export.c"
}

static void
value_export_init (GValue* value)
{
#line 25 "../src/Export.vala"
	value->data[0].v_pointer = NULL;
#line 1364 "Export.c"
}

static void
value_export_free_value (GValue* value)
{
#line 25 "../src/Export.vala"
	if (value->data[0].v_pointer) {
#line 25 "../src/Export.vala"
		export_unref (value->data[0].v_pointer);
#line 1374 "Export.c"
	}
}

static void
value_export_copy_value (const GValue* src_value,
                         GValue* dest_value)
{
#line 25 "../src/Export.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "../src/Export.vala"
		dest_value->data[0].v_pointer = export_ref (src_value->data[0].v_pointer);
#line 1386 "Export.c"
	} else {
#line 25 "../src/Export.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1390 "Export.c"
	}
}

static gpointer
value_export_peek_pointer (const GValue* value)
{
#line 25 "../src/Export.vala"
	return value->data[0].v_pointer;
#line 1399 "Export.c"
}

static gchar*
value_export_collect_value (GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
#line 25 "../src/Export.vala"
	if (collect_values[0].v_pointer) {
#line 1410 "Export.c"
		Export * object;
		object = collect_values[0].v_pointer;
#line 25 "../src/Export.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "../src/Export.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1417 "Export.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "../src/Export.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1421 "Export.c"
		}
#line 25 "../src/Export.vala"
		value->data[0].v_pointer = export_ref (object);
#line 1425 "Export.c"
	} else {
#line 25 "../src/Export.vala"
		value->data[0].v_pointer = NULL;
#line 1429 "Export.c"
	}
#line 25 "../src/Export.vala"
	return NULL;
#line 1433 "Export.c"
}

static gchar*
value_export_lcopy_value (const GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
	Export ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "../src/Export.vala"
	if (!object_p) {
#line 25 "../src/Export.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1448 "Export.c"
	}
#line 25 "../src/Export.vala"
	if (!value->data[0].v_pointer) {
#line 25 "../src/Export.vala"
		*object_p = NULL;
#line 1454 "Export.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "../src/Export.vala"
		*object_p = value->data[0].v_pointer;
#line 1458 "Export.c"
	} else {
#line 25 "../src/Export.vala"
		*object_p = export_ref (value->data[0].v_pointer);
#line 1462 "Export.c"
	}
#line 25 "../src/Export.vala"
	return NULL;
#line 1466 "Export.c"
}

GParamSpec*
param_spec_export (const gchar* name,
                   const gchar* nick,
                   const gchar* blurb,
                   GType object_type,
                   GParamFlags flags)
{
	ParamSpecExport* spec;
#line 25 "../src/Export.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_EXPORT), NULL);
#line 25 "../src/Export.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "../src/Export.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "../src/Export.vala"
	return G_PARAM_SPEC (spec);
#line 1485 "Export.c"
}

gpointer
value_get_export (const GValue* value)
{
#line 25 "../src/Export.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_EXPORT), NULL);
#line 25 "../src/Export.vala"
	return value->data[0].v_pointer;
#line 1495 "Export.c"
}

void
value_set_export (GValue* value,
                  gpointer v_object)
{
	Export * old;
#line 25 "../src/Export.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_EXPORT));
#line 25 "../src/Export.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/Export.vala"
	if (v_object) {
#line 25 "../src/Export.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_EXPORT));
#line 25 "../src/Export.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/Export.vala"
		value->data[0].v_pointer = v_object;
#line 25 "../src/Export.vala"
		export_ref (value->data[0].v_pointer);
#line 1517 "Export.c"
	} else {
#line 25 "../src/Export.vala"
		value->data[0].v_pointer = NULL;
#line 1521 "Export.c"
	}
#line 25 "../src/Export.vala"
	if (old) {
#line 25 "../src/Export.vala"
		export_unref (old);
#line 1527 "Export.c"
	}
}

void
value_take_export (GValue* value,
                   gpointer v_object)
{
	Export * old;
#line 25 "../src/Export.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_EXPORT));
#line 25 "../src/Export.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/Export.vala"
	if (v_object) {
#line 25 "../src/Export.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_EXPORT));
#line 25 "../src/Export.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/Export.vala"
		value->data[0].v_pointer = v_object;
#line 1548 "Export.c"
	} else {
#line 25 "../src/Export.vala"
		value->data[0].v_pointer = NULL;
#line 1552 "Export.c"
	}
#line 25 "../src/Export.vala"
	if (old) {
#line 25 "../src/Export.vala"
		export_unref (old);
#line 1558 "Export.c"
	}
}

static void
export_class_init (ExportClass * klass,
                   gpointer klass_data)
{
#line 25 "../src/Export.vala"
	export_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/Export.vala"
	((ExportClass *) klass)->finalize = export_finalize;
#line 25 "../src/Export.vala"
	g_type_class_adjust_private_offset (klass, &Export_private_offset);
#line 25 "../src/Export.vala"
	((ExportClass *) klass)->export = (gboolean (*) (Export*, const gchar*, DrawArea*)) export_real_export;
#line 25 "../src/Export.vala"
	((ExportClass *) klass)->import = (gboolean (*) (Export*, const gchar*, DrawArea*)) export_real_import;
#line 25 "../src/Export.vala"
	((ExportClass *) klass)->add_settings = (void (*) (Export*, GtkGrid*)) export_real_add_settings;
#line 25 "../src/Export.vala"
	((ExportClass *) klass)->save_settings = (void (*) (Export*, xmlNode*)) export_real_save_settings;
#line 25 "../src/Export.vala"
	((ExportClass *) klass)->load_settings = (void (*) (Export*, xmlNode*)) export_real_load_settings;
#line 25 "../src/Export.vala"
	export_signals[EXPORT_SETTINGS_CHANGED_SIGNAL] = g_signal_new ("settings-changed", TYPE_EXPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1584 "Export.c"
}

static void
export_instance_init (Export * self,
                      gpointer klass)
{
#line 25 "../src/Export.vala"
	self->priv = export_get_instance_private (self);
#line 25 "../src/Export.vala"
	self->ref_count = 1;
#line 1595 "Export.c"
}

static void
export_finalize (Export * obj)
{
	Export * self;
#line 25 "../src/Export.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPORT, Export);
#line 25 "../src/Export.vala"
	g_signal_handlers_destroy (self);
#line 27 "../src/Export.vala"
	_g_object_unref0 (self->priv->_settings);
#line 29 "../src/Export.vala"
	_g_free0 (self->priv->_name);
#line 30 "../src/Export.vala"
	_g_free0 (self->priv->_label);
#line 31 "../src/Export.vala"
	self->priv->_extensions = (_vala_array_free (self->priv->_extensions, self->priv->_extensions_length1, (GDestroyNotify) g_free), NULL);
#line 1614 "Export.c"
}

static GType
export_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_export_init, value_export_free_value, value_export_copy_value, value_export_peek_pointer, "p", value_export_collect_value, "p", value_export_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ExportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) export_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Export), 0, (GInstanceInitFunc) export_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType export_type_id;
	export_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Export", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Export_private_offset = g_type_add_instance_private (export_type_id, sizeof (ExportPrivate));
	return export_type_id;
}

GType
export_get_type (void)
{
	static volatile gsize export_type_id__once = 0;
	if (g_once_init_enter (&export_type_id__once)) {
		GType export_type_id;
		export_type_id = export_get_type_once ();
		g_once_init_leave (&export_type_id__once, export_type_id);
	}
	return export_type_id__once;
}

gpointer
export_ref (gpointer instance)
{
	Export * self;
	self = instance;
#line 25 "../src/Export.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "../src/Export.vala"
	return instance;
#line 1650 "Export.c"
}

void
export_unref (gpointer instance)
{
	Export * self;
	self = instance;
#line 25 "../src/Export.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "../src/Export.vala"
		EXPORT_GET_CLASS (self)->finalize (self);
#line 25 "../src/Export.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1664 "Export.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

