/* Layout.c generated by valac 0.56.3, the Vala compiler
 * generated from Layout.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef struct _LayoutPrivate LayoutPrivate;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_BOUNDS (node_bounds_get_type ())
typedef struct _NodeBounds NodeBounds;
enum  {
	LAYOUT_0_PROPERTY,
	LAYOUT_NAME_PROPERTY,
	LAYOUT_ICON_PROPERTY,
	LAYOUT_BALANCEABLE_PROPERTY,
	LAYOUT_NUM_PROPERTIES
};
static GParamSpec* layout_properties[LAYOUT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block21Data Block21Data;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;

struct _NodeBounds {
	gdouble x;
	gdouble y;
	gdouble width;
	gdouble height;
};

struct _Layout {
	GObject parent_instance;
	LayoutPrivate * priv;
	gdouble _rt_gap;
};

struct _LayoutClass {
	GObjectClass parent_class;
	NodeSide (*side_mapping) (Layout* self, NodeSide side);
	void (*initialize) (Layout* self, Node* parent);
	void (*bbox) (Layout* self, Node* parent, gint side_mask, NodeBounds* result);
	void (*adjust_tree) (Layout* self, Node* parent, gint child_index, gint side_mask, gdouble amount);
	void (*adjust_tree_all) (Layout* self, Node* n, NodeBounds* prev, gdouble amount, const gchar* msg);
	void (*propagate_side) (Layout* self, Node* parent, NodeSide side);
	NodeSide (*get_side) (Layout* self, Node* n);
	void (*set_side) (Layout* self, Node* current);
	void (*handle_update_by_edit) (Layout* self, Node* n, gdouble diffw, gdouble diffh);
	void (*handle_update_by_fold) (Layout* self, Node* n);
	gdouble (*get_insert_adjust) (Layout* self, Node* child);
	void (*handle_update_by_insert) (Layout* self, Node* parent, Node* child, gint pos);
	void (*handle_update_by_delete) (Layout* self, Node* parent, gint index, NodeSide side, gdouble size);
	void (*position_root) (Layout* self, Node* last, Node* n);
};

struct _LayoutPrivate {
	gchar* _name;
	gchar* _icon;
	gboolean _balanceable;
};

struct _Block21Data {
	int _ref_count_;
	Layout* self;
	Node* parent;
};

static gint Layout_private_offset;
static gpointer layout_parent_class = NULL;

VALA_EXTERN GType layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Layout, g_object_unref)
VALA_EXTERN GType node_side_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN GType node_bounds_get_type (void) G_GNUC_CONST ;
VALA_EXTERN NodeBounds* node_bounds_dup (const NodeBounds* self);
VALA_EXTERN void node_bounds_free (NodeBounds* self);
VALA_EXTERN NodeSide layout_side_mapping (Layout* self,
                              NodeSide side);
VALA_EXTERN void layout_initialize (Layout* self,
                        Node* parent);
VALA_EXTERN void layout_bbox (Layout* self,
                  Node* parent,
                  gint side_mask,
                  NodeBounds* result);
VALA_EXTERN void layout_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount);
VALA_EXTERN void layout_adjust_tree_all (Layout* self,
                             Node* n,
                             NodeBounds* prev,
                             gdouble amount,
                             const gchar* msg);
VALA_EXTERN void layout_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side);
VALA_EXTERN NodeSide layout_get_side (Layout* self,
                          Node* n);
VALA_EXTERN void layout_set_side (Layout* self,
                      Node* current);
VALA_EXTERN void layout_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh);
VALA_EXTERN void layout_handle_update_by_fold (Layout* self,
                                   Node* n);
VALA_EXTERN gdouble layout_get_insert_adjust (Layout* self,
                                  Node* child);
VALA_EXTERN void layout_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos);
VALA_EXTERN void layout_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size);
VALA_EXTERN void layout_position_root (Layout* self,
                           Node* last,
                           Node* n);
VALA_EXTERN Layout* layout_new (void);
VALA_EXTERN Layout* layout_construct (GType object_type);
static NodeSide layout_real_side_mapping (Layout* self,
                                   NodeSide side);
static void layout_real_initialize (Layout* self,
                             Node* parent);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
VALA_EXTERN GArray* node_children (Node* self);
VALA_EXTERN NodeSide node_get_side (Node* self);
VALA_EXTERN void node_set_side (Node* self,
                    NodeSide value);
static void __lambda38_ (Layout* self,
                  Node* item);
VALA_EXTERN void node_detach (Node* self,
                  NodeSide side);
static void ___lambda38__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda84_ (Block21Data* _data21_,
                  Node* item);
VALA_EXTERN void node_attach_init (Node* self,
                       Node* parent,
                       gint index);
static void ___lambda84__gfunc (gconstpointer data,
                         gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void layout_real_bbox (Layout* self,
                       Node* parent,
                       gint side_mask,
                       NodeBounds* result);
VALA_EXTERN void node_bbox (Node* self,
                gdouble* x,
                gdouble* y,
                gdouble* w,
                gdouble* h);
VALA_EXTERN gboolean node_get_folded (Node* self);
VALA_EXTERN void node_get_tree_bbox (Node* self,
                         NodeBounds * result);
VALA_EXTERN void layout_update_tree_size (Layout* self,
                              Node* n);
VALA_EXTERN void node_set_tree_bbox (Node* self,
                         NodeBounds * value);
VALA_EXTERN gint node_side_horizontal (void);
VALA_EXTERN void node_set_tree_size (Node* self,
                         gdouble value);
VALA_EXTERN gdouble layout_get_adjust (Layout* self,
                           Node* parent);
VALA_EXTERN gdouble node_get_tree_size (Node* self);
static void layout_real_adjust_tree (Layout* self,
                              Node* parent,
                              gint child_index,
                              gint side_mask,
                              gdouble amount);
VALA_EXTERN gdouble node_get_posy (Node* self);
VALA_EXTERN void node_set_posy (Node* self,
                    gdouble value);
VALA_EXTERN gdouble node_get_posx (Node* self);
VALA_EXTERN void node_set_posx (Node* self,
                    gdouble value);
static void layout_real_adjust_tree_all (Layout* self,
                                  Node* n,
                                  NodeBounds* prev,
                                  gdouble amount,
                                  const gchar* msg);
VALA_EXTERN Node* node_get_parent (Node* self);
VALA_EXTERN gint node_index (Node* self);
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN DrawArea* node_get_da (Node* self);
VALA_EXTERN GArray* draw_area_get_nodes (DrawArea* self);
VALA_EXTERN void draw_area_handle_tree_overlap (DrawArea* self,
                                    NodeBounds* prev);
static void layout_real_propagate_side (Layout* self,
                                 Node* parent,
                                 NodeSide side);
VALA_EXTERN gpointer style_ref (gpointer instance);
VALA_EXTERN void style_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_style (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_style (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_style (const GValue* value);
VALA_EXTERN GType style_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Style, style_unref)
VALA_EXTERN Style* node_get_style (Node* self);
VALA_EXTERN gint* style_get_branch_margin (Style* self);
static gint* _int_dup (gint* self);
static NodeSide layout_real_get_side (Layout* self,
                               Node* n);
VALA_EXTERN Node* node_get_root (Node* self);
static void layout_real_set_side (Layout* self,
                           Node* current);
VALA_EXTERN gboolean node_is_root (Node* self);
VALA_EXTERN void layout_apply_margin (Layout* self,
                          Node* n);
VALA_EXTERN gdouble node_task_width (Node* self);
static void layout_real_handle_update_by_edit (Layout* self,
                                        Node* n,
                                        gdouble diffw,
                                        gdouble diffh);
VALA_EXTERN void node_adjust_posy_only (Node* self,
                            gdouble value);
VALA_EXTERN void node_adjust_posx_only (Node* self,
                            gdouble value);
static void layout_real_handle_update_by_fold (Layout* self,
                                        Node* n);
static gdouble layout_real_get_insert_adjust (Layout* self,
                                       Node* child);
static void layout_real_handle_update_by_insert (Layout* self,
                                          Node* parent,
                                          Node* child,
                                          gint pos);
VALA_EXTERN gint node_side_count (Node* self,
                      NodeSide side);
static void layout_real_handle_update_by_delete (Layout* self,
                                          Node* parent,
                                          gint index,
                                          NodeSide side,
                                          gdouble size);
static void layout_real_position_root (Layout* self,
                                Node* last,
                                Node* n);
VALA_EXTERN const gchar* layout_get_name (Layout* self);
VALA_EXTERN void layout_set_name (Layout* self,
                      const gchar* value);
VALA_EXTERN const gchar* layout_get_icon (Layout* self);
VALA_EXTERN void layout_set_icon (Layout* self,
                      const gchar* value);
VALA_EXTERN gboolean layout_get_balanceable (Layout* self);
VALA_EXTERN void layout_set_balanceable (Layout* self,
                             gboolean value);
static void layout_finalize (GObject * obj);
static GType layout_get_type_once (void);
static void _vala_layout_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_layout_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
layout_get_instance_private (Layout* self)
{
	return G_STRUCT_MEMBER_P (self, Layout_private_offset);
}

Layout*
layout_construct (GType object_type)
{
	Layout * self = NULL;
#line 31 "../src/Layout.vala"
	self = (Layout*) g_object_new (object_type, NULL);
#line 31 "../src/Layout.vala"
	return self;
#line 371 "Layout.c"
}

Layout*
layout_new (void)
{
#line 31 "../src/Layout.vala"
	return layout_construct (TYPE_LAYOUT);
#line 379 "Layout.c"
}

static NodeSide
layout_real_side_mapping (Layout* self,
                          NodeSide side)
{
	NodeSide result;
#line 38 "../src/Layout.vala"
	switch (side) {
#line 38 "../src/Layout.vala"
		case NODE_SIDE_LEFT:
#line 391 "Layout.c"
		{
#line 39 "../src/Layout.vala"
			result = NODE_SIDE_LEFT;
#line 39 "../src/Layout.vala"
			return result;
#line 397 "Layout.c"
		}
#line 38 "../src/Layout.vala"
		case NODE_SIDE_RIGHT:
#line 401 "Layout.c"
		{
#line 40 "../src/Layout.vala"
			result = NODE_SIDE_RIGHT;
#line 40 "../src/Layout.vala"
			return result;
#line 407 "Layout.c"
		}
#line 38 "../src/Layout.vala"
		case NODE_SIDE_TOP:
#line 411 "Layout.c"
		{
#line 41 "../src/Layout.vala"
			result = NODE_SIDE_LEFT;
#line 41 "../src/Layout.vala"
			return result;
#line 417 "Layout.c"
		}
#line 38 "../src/Layout.vala"
		case NODE_SIDE_BOTTOM:
#line 421 "Layout.c"
		{
#line 42 "../src/Layout.vala"
			result = NODE_SIDE_RIGHT;
#line 42 "../src/Layout.vala"
			return result;
#line 427 "Layout.c"
		}
		default:
#line 38 "../src/Layout.vala"
		break;
#line 432 "Layout.c"
	}
#line 44 "../src/Layout.vala"
	result = NODE_SIDE_RIGHT;
#line 44 "../src/Layout.vala"
	return result;
#line 438 "Layout.c"
}

NodeSide
layout_side_mapping (Layout* self,
                     NodeSide side)
{
	LayoutClass* _klass_;
#line 37 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 37 "../src/Layout.vala"
	if (_klass_->side_mapping) {
#line 37 "../src/Layout.vala"
		return _klass_->side_mapping (self, side);
#line 454 "Layout.c"
	}
#line 37 "../src/Layout.vala"
	return 0;
#line 458 "Layout.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 48 "../src/Layout.vala"
	return self ? g_object_ref (self) : NULL;
#line 466 "Layout.c"
}

static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 48 "../src/Layout.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 48 "../src/Layout.vala"
	return _data21_;
#line 476 "Layout.c"
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 48 "../src/Layout.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 486 "Layout.c"
		Layout* self;
#line 48 "../src/Layout.vala"
		self = _data21_->self;
#line 48 "../src/Layout.vala"
		_g_object_unref0 (_data21_->parent);
#line 48 "../src/Layout.vala"
		_g_object_unref0 (self);
#line 48 "../src/Layout.vala"
		g_slice_free (Block21Data, _data21_);
#line 496 "Layout.c"
	}
}

static void
__lambda38_ (Layout* self,
             Node* item)
{
	NodeSide _tmp0_;
	NodeSide _tmp1_;
#line 56 "../src/Layout.vala"
	g_return_if_fail (item != NULL);
#line 57 "../src/Layout.vala"
	_tmp0_ = node_get_side (item);
#line 57 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 57 "../src/Layout.vala"
	node_detach (item, _tmp1_);
#line 514 "Layout.c"
}

static void
___lambda38__gfunc (gconstpointer data,
                    gpointer self)
{
#line 56 "../src/Layout.vala"
	__lambda38_ ((Layout*) self, (Node*) data);
#line 523 "Layout.c"
}

static void
__lambda84_ (Block21Data* _data21_,
             Node* item)
{
	Layout* self;
#line 59 "../src/Layout.vala"
	self = _data21_->self;
#line 59 "../src/Layout.vala"
	g_return_if_fail (item != NULL);
#line 60 "../src/Layout.vala"
	node_attach_init (item, _data21_->parent, -1);
#line 537 "Layout.c"
}

static void
___lambda84__gfunc (gconstpointer data,
                    gpointer self)
{
#line 59 "../src/Layout.vala"
	__lambda84_ (self, (Node*) data);
#line 546 "Layout.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 48 "../src/Layout.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 554 "Layout.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 48 "../src/Layout.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 562 "Layout.c"
}

static void
layout_real_initialize (Layout* self,
                        Node* parent)
{
	Block21Data* _data21_;
	Node* _tmp0_;
	GSList* list = NULL;
	GSList* _tmp18_;
	GSList* _tmp19_;
#line 48 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 48 "../src/Layout.vala"
	_data21_ = g_slice_new0 (Block21Data);
#line 48 "../src/Layout.vala"
	_data21_->_ref_count_ = 1;
#line 48 "../src/Layout.vala"
	_data21_->self = g_object_ref (self);
#line 48 "../src/Layout.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 48 "../src/Layout.vala"
	_g_object_unref0 (_data21_->parent);
#line 48 "../src/Layout.vala"
	_data21_->parent = _tmp0_;
#line 49 "../src/Layout.vala"
	list = NULL;
#line 590 "Layout.c"
	{
		gint i = 0;
#line 50 "../src/Layout.vala"
		i = 0;
#line 595 "Layout.c"
		{
			gboolean _tmp1_ = FALSE;
#line 50 "../src/Layout.vala"
			_tmp1_ = TRUE;
#line 50 "../src/Layout.vala"
			while (TRUE) {
#line 602 "Layout.c"
				GArray* _tmp3_;
				GArray* _tmp4_;
				gboolean _tmp5_;
				Node* n = NULL;
				GArray* _tmp6_;
				GArray* _tmp7_;
				Node* _tmp8_;
				Node* _tmp9_;
				Node* _tmp10_;
				Node* _tmp11_;
				Node* _tmp12_;
				Node* _tmp13_;
				NodeSide _tmp14_;
				NodeSide _tmp15_;
				Node* _tmp16_;
				Node* _tmp17_;
#line 50 "../src/Layout.vala"
				if (!_tmp1_) {
#line 621 "Layout.c"
					gint _tmp2_;
#line 50 "../src/Layout.vala"
					_tmp2_ = i;
#line 50 "../src/Layout.vala"
					i = _tmp2_ + 1;
#line 627 "Layout.c"
				}
#line 50 "../src/Layout.vala"
				_tmp1_ = FALSE;
#line 50 "../src/Layout.vala"
				_tmp3_ = node_children (_data21_->parent);
#line 50 "../src/Layout.vala"
				_tmp4_ = _tmp3_;
#line 50 "../src/Layout.vala"
				_tmp5_ = !(((guint) i) < _tmp4_->len);
#line 50 "../src/Layout.vala"
				_g_array_unref0 (_tmp4_);
#line 50 "../src/Layout.vala"
				if (_tmp5_) {
#line 50 "../src/Layout.vala"
					break;
#line 643 "Layout.c"
				}
#line 51 "../src/Layout.vala"
				_tmp6_ = node_children (_data21_->parent);
#line 51 "../src/Layout.vala"
				_tmp7_ = _tmp6_;
#line 51 "../src/Layout.vala"
				_tmp8_ = g_array_index (_tmp7_, Node*, (guint) i);
#line 51 "../src/Layout.vala"
				_tmp9_ = _g_object_ref0 (_tmp8_);
#line 51 "../src/Layout.vala"
				_tmp10_ = _tmp9_;
#line 51 "../src/Layout.vala"
				_g_array_unref0 (_tmp7_);
#line 51 "../src/Layout.vala"
				n = _tmp10_;
#line 52 "../src/Layout.vala"
				_tmp11_ = n;
#line 52 "../src/Layout.vala"
				layout_initialize (self, _tmp11_);
#line 53 "../src/Layout.vala"
				_tmp12_ = n;
#line 53 "../src/Layout.vala"
				_tmp13_ = n;
#line 53 "../src/Layout.vala"
				_tmp14_ = node_get_side (_tmp13_);
#line 53 "../src/Layout.vala"
				_tmp15_ = _tmp14_;
#line 53 "../src/Layout.vala"
				node_set_side (_tmp12_, layout_side_mapping (self, _tmp15_));
#line 54 "../src/Layout.vala"
				_tmp16_ = n;
#line 54 "../src/Layout.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 54 "../src/Layout.vala"
				list = g_slist_append (list, _tmp17_);
#line 50 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 681 "Layout.c"
			}
		}
	}
#line 56 "../src/Layout.vala"
	_tmp18_ = list;
#line 56 "../src/Layout.vala"
	g_slist_foreach (_tmp18_, ___lambda38__gfunc, self);
#line 59 "../src/Layout.vala"
	_tmp19_ = list;
#line 59 "../src/Layout.vala"
	g_slist_foreach (_tmp19_, ___lambda84__gfunc, _data21_);
#line 48 "../src/Layout.vala"
	(list == NULL) ? NULL : (list = (_g_slist_free__g_object_unref0_ (list), NULL));
#line 48 "../src/Layout.vala"
	block21_data_unref (_data21_);
#line 48 "../src/Layout.vala"
	_data21_ = NULL;
#line 699 "Layout.c"
}

void
layout_initialize (Layout* self,
                   Node* parent)
{
	LayoutClass* _klass_;
#line 48 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 48 "../src/Layout.vala"
	if (_klass_->initialize) {
#line 48 "../src/Layout.vala"
		_klass_->initialize (self, parent);
#line 715 "Layout.c"
	}
}

static void
layout_real_bbox (Layout* self,
                  Node* parent,
                  gint side_mask,
                  NodeBounds* result)
{
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	guint num_children = 0U;
	GArray* _tmp1_;
	GArray* _tmp2_;
	guint _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble x2 = 0.0;
	NodeBounds _tmp8_;
	NodeBounds _tmp9_;
	gdouble y2 = 0.0;
	NodeBounds _tmp10_;
	NodeBounds _tmp11_;
	gboolean _tmp12_ = FALSE;
	NodeBounds _tmp52_;
	NodeBounds _tmp53_;
#line 65 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 67 "../src/Layout.vala"
	_tmp0_.x = (gdouble) 0;
#line 67 "../src/Layout.vala"
	_tmp0_.y = (gdouble) 0;
#line 67 "../src/Layout.vala"
	_tmp0_.width = (gdouble) 0;
#line 67 "../src/Layout.vala"
	_tmp0_.height = (gdouble) 0;
#line 67 "../src/Layout.vala"
	nb = _tmp0_;
#line 68 "../src/Layout.vala"
	_tmp1_ = node_children (parent);
#line 68 "../src/Layout.vala"
	_tmp2_ = _tmp1_;
#line 68 "../src/Layout.vala"
	_tmp3_ = _tmp2_->len;
#line 68 "../src/Layout.vala"
	_g_array_unref0 (_tmp2_);
#line 68 "../src/Layout.vala"
	num_children = _tmp3_;
#line 70 "../src/Layout.vala"
	node_bbox (parent, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 70 "../src/Layout.vala"
	nb.x = _tmp4_;
#line 70 "../src/Layout.vala"
	nb.y = _tmp5_;
#line 70 "../src/Layout.vala"
	nb.width = _tmp6_;
#line 70 "../src/Layout.vala"
	nb.height = _tmp7_;
#line 72 "../src/Layout.vala"
	_tmp8_ = nb;
#line 72 "../src/Layout.vala"
	_tmp9_ = nb;
#line 72 "../src/Layout.vala"
	x2 = _tmp8_.x + _tmp9_.width;
#line 73 "../src/Layout.vala"
	_tmp10_ = nb;
#line 73 "../src/Layout.vala"
	_tmp11_ = nb;
#line 73 "../src/Layout.vala"
	y2 = _tmp10_.y + _tmp11_.height;
#line 75 "../src/Layout.vala"
	if (num_children != ((guint) 0)) {
#line 790 "Layout.c"
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 75 "../src/Layout.vala"
		_tmp13_ = node_get_folded (parent);
#line 75 "../src/Layout.vala"
		_tmp14_ = _tmp13_;
#line 75 "../src/Layout.vala"
		_tmp12_ = !_tmp14_;
#line 799 "Layout.c"
	} else {
#line 75 "../src/Layout.vala"
		_tmp12_ = FALSE;
#line 803 "Layout.c"
	}
#line 75 "../src/Layout.vala"
	if (_tmp12_) {
#line 807 "Layout.c"
		{
			gint i = 0;
#line 76 "../src/Layout.vala"
			i = 0;
#line 812 "Layout.c"
			{
				gboolean _tmp15_ = FALSE;
#line 76 "../src/Layout.vala"
				_tmp15_ = TRUE;
#line 76 "../src/Layout.vala"
				while (TRUE) {
#line 819 "Layout.c"
					GArray* _tmp17_;
					GArray* _tmp18_;
					gboolean _tmp19_;
					GArray* _tmp20_;
					GArray* _tmp21_;
					Node* _tmp22_;
					NodeSide _tmp23_;
					NodeSide _tmp24_;
					gboolean _tmp25_;
#line 76 "../src/Layout.vala"
					if (!_tmp15_) {
#line 831 "Layout.c"
						gint _tmp16_;
#line 76 "../src/Layout.vala"
						_tmp16_ = i;
#line 76 "../src/Layout.vala"
						i = _tmp16_ + 1;
#line 837 "Layout.c"
					}
#line 76 "../src/Layout.vala"
					_tmp15_ = FALSE;
#line 76 "../src/Layout.vala"
					_tmp17_ = node_children (parent);
#line 76 "../src/Layout.vala"
					_tmp18_ = _tmp17_;
#line 76 "../src/Layout.vala"
					_tmp19_ = !(((guint) i) < _tmp18_->len);
#line 76 "../src/Layout.vala"
					_g_array_unref0 (_tmp18_);
#line 76 "../src/Layout.vala"
					if (_tmp19_) {
#line 76 "../src/Layout.vala"
						break;
#line 853 "Layout.c"
					}
#line 77 "../src/Layout.vala"
					_tmp20_ = node_children (parent);
#line 77 "../src/Layout.vala"
					_tmp21_ = _tmp20_;
#line 77 "../src/Layout.vala"
					_tmp22_ = g_array_index (_tmp21_, Node*, (guint) i);
#line 77 "../src/Layout.vala"
					_tmp23_ = node_get_side (_tmp22_);
#line 77 "../src/Layout.vala"
					_tmp24_ = _tmp23_;
#line 77 "../src/Layout.vala"
					_tmp25_ = (_tmp24_ & side_mask) != 0;
#line 77 "../src/Layout.vala"
					_g_array_unref0 (_tmp21_);
#line 77 "../src/Layout.vala"
					if (_tmp25_) {
#line 871 "Layout.c"
						NodeBounds cb = {0};
						GArray* _tmp26_;
						GArray* _tmp27_;
						Node* _tmp28_;
						NodeBounds _tmp29_ = {0};
						NodeBounds _tmp30_;
						NodeBounds _tmp31_;
						gdouble _tmp32_ = 0.0;
						NodeBounds _tmp33_;
						NodeBounds _tmp34_;
						gdouble _tmp37_ = 0.0;
						NodeBounds _tmp38_;
						NodeBounds _tmp39_;
						gdouble _tmp42_ = 0.0;
						NodeBounds _tmp43_;
						NodeBounds _tmp44_;
						gdouble _tmp47_ = 0.0;
						NodeBounds _tmp48_;
						NodeBounds _tmp49_;
#line 78 "../src/Layout.vala"
						_tmp26_ = node_children (parent);
#line 78 "../src/Layout.vala"
						_tmp27_ = _tmp26_;
#line 78 "../src/Layout.vala"
						_tmp28_ = g_array_index (_tmp27_, Node*, (guint) i);
#line 78 "../src/Layout.vala"
						node_get_tree_bbox (_tmp28_, &_tmp29_);
#line 78 "../src/Layout.vala"
						_tmp30_ = _tmp29_;
#line 78 "../src/Layout.vala"
						_tmp31_ = _tmp30_;
#line 78 "../src/Layout.vala"
						_g_array_unref0 (_tmp27_);
#line 78 "../src/Layout.vala"
						cb = _tmp31_;
#line 79 "../src/Layout.vala"
						_tmp33_ = nb;
#line 79 "../src/Layout.vala"
						_tmp34_ = cb;
#line 79 "../src/Layout.vala"
						if (_tmp33_.x < _tmp34_.x) {
#line 913 "Layout.c"
							NodeBounds _tmp35_;
#line 79 "../src/Layout.vala"
							_tmp35_ = nb;
#line 79 "../src/Layout.vala"
							_tmp32_ = _tmp35_.x;
#line 919 "Layout.c"
						} else {
							NodeBounds _tmp36_;
#line 79 "../src/Layout.vala"
							_tmp36_ = cb;
#line 79 "../src/Layout.vala"
							_tmp32_ = _tmp36_.x;
#line 926 "Layout.c"
						}
#line 79 "../src/Layout.vala"
						nb.x = _tmp32_;
#line 80 "../src/Layout.vala"
						_tmp38_ = nb;
#line 80 "../src/Layout.vala"
						_tmp39_ = cb;
#line 80 "../src/Layout.vala"
						if (_tmp38_.y < _tmp39_.y) {
#line 936 "Layout.c"
							NodeBounds _tmp40_;
#line 80 "../src/Layout.vala"
							_tmp40_ = nb;
#line 80 "../src/Layout.vala"
							_tmp37_ = _tmp40_.y;
#line 942 "Layout.c"
						} else {
							NodeBounds _tmp41_;
#line 80 "../src/Layout.vala"
							_tmp41_ = cb;
#line 80 "../src/Layout.vala"
							_tmp37_ = _tmp41_.y;
#line 949 "Layout.c"
						}
#line 80 "../src/Layout.vala"
						nb.y = _tmp37_;
#line 81 "../src/Layout.vala"
						_tmp43_ = cb;
#line 81 "../src/Layout.vala"
						_tmp44_ = cb;
#line 81 "../src/Layout.vala"
						if (x2 < (_tmp43_.x + _tmp44_.width)) {
#line 959 "Layout.c"
							NodeBounds _tmp45_;
							NodeBounds _tmp46_;
#line 81 "../src/Layout.vala"
							_tmp45_ = cb;
#line 81 "../src/Layout.vala"
							_tmp46_ = cb;
#line 81 "../src/Layout.vala"
							_tmp42_ = _tmp45_.x + _tmp46_.width;
#line 968 "Layout.c"
						} else {
#line 81 "../src/Layout.vala"
							_tmp42_ = x2;
#line 972 "Layout.c"
						}
#line 81 "../src/Layout.vala"
						x2 = _tmp42_;
#line 82 "../src/Layout.vala"
						_tmp48_ = cb;
#line 82 "../src/Layout.vala"
						_tmp49_ = cb;
#line 82 "../src/Layout.vala"
						if (y2 < (_tmp48_.y + _tmp49_.height)) {
#line 982 "Layout.c"
							NodeBounds _tmp50_;
							NodeBounds _tmp51_;
#line 82 "../src/Layout.vala"
							_tmp50_ = cb;
#line 82 "../src/Layout.vala"
							_tmp51_ = cb;
#line 82 "../src/Layout.vala"
							_tmp47_ = _tmp50_.y + _tmp51_.height;
#line 991 "Layout.c"
						} else {
#line 82 "../src/Layout.vala"
							_tmp47_ = y2;
#line 995 "Layout.c"
						}
#line 82 "../src/Layout.vala"
						y2 = _tmp47_;
#line 999 "Layout.c"
					}
				}
			}
		}
	}
#line 87 "../src/Layout.vala"
	_tmp52_ = nb;
#line 87 "../src/Layout.vala"
	nb.width = x2 - _tmp52_.x;
#line 88 "../src/Layout.vala"
	_tmp53_ = nb;
#line 88 "../src/Layout.vala"
	nb.height = y2 - _tmp53_.y;
#line 90 "../src/Layout.vala"
	*result = nb;
#line 90 "../src/Layout.vala"
	return;
#line 1017 "Layout.c"
}

void
layout_bbox (Layout* self,
             Node* parent,
             gint side_mask,
             NodeBounds* result)
{
	LayoutClass* _klass_;
#line 65 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 65 "../src/Layout.vala"
	if (_klass_->bbox) {
#line 65 "../src/Layout.vala"
		_klass_->bbox (self, parent, side_mask, result);
#line 1035 "Layout.c"
	}
}

void
layout_update_tree_size (Layout* self,
                         Node* n)
{
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gdouble _tmp2_ = 0.0;
	NodeSide _tmp3_;
	NodeSide _tmp4_;
#line 95 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 98 "../src/Layout.vala"
	layout_bbox (self, n, -1, &_tmp0_);
#line 98 "../src/Layout.vala"
	nb = _tmp0_;
#line 101 "../src/Layout.vala"
	_tmp1_ = nb;
#line 101 "../src/Layout.vala"
	node_set_tree_bbox (n, &_tmp1_);
#line 104 "../src/Layout.vala"
	_tmp3_ = node_get_side (n);
#line 104 "../src/Layout.vala"
	_tmp4_ = _tmp3_;
#line 104 "../src/Layout.vala"
	if ((_tmp4_ & node_side_horizontal ()) != 0) {
#line 1067 "Layout.c"
		NodeBounds _tmp5_;
#line 104 "../src/Layout.vala"
		_tmp5_ = nb;
#line 104 "../src/Layout.vala"
		_tmp2_ = _tmp5_.height;
#line 1073 "Layout.c"
	} else {
		NodeBounds _tmp6_;
#line 104 "../src/Layout.vala"
		_tmp6_ = nb;
#line 104 "../src/Layout.vala"
		_tmp2_ = _tmp6_.width;
#line 1080 "Layout.c"
	}
#line 104 "../src/Layout.vala"
	node_set_tree_size (n, _tmp2_);
#line 1084 "Layout.c"
}

gdouble
layout_get_adjust (Layout* self,
                   Node* parent)
{
	gdouble orig_tree_size = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 112 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 112 "../src/Layout.vala"
	g_return_val_if_fail (parent != NULL, 0.0);
#line 114 "../src/Layout.vala"
	_tmp0_ = node_get_tree_size (parent);
#line 114 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 114 "../src/Layout.vala"
	orig_tree_size = _tmp1_;
#line 116 "../src/Layout.vala"
	layout_update_tree_size (self, parent);
#line 118 "../src/Layout.vala"
	if (orig_tree_size == ((gdouble) 0)) {
#line 118 "../src/Layout.vala"
		_tmp2_ = (gdouble) 0;
#line 1112 "Layout.c"
	} else {
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 118 "../src/Layout.vala"
		_tmp3_ = node_get_tree_size (parent);
#line 118 "../src/Layout.vala"
		_tmp4_ = _tmp3_;
#line 118 "../src/Layout.vala"
		_tmp2_ = _tmp4_ - orig_tree_size;
#line 1122 "Layout.c"
	}
#line 118 "../src/Layout.vala"
	result = _tmp2_;
#line 118 "../src/Layout.vala"
	return result;
#line 1128 "Layout.c"
}

static void
layout_real_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount)
{
#line 123 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 1140 "Layout.c"
	{
		gint i = 0;
#line 125 "../src/Layout.vala"
		i = 0;
#line 1145 "Layout.c"
		{
			gboolean _tmp0_ = FALSE;
#line 125 "../src/Layout.vala"
			_tmp0_ = TRUE;
#line 125 "../src/Layout.vala"
			while (TRUE) {
#line 1152 "Layout.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				gboolean _tmp4_;
#line 125 "../src/Layout.vala"
				if (!_tmp0_) {
#line 1158 "Layout.c"
					gint _tmp1_;
#line 125 "../src/Layout.vala"
					_tmp1_ = i;
#line 125 "../src/Layout.vala"
					i = _tmp1_ + 1;
#line 1164 "Layout.c"
				}
#line 125 "../src/Layout.vala"
				_tmp0_ = FALSE;
#line 125 "../src/Layout.vala"
				_tmp2_ = node_children (parent);
#line 125 "../src/Layout.vala"
				_tmp3_ = _tmp2_;
#line 125 "../src/Layout.vala"
				_tmp4_ = !(((guint) i) < _tmp3_->len);
#line 125 "../src/Layout.vala"
				_g_array_unref0 (_tmp3_);
#line 125 "../src/Layout.vala"
				if (_tmp4_) {
#line 125 "../src/Layout.vala"
					break;
#line 1180 "Layout.c"
				}
#line 126 "../src/Layout.vala"
				if (i != child_index) {
#line 1184 "Layout.c"
					Node* n = NULL;
					GArray* _tmp5_;
					GArray* _tmp6_;
					Node* _tmp7_;
					Node* _tmp8_;
					Node* _tmp9_;
					Node* _tmp10_;
					NodeSide _tmp11_;
					NodeSide _tmp12_;
#line 127 "../src/Layout.vala"
					_tmp5_ = node_children (parent);
#line 127 "../src/Layout.vala"
					_tmp6_ = _tmp5_;
#line 127 "../src/Layout.vala"
					_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
#line 127 "../src/Layout.vala"
					_tmp8_ = _g_object_ref0 (_tmp7_);
#line 127 "../src/Layout.vala"
					_tmp9_ = _tmp8_;
#line 127 "../src/Layout.vala"
					_g_array_unref0 (_tmp6_);
#line 127 "../src/Layout.vala"
					n = _tmp9_;
#line 128 "../src/Layout.vala"
					_tmp10_ = n;
#line 128 "../src/Layout.vala"
					_tmp11_ = node_get_side (_tmp10_);
#line 128 "../src/Layout.vala"
					_tmp12_ = _tmp11_;
#line 128 "../src/Layout.vala"
					if ((_tmp12_ & side_mask) != 0) {
#line 1216 "Layout.c"
						Node* _tmp13_;
						NodeSide _tmp14_;
						NodeSide _tmp15_;
#line 129 "../src/Layout.vala"
						_tmp13_ = n;
#line 129 "../src/Layout.vala"
						_tmp14_ = node_get_side (_tmp13_);
#line 129 "../src/Layout.vala"
						_tmp15_ = _tmp14_;
#line 129 "../src/Layout.vala"
						if ((_tmp15_ & node_side_horizontal ()) != 0) {
#line 1228 "Layout.c"
							Node* _tmp16_;
							Node* _tmp17_;
							gdouble _tmp18_;
							gdouble _tmp19_;
#line 130 "../src/Layout.vala"
							_tmp16_ = n;
#line 130 "../src/Layout.vala"
							_tmp17_ = n;
#line 130 "../src/Layout.vala"
							_tmp18_ = node_get_posy (_tmp17_);
#line 130 "../src/Layout.vala"
							_tmp19_ = _tmp18_;
#line 130 "../src/Layout.vala"
							node_set_posy (_tmp17_, _tmp19_ + amount);
#line 1243 "Layout.c"
						} else {
							Node* _tmp20_;
							Node* _tmp21_;
							gdouble _tmp22_;
							gdouble _tmp23_;
#line 132 "../src/Layout.vala"
							_tmp20_ = n;
#line 132 "../src/Layout.vala"
							_tmp21_ = n;
#line 132 "../src/Layout.vala"
							_tmp22_ = node_get_posx (_tmp21_);
#line 132 "../src/Layout.vala"
							_tmp23_ = _tmp22_;
#line 132 "../src/Layout.vala"
							node_set_posx (_tmp21_, _tmp23_ + amount);
#line 1259 "Layout.c"
						}
					}
#line 126 "../src/Layout.vala"
					_g_object_unref0 (n);
#line 1264 "Layout.c"
				} else {
#line 136 "../src/Layout.vala"
					amount = 0 - amount;
#line 1268 "Layout.c"
				}
			}
		}
	}
}

void
layout_adjust_tree (Layout* self,
                    Node* parent,
                    gint child_index,
                    gint side_mask,
                    gdouble amount)
{
	LayoutClass* _klass_;
#line 123 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 123 "../src/Layout.vala"
	if (_klass_->adjust_tree) {
#line 123 "../src/Layout.vala"
		_klass_->adjust_tree (self, parent, child_index, side_mask, amount);
#line 1291 "Layout.c"
	}
}

static void
layout_real_adjust_tree_all (Layout* self,
                             Node* n,
                             NodeBounds* prev,
                             gdouble amount,
                             const gchar* msg)
{
	Node* parent = NULL;
	Node* _tmp0_;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* last = NULL;
	Node* _tmp3_;
	gint index = 0;
	GArray* nodes = NULL;
	DrawArea* _tmp4_;
	DrawArea* _tmp5_;
	GArray* _tmp6_;
#line 143 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 143 "../src/Layout.vala"
	g_return_if_fail (prev != NULL);
#line 143 "../src/Layout.vala"
	g_return_if_fail (msg != NULL);
#line 145 "../src/Layout.vala"
	_tmp0_ = node_get_parent (n);
#line 145 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 145 "../src/Layout.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 145 "../src/Layout.vala"
	parent = _tmp2_;
#line 146 "../src/Layout.vala"
	_tmp3_ = _g_object_ref0 (n);
#line 146 "../src/Layout.vala"
	last = _tmp3_;
#line 147 "../src/Layout.vala"
	index = node_index (n);
#line 148 "../src/Layout.vala"
	_tmp4_ = node_get_da (n);
#line 148 "../src/Layout.vala"
	_tmp5_ = _tmp4_;
#line 148 "../src/Layout.vala"
	_tmp6_ = draw_area_get_nodes (_tmp5_);
#line 148 "../src/Layout.vala"
	nodes = _tmp6_;
#line 150 "../src/Layout.vala"
	while (TRUE) {
#line 1343 "Layout.c"
		Node* _tmp7_;
		Node* _tmp8_;
		NodeSide _tmp9_;
		NodeSide _tmp10_;
		Node* _tmp11_;
		NodeBounds _tmp12_ = {0};
		NodeBounds _tmp13_;
		Node* _tmp14_;
		Node* _tmp15_;
		Node* _tmp16_;
		Node* _tmp17_;
		Node* _tmp18_;
		Node* _tmp19_;
		Node* _tmp20_;
		Node* _tmp21_;
#line 150 "../src/Layout.vala"
		_tmp7_ = parent;
#line 150 "../src/Layout.vala"
		if (!(_tmp7_ != NULL)) {
#line 150 "../src/Layout.vala"
			break;
#line 1365 "Layout.c"
		}
#line 151 "../src/Layout.vala"
		_tmp8_ = parent;
#line 151 "../src/Layout.vala"
		_tmp9_ = node_get_side (n);
#line 151 "../src/Layout.vala"
		_tmp10_ = _tmp9_;
#line 151 "../src/Layout.vala"
		layout_adjust_tree (self, _tmp8_, index, (gint) _tmp10_, amount);
#line 152 "../src/Layout.vala"
		_tmp11_ = parent;
#line 152 "../src/Layout.vala"
		node_get_tree_bbox (_tmp11_, &_tmp12_);
#line 152 "../src/Layout.vala"
		_tmp13_ = _tmp12_;
#line 152 "../src/Layout.vala"
		*prev = _tmp13_;
#line 153 "../src/Layout.vala"
		_tmp14_ = parent;
#line 153 "../src/Layout.vala"
		amount = 0 - (layout_get_adjust (self, _tmp14_) / 2);
#line 154 "../src/Layout.vala"
		_tmp15_ = parent;
#line 154 "../src/Layout.vala"
		index = node_index (_tmp15_);
#line 155 "../src/Layout.vala"
		_tmp16_ = parent;
#line 155 "../src/Layout.vala"
		_tmp17_ = _g_object_ref0 (_tmp16_);
#line 155 "../src/Layout.vala"
		_g_object_unref0 (last);
#line 155 "../src/Layout.vala"
		last = _tmp17_;
#line 156 "../src/Layout.vala"
		_tmp18_ = parent;
#line 156 "../src/Layout.vala"
		_tmp19_ = node_get_parent (_tmp18_);
#line 156 "../src/Layout.vala"
		_tmp20_ = _tmp19_;
#line 156 "../src/Layout.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 156 "../src/Layout.vala"
		_g_object_unref0 (parent);
#line 156 "../src/Layout.vala"
		parent = _tmp21_;
#line 1411 "Layout.c"
	}
	{
		gint i = 0;
#line 159 "../src/Layout.vala"
		i = 0;
#line 1417 "Layout.c"
		{
			gboolean _tmp22_ = FALSE;
#line 159 "../src/Layout.vala"
			_tmp22_ = TRUE;
#line 159 "../src/Layout.vala"
			while (TRUE) {
#line 1424 "Layout.c"
				GArray* _tmp24_;
				GArray* _tmp25_;
				Node* _tmp26_;
				Node* _tmp27_;
#line 159 "../src/Layout.vala"
				if (!_tmp22_) {
#line 1431 "Layout.c"
					gint _tmp23_;
#line 159 "../src/Layout.vala"
					_tmp23_ = i;
#line 159 "../src/Layout.vala"
					i = _tmp23_ + 1;
#line 1437 "Layout.c"
				}
#line 159 "../src/Layout.vala"
				_tmp22_ = FALSE;
#line 159 "../src/Layout.vala"
				_tmp24_ = nodes;
#line 159 "../src/Layout.vala"
				if (!(((guint) i) < _tmp24_->len)) {
#line 159 "../src/Layout.vala"
					break;
#line 1447 "Layout.c"
				}
#line 160 "../src/Layout.vala"
				_tmp25_ = nodes;
#line 160 "../src/Layout.vala"
				_tmp26_ = g_array_index (_tmp25_, Node*, (guint) i);
#line 160 "../src/Layout.vala"
				_tmp27_ = last;
#line 160 "../src/Layout.vala"
				if (_tmp26_ == _tmp27_) {
#line 1457 "Layout.c"
					DrawArea* _tmp28_;
					DrawArea* _tmp29_;
					NodeBounds _tmp30_;
#line 161 "../src/Layout.vala"
					_tmp28_ = node_get_da (n);
#line 161 "../src/Layout.vala"
					_tmp29_ = _tmp28_;
#line 161 "../src/Layout.vala"
					_tmp30_ = *prev;
#line 161 "../src/Layout.vala"
					draw_area_handle_tree_overlap (_tmp29_, &_tmp30_);
#line 1469 "Layout.c"
				}
			}
		}
	}
#line 143 "../src/Layout.vala"
	_g_array_unref0 (nodes);
#line 143 "../src/Layout.vala"
	_g_object_unref0 (last);
#line 143 "../src/Layout.vala"
	_g_object_unref0 (parent);
#line 1480 "Layout.c"
}

void
layout_adjust_tree_all (Layout* self,
                        Node* n,
                        NodeBounds* prev,
                        gdouble amount,
                        const gchar* msg)
{
	LayoutClass* _klass_;
#line 143 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 143 "../src/Layout.vala"
	if (_klass_->adjust_tree_all) {
#line 143 "../src/Layout.vala"
		_klass_->adjust_tree_all (self, n, prev, amount, msg);
#line 1499 "Layout.c"
	}
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 171 "../src/Layout.vala"
	dup = g_new0 (gint, 1);
#line 171 "../src/Layout.vala"
	memcpy (dup, self, sizeof (gint));
#line 171 "../src/Layout.vala"
	return dup;
#line 1513 "Layout.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 171 "../src/Layout.vala"
	return self ? _int_dup (self) : NULL;
#line 1521 "Layout.c"
}

static void
layout_real_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side)
{
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	gint* margin = NULL;
	Style* _tmp0_;
	Style* _tmp1_;
	gint* _tmp2_;
	gint* _tmp3_;
	gint* _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
#line 168 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 171 "../src/Layout.vala"
	_tmp0_ = node_get_style (parent);
#line 171 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 171 "../src/Layout.vala"
	_tmp2_ = style_get_branch_margin (_tmp1_);
#line 171 "../src/Layout.vala"
	_tmp3_ = _tmp2_;
#line 171 "../src/Layout.vala"
	_tmp4_ = __int_dup0 (_tmp3_);
#line 171 "../src/Layout.vala"
	margin = _tmp4_;
#line 173 "../src/Layout.vala"
	node_bbox (parent, &_tmp5_, &_tmp6_, &_tmp7_, &_tmp8_);
#line 173 "../src/Layout.vala"
	px = _tmp5_;
#line 173 "../src/Layout.vala"
	py = _tmp6_;
#line 173 "../src/Layout.vala"
	pw = _tmp7_;
#line 173 "../src/Layout.vala"
	ph = _tmp8_;
#line 1567 "Layout.c"
	{
		gint i = 0;
#line 175 "../src/Layout.vala"
		i = 0;
#line 1572 "Layout.c"
		{
			gboolean _tmp9_ = FALSE;
#line 175 "../src/Layout.vala"
			_tmp9_ = TRUE;
#line 175 "../src/Layout.vala"
			while (TRUE) {
#line 1579 "Layout.c"
				GArray* _tmp11_;
				GArray* _tmp12_;
				gboolean _tmp13_;
				Node* n = NULL;
				GArray* _tmp14_;
				GArray* _tmp15_;
				Node* _tmp16_;
				Node* _tmp17_;
				Node* _tmp18_;
				Node* _tmp19_;
				NodeSide _tmp20_;
				NodeSide _tmp21_;
#line 175 "../src/Layout.vala"
				if (!_tmp9_) {
#line 1594 "Layout.c"
					gint _tmp10_;
#line 175 "../src/Layout.vala"
					_tmp10_ = i;
#line 175 "../src/Layout.vala"
					i = _tmp10_ + 1;
#line 1600 "Layout.c"
				}
#line 175 "../src/Layout.vala"
				_tmp9_ = FALSE;
#line 175 "../src/Layout.vala"
				_tmp11_ = node_children (parent);
#line 175 "../src/Layout.vala"
				_tmp12_ = _tmp11_;
#line 175 "../src/Layout.vala"
				_tmp13_ = !(((guint) i) < _tmp12_->len);
#line 175 "../src/Layout.vala"
				_g_array_unref0 (_tmp12_);
#line 175 "../src/Layout.vala"
				if (_tmp13_) {
#line 175 "../src/Layout.vala"
					break;
#line 1616 "Layout.c"
				}
#line 176 "../src/Layout.vala"
				_tmp14_ = node_children (parent);
#line 176 "../src/Layout.vala"
				_tmp15_ = _tmp14_;
#line 176 "../src/Layout.vala"
				_tmp16_ = g_array_index (_tmp15_, Node*, (guint) i);
#line 176 "../src/Layout.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 176 "../src/Layout.vala"
				_tmp18_ = _tmp17_;
#line 176 "../src/Layout.vala"
				_g_array_unref0 (_tmp15_);
#line 176 "../src/Layout.vala"
				n = _tmp18_;
#line 177 "../src/Layout.vala"
				_tmp19_ = n;
#line 177 "../src/Layout.vala"
				_tmp20_ = node_get_side (_tmp19_);
#line 177 "../src/Layout.vala"
				_tmp21_ = _tmp20_;
#line 177 "../src/Layout.vala"
				if (_tmp21_ != side) {
#line 1640 "Layout.c"
					Node* _tmp22_;
					Node* _tmp41_;
#line 178 "../src/Layout.vala"
					_tmp22_ = n;
#line 178 "../src/Layout.vala"
					node_set_side (_tmp22_, side);
#line 179 "../src/Layout.vala"
					switch (side) {
#line 179 "../src/Layout.vala"
						case NODE_SIDE_LEFT:
#line 1651 "Layout.c"
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp23_;
							gdouble _tmp24_ = 0.0;
							gdouble _tmp25_ = 0.0;
							gdouble _tmp26_ = 0.0;
							gdouble _tmp27_ = 0.0;
							Node* _tmp28_;
							gint* _tmp29_;
#line 182 "../src/Layout.vala"
							_tmp23_ = n;
#line 182 "../src/Layout.vala"
							node_bbox (_tmp23_, &_tmp24_, &_tmp25_, &_tmp26_, &_tmp27_);
#line 182 "../src/Layout.vala"
							cx = _tmp24_;
#line 182 "../src/Layout.vala"
							cy = _tmp25_;
#line 182 "../src/Layout.vala"
							cw = _tmp26_;
#line 182 "../src/Layout.vala"
							ch = _tmp27_;
#line 183 "../src/Layout.vala"
							_tmp28_ = n;
#line 183 "../src/Layout.vala"
							_tmp29_ = margin;
#line 183 "../src/Layout.vala"
							node_set_posx (_tmp28_, (px - (*_tmp29_)) - cw);
#line 184 "../src/Layout.vala"
							break;
#line 1684 "Layout.c"
						}
#line 179 "../src/Layout.vala"
						case NODE_SIDE_RIGHT:
#line 1688 "Layout.c"
						{
							Node* _tmp30_;
							gint* _tmp31_;
#line 186 "../src/Layout.vala"
							_tmp30_ = n;
#line 186 "../src/Layout.vala"
							_tmp31_ = margin;
#line 186 "../src/Layout.vala"
							node_set_posx (_tmp30_, (px + pw) + (*_tmp31_));
#line 187 "../src/Layout.vala"
							break;
#line 1700 "Layout.c"
						}
#line 179 "../src/Layout.vala"
						case NODE_SIDE_TOP:
#line 1704 "Layout.c"
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp32_;
							gdouble _tmp33_ = 0.0;
							gdouble _tmp34_ = 0.0;
							gdouble _tmp35_ = 0.0;
							gdouble _tmp36_ = 0.0;
							Node* _tmp37_;
							gint* _tmp38_;
#line 190 "../src/Layout.vala"
							_tmp32_ = n;
#line 190 "../src/Layout.vala"
							node_bbox (_tmp32_, &_tmp33_, &_tmp34_, &_tmp35_, &_tmp36_);
#line 190 "../src/Layout.vala"
							cx = _tmp33_;
#line 190 "../src/Layout.vala"
							cy = _tmp34_;
#line 190 "../src/Layout.vala"
							cw = _tmp35_;
#line 190 "../src/Layout.vala"
							ch = _tmp36_;
#line 191 "../src/Layout.vala"
							_tmp37_ = n;
#line 191 "../src/Layout.vala"
							_tmp38_ = margin;
#line 191 "../src/Layout.vala"
							node_set_posy (_tmp37_, (py - (*_tmp38_)) - ch);
#line 192 "../src/Layout.vala"
							break;
#line 1737 "Layout.c"
						}
#line 179 "../src/Layout.vala"
						case NODE_SIDE_BOTTOM:
#line 1741 "Layout.c"
						{
							Node* _tmp39_;
							gint* _tmp40_;
#line 194 "../src/Layout.vala"
							_tmp39_ = n;
#line 194 "../src/Layout.vala"
							_tmp40_ = margin;
#line 194 "../src/Layout.vala"
							node_set_posy (_tmp39_, (py + ph) + (*_tmp40_));
#line 195 "../src/Layout.vala"
							break;
#line 1753 "Layout.c"
						}
						default:
#line 179 "../src/Layout.vala"
						break;
#line 1758 "Layout.c"
					}
#line 197 "../src/Layout.vala"
					_tmp41_ = n;
#line 197 "../src/Layout.vala"
					layout_propagate_side (self, _tmp41_, side);
#line 1764 "Layout.c"
				}
#line 175 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 1768 "Layout.c"
			}
		}
	}
#line 168 "../src/Layout.vala"
	_g_free0 (margin);
#line 1774 "Layout.c"
}

void
layout_propagate_side (Layout* self,
                       Node* parent,
                       NodeSide side)
{
	LayoutClass* _klass_;
#line 168 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 168 "../src/Layout.vala"
	if (_klass_->propagate_side) {
#line 168 "../src/Layout.vala"
		_klass_->propagate_side (self, parent, side);
#line 1791 "Layout.c"
	}
}

static NodeSide
layout_real_get_side (Layout* self,
                      Node* n)
{
	gdouble rx = 0.0;
	gdouble ry = 0.0;
	gdouble rw = 0.0;
	gdouble rh = 0.0;
	gdouble nx = 0.0;
	gdouble ny = 0.0;
	gdouble nw = 0.0;
	gdouble nh = 0.0;
	Node* _tmp0_;
	Node* _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	NodeSide _tmp10_;
	NodeSide _tmp11_;
	NodeSide result;
#line 204 "../src/Layout.vala"
	g_return_val_if_fail (n != NULL, 0);
#line 207 "../src/Layout.vala"
	_tmp0_ = node_get_root (n);
#line 207 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 207 "../src/Layout.vala"
	node_bbox (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 207 "../src/Layout.vala"
	rx = _tmp2_;
#line 207 "../src/Layout.vala"
	ry = _tmp3_;
#line 207 "../src/Layout.vala"
	rw = _tmp4_;
#line 207 "../src/Layout.vala"
	rh = _tmp5_;
#line 207 "../src/Layout.vala"
	_g_object_unref0 (_tmp1_);
#line 208 "../src/Layout.vala"
	node_bbox (n, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 208 "../src/Layout.vala"
	nx = _tmp6_;
#line 208 "../src/Layout.vala"
	ny = _tmp7_;
#line 208 "../src/Layout.vala"
	nw = _tmp8_;
#line 208 "../src/Layout.vala"
	nh = _tmp9_;
#line 209 "../src/Layout.vala"
	_tmp10_ = node_get_side (n);
#line 209 "../src/Layout.vala"
	_tmp11_ = _tmp10_;
#line 209 "../src/Layout.vala"
	if ((_tmp11_ & node_side_horizontal ()) != 0) {
#line 1854 "Layout.c"
		NodeSide _tmp12_ = 0;
#line 210 "../src/Layout.vala"
		if ((nx + (nw / 2)) > (rx + (rw / 2))) {
#line 210 "../src/Layout.vala"
			_tmp12_ = NODE_SIDE_RIGHT;
#line 1860 "Layout.c"
		} else {
#line 210 "../src/Layout.vala"
			_tmp12_ = NODE_SIDE_LEFT;
#line 1864 "Layout.c"
		}
#line 210 "../src/Layout.vala"
		result = _tmp12_;
#line 210 "../src/Layout.vala"
		return result;
#line 1870 "Layout.c"
	} else {
		NodeSide _tmp13_ = 0;
#line 212 "../src/Layout.vala"
		if ((ny + (nh / 2)) > (ry + (rh / 2))) {
#line 212 "../src/Layout.vala"
			_tmp13_ = NODE_SIDE_BOTTOM;
#line 1877 "Layout.c"
		} else {
#line 212 "../src/Layout.vala"
			_tmp13_ = NODE_SIDE_TOP;
#line 1881 "Layout.c"
		}
#line 212 "../src/Layout.vala"
		result = _tmp13_;
#line 212 "../src/Layout.vala"
		return result;
#line 1887 "Layout.c"
	}
}

NodeSide
layout_get_side (Layout* self,
                 Node* n)
{
	LayoutClass* _klass_;
#line 204 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 204 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 204 "../src/Layout.vala"
	if (_klass_->get_side) {
#line 204 "../src/Layout.vala"
		return _klass_->get_side (self, n);
#line 1904 "Layout.c"
	}
#line 204 "../src/Layout.vala"
	return 0;
#line 1908 "Layout.c"
}

static void
layout_real_set_side (Layout* self,
                      Node* current)
{
#line 217 "../src/Layout.vala"
	g_return_if_fail (current != NULL);
#line 218 "../src/Layout.vala"
	if (!node_is_root (current)) {
#line 1919 "Layout.c"
		NodeSide side = 0;
		NodeSide _tmp0_;
		NodeSide _tmp1_;
#line 219 "../src/Layout.vala"
		side = layout_get_side (self, current);
#line 220 "../src/Layout.vala"
		_tmp0_ = node_get_side (current);
#line 220 "../src/Layout.vala"
		_tmp1_ = _tmp0_;
#line 220 "../src/Layout.vala"
		if (_tmp1_ != side) {
#line 221 "../src/Layout.vala"
			node_set_side (current, side);
#line 222 "../src/Layout.vala"
			layout_propagate_side (self, current, side);
#line 1935 "Layout.c"
		}
	}
}

void
layout_set_side (Layout* self,
                 Node* current)
{
	LayoutClass* _klass_;
#line 217 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 217 "../src/Layout.vala"
	if (_klass_->set_side) {
#line 217 "../src/Layout.vala"
		_klass_->set_side (self, current);
#line 1953 "Layout.c"
	}
}

void
layout_apply_margin (Layout* self,
                     Node* n)
{
	Node* _tmp0_;
	Node* _tmp1_;
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	gint* margin = NULL;
	Node* _tmp2_;
	Node* _tmp3_;
	Style* _tmp4_;
	Style* _tmp5_;
	gint* _tmp6_;
	gint* _tmp7_;
	gint* _tmp8_;
	Node* _tmp9_;
	Node* _tmp10_;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	NodeSide _tmp15_;
	NodeSide _tmp16_;
#line 228 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 228 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 229 "../src/Layout.vala"
	_tmp0_ = node_get_parent (n);
#line 229 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 229 "../src/Layout.vala"
	if (_tmp1_ == NULL) {
#line 229 "../src/Layout.vala"
		return;
#line 1995 "Layout.c"
	}
#line 231 "../src/Layout.vala"
	_tmp2_ = node_get_parent (n);
#line 231 "../src/Layout.vala"
	_tmp3_ = _tmp2_;
#line 231 "../src/Layout.vala"
	_tmp4_ = node_get_style (_tmp3_);
#line 231 "../src/Layout.vala"
	_tmp5_ = _tmp4_;
#line 231 "../src/Layout.vala"
	_tmp6_ = style_get_branch_margin (_tmp5_);
#line 231 "../src/Layout.vala"
	_tmp7_ = _tmp6_;
#line 231 "../src/Layout.vala"
	_tmp8_ = __int_dup0 (_tmp7_);
#line 231 "../src/Layout.vala"
	margin = _tmp8_;
#line 232 "../src/Layout.vala"
	_tmp9_ = node_get_parent (n);
#line 232 "../src/Layout.vala"
	_tmp10_ = _tmp9_;
#line 232 "../src/Layout.vala"
	node_bbox (_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
#line 232 "../src/Layout.vala"
	px = _tmp11_;
#line 232 "../src/Layout.vala"
	py = _tmp12_;
#line 232 "../src/Layout.vala"
	pw = _tmp13_;
#line 232 "../src/Layout.vala"
	ph = _tmp14_;
#line 233 "../src/Layout.vala"
	_tmp15_ = node_get_side (n);
#line 233 "../src/Layout.vala"
	_tmp16_ = _tmp15_;
#line 233 "../src/Layout.vala"
	switch (_tmp16_) {
#line 233 "../src/Layout.vala"
		case NODE_SIDE_LEFT:
#line 2035 "Layout.c"
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp17_ = 0.0;
			gdouble _tmp18_ = 0.0;
			gdouble _tmp19_ = 0.0;
			gdouble _tmp20_ = 0.0;
			gint* _tmp21_;
#line 236 "../src/Layout.vala"
			node_bbox (n, &_tmp17_, &_tmp18_, &_tmp19_, &_tmp20_);
#line 236 "../src/Layout.vala"
			cx = _tmp17_;
#line 236 "../src/Layout.vala"
			cy = _tmp18_;
#line 236 "../src/Layout.vala"
			cw = _tmp19_;
#line 236 "../src/Layout.vala"
			ch = _tmp20_;
#line 237 "../src/Layout.vala"
			_tmp21_ = margin;
#line 237 "../src/Layout.vala"
			node_set_posx (n, px - (cw + (*_tmp21_)));
#line 238 "../src/Layout.vala"
			break;
#line 2062 "Layout.c"
		}
#line 233 "../src/Layout.vala"
		case NODE_SIDE_RIGHT:
#line 2066 "Layout.c"
		{
			gint* _tmp22_;
			Node* _tmp23_;
			Node* _tmp24_;
#line 240 "../src/Layout.vala"
			_tmp22_ = margin;
#line 240 "../src/Layout.vala"
			_tmp23_ = node_get_parent (n);
#line 240 "../src/Layout.vala"
			_tmp24_ = _tmp23_;
#line 240 "../src/Layout.vala"
			node_set_posx (n, (px + (pw + (*_tmp22_))) - node_task_width (_tmp24_));
#line 241 "../src/Layout.vala"
			break;
#line 2081 "Layout.c"
		}
#line 233 "../src/Layout.vala"
		case NODE_SIDE_TOP:
#line 2085 "Layout.c"
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp25_ = 0.0;
			gdouble _tmp26_ = 0.0;
			gdouble _tmp27_ = 0.0;
			gdouble _tmp28_ = 0.0;
			gint* _tmp29_;
#line 244 "../src/Layout.vala"
			node_bbox (n, &_tmp25_, &_tmp26_, &_tmp27_, &_tmp28_);
#line 244 "../src/Layout.vala"
			cx = _tmp25_;
#line 244 "../src/Layout.vala"
			cy = _tmp26_;
#line 244 "../src/Layout.vala"
			cw = _tmp27_;
#line 244 "../src/Layout.vala"
			ch = _tmp28_;
#line 245 "../src/Layout.vala"
			_tmp29_ = margin;
#line 245 "../src/Layout.vala"
			node_set_posy (n, py - (ch + (*_tmp29_)));
#line 246 "../src/Layout.vala"
			break;
#line 2112 "Layout.c"
		}
#line 233 "../src/Layout.vala"
		case NODE_SIDE_BOTTOM:
#line 2116 "Layout.c"
		{
			gint* _tmp30_;
#line 248 "../src/Layout.vala"
			_tmp30_ = margin;
#line 248 "../src/Layout.vala"
			node_set_posy (n, py + (ph + (*_tmp30_)));
#line 249 "../src/Layout.vala"
			break;
#line 2125 "Layout.c"
		}
		default:
#line 233 "../src/Layout.vala"
		break;
#line 2130 "Layout.c"
	}
#line 228 "../src/Layout.vala"
	_g_free0 (margin);
#line 2134 "Layout.c"
}

static void
layout_real_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh)
{
	gdouble adjust = 0.0;
	NodeSide _tmp0_;
	NodeSide _tmp1_;
	NodeBounds _tmp79_ = {0};
	NodeBounds _tmp80_;
#line 254 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 255 "../src/Layout.vala"
	adjust = 0 - (layout_get_adjust (self, n) / 2);
#line 256 "../src/Layout.vala"
	_tmp0_ = node_get_side (n);
#line 256 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 256 "../src/Layout.vala"
	if ((_tmp1_ & node_side_horizontal ()) != 0) {
#line 257 "../src/Layout.vala"
		if (diffh != ((gdouble) 0)) {
#line 258 "../src/Layout.vala"
			node_adjust_posy_only (n, 0 - (diffh / 2));
#line 2162 "Layout.c"
		}
#line 260 "../src/Layout.vala"
		if (diffw != ((gdouble) 0)) {
#line 261 "../src/Layout.vala"
			if (node_is_root (n)) {
#line 262 "../src/Layout.vala"
				node_adjust_posx_only (n, 0 - (diffw / 2));
#line 2170 "Layout.c"
				{
					gint i = 0;
#line 263 "../src/Layout.vala"
					i = 0;
#line 2175 "Layout.c"
					{
						gboolean _tmp2_ = FALSE;
#line 263 "../src/Layout.vala"
						_tmp2_ = TRUE;
#line 263 "../src/Layout.vala"
						while (TRUE) {
#line 2182 "Layout.c"
							GArray* _tmp4_;
							GArray* _tmp5_;
							gboolean _tmp6_;
							Node* child = NULL;
							GArray* _tmp7_;
							GArray* _tmp8_;
							Node* _tmp9_;
							Node* _tmp10_;
							Node* _tmp11_;
							Node* _tmp12_;
							NodeSide _tmp13_;
							NodeSide _tmp14_;
#line 263 "../src/Layout.vala"
							if (!_tmp2_) {
#line 2197 "Layout.c"
								gint _tmp3_;
#line 263 "../src/Layout.vala"
								_tmp3_ = i;
#line 263 "../src/Layout.vala"
								i = _tmp3_ + 1;
#line 2203 "Layout.c"
							}
#line 263 "../src/Layout.vala"
							_tmp2_ = FALSE;
#line 263 "../src/Layout.vala"
							_tmp4_ = node_children (n);
#line 263 "../src/Layout.vala"
							_tmp5_ = _tmp4_;
#line 263 "../src/Layout.vala"
							_tmp6_ = !(((guint) i) < _tmp5_->len);
#line 263 "../src/Layout.vala"
							_g_array_unref0 (_tmp5_);
#line 263 "../src/Layout.vala"
							if (_tmp6_) {
#line 263 "../src/Layout.vala"
								break;
#line 2219 "Layout.c"
							}
#line 264 "../src/Layout.vala"
							_tmp7_ = node_children (n);
#line 264 "../src/Layout.vala"
							_tmp8_ = _tmp7_;
#line 264 "../src/Layout.vala"
							_tmp9_ = g_array_index (_tmp8_, Node*, (guint) i);
#line 264 "../src/Layout.vala"
							_tmp10_ = _g_object_ref0 (_tmp9_);
#line 264 "../src/Layout.vala"
							_tmp11_ = _tmp10_;
#line 264 "../src/Layout.vala"
							_g_array_unref0 (_tmp8_);
#line 264 "../src/Layout.vala"
							child = _tmp11_;
#line 265 "../src/Layout.vala"
							_tmp12_ = child;
#line 265 "../src/Layout.vala"
							_tmp13_ = node_get_side (_tmp12_);
#line 265 "../src/Layout.vala"
							_tmp14_ = _tmp13_;
#line 265 "../src/Layout.vala"
							if (_tmp14_ == NODE_SIDE_LEFT) {
#line 2243 "Layout.c"
								Node* _tmp15_;
								Node* _tmp16_;
								gdouble _tmp17_;
								gdouble _tmp18_;
#line 266 "../src/Layout.vala"
								_tmp15_ = child;
#line 266 "../src/Layout.vala"
								_tmp16_ = child;
#line 266 "../src/Layout.vala"
								_tmp17_ = node_get_posx (_tmp16_);
#line 266 "../src/Layout.vala"
								_tmp18_ = _tmp17_;
#line 266 "../src/Layout.vala"
								node_set_posx (_tmp16_, _tmp18_ - (diffw / 2));
#line 2258 "Layout.c"
							} else {
								Node* _tmp19_;
								Node* _tmp20_;
								gdouble _tmp21_;
								gdouble _tmp22_;
#line 268 "../src/Layout.vala"
								_tmp19_ = child;
#line 268 "../src/Layout.vala"
								_tmp20_ = child;
#line 268 "../src/Layout.vala"
								_tmp21_ = node_get_posx (_tmp20_);
#line 268 "../src/Layout.vala"
								_tmp22_ = _tmp21_;
#line 268 "../src/Layout.vala"
								node_set_posx (_tmp20_, _tmp22_ + (diffw / 2));
#line 2274 "Layout.c"
							}
#line 263 "../src/Layout.vala"
							_g_object_unref0 (child);
#line 2278 "Layout.c"
						}
					}
				}
			} else {
				NodeSide _tmp23_;
				NodeSide _tmp24_;
#line 271 "../src/Layout.vala"
				_tmp23_ = node_get_side (n);
#line 271 "../src/Layout.vala"
				_tmp24_ = _tmp23_;
#line 271 "../src/Layout.vala"
				if (_tmp24_ == NODE_SIDE_LEFT) {
#line 2291 "Layout.c"
					gdouble _tmp25_;
					gdouble _tmp26_;
#line 272 "../src/Layout.vala"
					_tmp25_ = node_get_posx (n);
#line 272 "../src/Layout.vala"
					_tmp26_ = _tmp25_;
#line 272 "../src/Layout.vala"
					node_set_posx (n, _tmp26_ - diffw);
#line 2300 "Layout.c"
				} else {
					{
						gint i = 0;
#line 274 "../src/Layout.vala"
						i = 0;
#line 2306 "Layout.c"
						{
							gboolean _tmp27_ = FALSE;
#line 274 "../src/Layout.vala"
							_tmp27_ = TRUE;
#line 274 "../src/Layout.vala"
							while (TRUE) {
#line 2313 "Layout.c"
								GArray* _tmp29_;
								GArray* _tmp30_;
								gboolean _tmp31_;
								GArray* _tmp32_;
								GArray* _tmp33_;
								Node* _tmp34_;
								GArray* _tmp35_;
								GArray* _tmp36_;
								Node* _tmp37_;
								gdouble _tmp38_;
								gdouble _tmp39_;
#line 274 "../src/Layout.vala"
								if (!_tmp27_) {
#line 2327 "Layout.c"
									gint _tmp28_;
#line 274 "../src/Layout.vala"
									_tmp28_ = i;
#line 274 "../src/Layout.vala"
									i = _tmp28_ + 1;
#line 2333 "Layout.c"
								}
#line 274 "../src/Layout.vala"
								_tmp27_ = FALSE;
#line 274 "../src/Layout.vala"
								_tmp29_ = node_children (n);
#line 274 "../src/Layout.vala"
								_tmp30_ = _tmp29_;
#line 274 "../src/Layout.vala"
								_tmp31_ = !(((guint) i) < _tmp30_->len);
#line 274 "../src/Layout.vala"
								_g_array_unref0 (_tmp30_);
#line 274 "../src/Layout.vala"
								if (_tmp31_) {
#line 274 "../src/Layout.vala"
									break;
#line 2349 "Layout.c"
								}
#line 275 "../src/Layout.vala"
								_tmp32_ = node_children (n);
#line 275 "../src/Layout.vala"
								_tmp33_ = _tmp32_;
#line 275 "../src/Layout.vala"
								_tmp34_ = g_array_index (_tmp33_, Node*, (guint) i);
#line 275 "../src/Layout.vala"
								_tmp35_ = node_children (n);
#line 275 "../src/Layout.vala"
								_tmp36_ = _tmp35_;
#line 275 "../src/Layout.vala"
								_tmp37_ = g_array_index (_tmp36_, Node*, (guint) i);
#line 275 "../src/Layout.vala"
								_tmp38_ = node_get_posx (_tmp37_);
#line 275 "../src/Layout.vala"
								_tmp39_ = _tmp38_;
#line 275 "../src/Layout.vala"
								node_set_posx (_tmp37_, _tmp39_ + diffw);
#line 275 "../src/Layout.vala"
								_g_array_unref0 (_tmp36_);
#line 275 "../src/Layout.vala"
								_g_array_unref0 (_tmp33_);
#line 2373 "Layout.c"
							}
						}
					}
				}
			}
		}
	} else {
#line 280 "../src/Layout.vala"
		if (diffw != ((gdouble) 0)) {
#line 281 "../src/Layout.vala"
			node_adjust_posx_only (n, 0 - (diffw / 2));
#line 2385 "Layout.c"
		}
#line 283 "../src/Layout.vala"
		if (diffh != ((gdouble) 0)) {
#line 284 "../src/Layout.vala"
			if (node_is_root (n)) {
#line 2391 "Layout.c"
				gdouble _tmp40_;
				gdouble _tmp41_;
#line 285 "../src/Layout.vala"
				_tmp40_ = node_get_posy (n);
#line 285 "../src/Layout.vala"
				_tmp41_ = _tmp40_;
#line 285 "../src/Layout.vala"
				node_set_posy (n, _tmp41_ - (diffh / 2));
#line 2400 "Layout.c"
				{
					gint i = 0;
#line 286 "../src/Layout.vala"
					i = 0;
#line 2405 "Layout.c"
					{
						gboolean _tmp42_ = FALSE;
#line 286 "../src/Layout.vala"
						_tmp42_ = TRUE;
#line 286 "../src/Layout.vala"
						while (TRUE) {
#line 2412 "Layout.c"
							GArray* _tmp44_;
							GArray* _tmp45_;
							gboolean _tmp46_;
							Node* child = NULL;
							GArray* _tmp47_;
							GArray* _tmp48_;
							Node* _tmp49_;
							Node* _tmp50_;
							Node* _tmp51_;
							NodeSide _tmp52_;
							NodeSide _tmp53_;
#line 286 "../src/Layout.vala"
							if (!_tmp42_) {
#line 2426 "Layout.c"
								gint _tmp43_;
#line 286 "../src/Layout.vala"
								_tmp43_ = i;
#line 286 "../src/Layout.vala"
								i = _tmp43_ + 1;
#line 2432 "Layout.c"
							}
#line 286 "../src/Layout.vala"
							_tmp42_ = FALSE;
#line 286 "../src/Layout.vala"
							_tmp44_ = node_children (n);
#line 286 "../src/Layout.vala"
							_tmp45_ = _tmp44_;
#line 286 "../src/Layout.vala"
							_tmp46_ = !(((guint) i) < _tmp45_->len);
#line 286 "../src/Layout.vala"
							_g_array_unref0 (_tmp45_);
#line 286 "../src/Layout.vala"
							if (_tmp46_) {
#line 286 "../src/Layout.vala"
								break;
#line 2448 "Layout.c"
							}
#line 287 "../src/Layout.vala"
							_tmp47_ = node_children (n);
#line 287 "../src/Layout.vala"
							_tmp48_ = _tmp47_;
#line 287 "../src/Layout.vala"
							_tmp49_ = g_array_index (_tmp48_, Node*, (guint) i);
#line 287 "../src/Layout.vala"
							_tmp50_ = _g_object_ref0 (_tmp49_);
#line 287 "../src/Layout.vala"
							_tmp51_ = _tmp50_;
#line 287 "../src/Layout.vala"
							_g_array_unref0 (_tmp48_);
#line 287 "../src/Layout.vala"
							child = _tmp51_;
#line 288 "../src/Layout.vala"
							_tmp52_ = node_get_side (n);
#line 288 "../src/Layout.vala"
							_tmp53_ = _tmp52_;
#line 288 "../src/Layout.vala"
							if (_tmp53_ == NODE_SIDE_TOP) {
#line 2470 "Layout.c"
								Node* _tmp54_;
								Node* _tmp55_;
								gdouble _tmp56_;
								gdouble _tmp57_;
#line 289 "../src/Layout.vala"
								_tmp54_ = child;
#line 289 "../src/Layout.vala"
								_tmp55_ = child;
#line 289 "../src/Layout.vala"
								_tmp56_ = node_get_posy (_tmp55_);
#line 289 "../src/Layout.vala"
								_tmp57_ = _tmp56_;
#line 289 "../src/Layout.vala"
								node_set_posy (_tmp55_, _tmp57_ - (diffh / 2));
#line 2485 "Layout.c"
							} else {
								Node* _tmp58_;
								Node* _tmp59_;
								gdouble _tmp60_;
								gdouble _tmp61_;
#line 291 "../src/Layout.vala"
								_tmp58_ = child;
#line 291 "../src/Layout.vala"
								_tmp59_ = child;
#line 291 "../src/Layout.vala"
								_tmp60_ = node_get_posy (_tmp59_);
#line 291 "../src/Layout.vala"
								_tmp61_ = _tmp60_;
#line 291 "../src/Layout.vala"
								node_set_posy (_tmp59_, _tmp61_ + (diffh / 2));
#line 2501 "Layout.c"
							}
#line 286 "../src/Layout.vala"
							_g_object_unref0 (child);
#line 2505 "Layout.c"
						}
					}
				}
			} else {
				NodeSide _tmp62_;
				NodeSide _tmp63_;
#line 294 "../src/Layout.vala"
				_tmp62_ = node_get_side (n);
#line 294 "../src/Layout.vala"
				_tmp63_ = _tmp62_;
#line 294 "../src/Layout.vala"
				if (_tmp63_ == NODE_SIDE_TOP) {
#line 2518 "Layout.c"
					gdouble _tmp64_;
					gdouble _tmp65_;
#line 295 "../src/Layout.vala"
					_tmp64_ = node_get_posy (n);
#line 295 "../src/Layout.vala"
					_tmp65_ = _tmp64_;
#line 295 "../src/Layout.vala"
					node_set_posy (n, _tmp65_ - diffh);
#line 2527 "Layout.c"
				} else {
					{
						gint i = 0;
#line 297 "../src/Layout.vala"
						i = 0;
#line 2533 "Layout.c"
						{
							gboolean _tmp66_ = FALSE;
#line 297 "../src/Layout.vala"
							_tmp66_ = TRUE;
#line 297 "../src/Layout.vala"
							while (TRUE) {
#line 2540 "Layout.c"
								GArray* _tmp68_;
								GArray* _tmp69_;
								gboolean _tmp70_;
								GArray* _tmp71_;
								GArray* _tmp72_;
								Node* _tmp73_;
								GArray* _tmp74_;
								GArray* _tmp75_;
								Node* _tmp76_;
								gdouble _tmp77_;
								gdouble _tmp78_;
#line 297 "../src/Layout.vala"
								if (!_tmp66_) {
#line 2554 "Layout.c"
									gint _tmp67_;
#line 297 "../src/Layout.vala"
									_tmp67_ = i;
#line 297 "../src/Layout.vala"
									i = _tmp67_ + 1;
#line 2560 "Layout.c"
								}
#line 297 "../src/Layout.vala"
								_tmp66_ = FALSE;
#line 297 "../src/Layout.vala"
								_tmp68_ = node_children (n);
#line 297 "../src/Layout.vala"
								_tmp69_ = _tmp68_;
#line 297 "../src/Layout.vala"
								_tmp70_ = !(((guint) i) < _tmp69_->len);
#line 297 "../src/Layout.vala"
								_g_array_unref0 (_tmp69_);
#line 297 "../src/Layout.vala"
								if (_tmp70_) {
#line 297 "../src/Layout.vala"
									break;
#line 2576 "Layout.c"
								}
#line 298 "../src/Layout.vala"
								_tmp71_ = node_children (n);
#line 298 "../src/Layout.vala"
								_tmp72_ = _tmp71_;
#line 298 "../src/Layout.vala"
								_tmp73_ = g_array_index (_tmp72_, Node*, (guint) i);
#line 298 "../src/Layout.vala"
								_tmp74_ = node_children (n);
#line 298 "../src/Layout.vala"
								_tmp75_ = _tmp74_;
#line 298 "../src/Layout.vala"
								_tmp76_ = g_array_index (_tmp75_, Node*, (guint) i);
#line 298 "../src/Layout.vala"
								_tmp77_ = node_get_posy (_tmp76_);
#line 298 "../src/Layout.vala"
								_tmp78_ = _tmp77_;
#line 298 "../src/Layout.vala"
								node_set_posy (_tmp76_, _tmp78_ + diffh);
#line 298 "../src/Layout.vala"
								_g_array_unref0 (_tmp75_);
#line 298 "../src/Layout.vala"
								_g_array_unref0 (_tmp72_);
#line 2600 "Layout.c"
							}
						}
					}
				}
			}
		}
	}
#line 303 "../src/Layout.vala"
	node_get_tree_bbox (n, &_tmp79_);
#line 303 "../src/Layout.vala"
	_tmp80_ = _tmp79_;
#line 303 "../src/Layout.vala"
	layout_adjust_tree_all (self, n, &_tmp80_, adjust, "by_edit");
#line 2614 "Layout.c"
}

void
layout_handle_update_by_edit (Layout* self,
                              Node* n,
                              gdouble diffw,
                              gdouble diffh)
{
	LayoutClass* _klass_;
#line 254 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 254 "../src/Layout.vala"
	if (_klass_->handle_update_by_edit) {
#line 254 "../src/Layout.vala"
		_klass_->handle_update_by_edit (self, n, diffw, diffh);
#line 2632 "Layout.c"
	}
}

static void
layout_real_handle_update_by_fold (Layout* self,
                                   Node* n)
{
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
#line 307 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 308 "../src/Layout.vala"
	node_get_tree_bbox (n, &_tmp0_);
#line 308 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 308 "../src/Layout.vala"
	layout_adjust_tree_all (self, n, &_tmp1_, 0 - (layout_get_adjust (self, n) / 2), "by_fold");
#line 2650 "Layout.c"
}

void
layout_handle_update_by_fold (Layout* self,
                              Node* n)
{
	LayoutClass* _klass_;
#line 307 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 307 "../src/Layout.vala"
	if (_klass_->handle_update_by_fold) {
#line 307 "../src/Layout.vala"
		_klass_->handle_update_by_fold (self, n);
#line 2666 "Layout.c"
	}
}

static gdouble
layout_real_get_insert_adjust (Layout* self,
                               Node* child)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble result;
#line 312 "../src/Layout.vala"
	g_return_val_if_fail (child != NULL, 0.0);
#line 313 "../src/Layout.vala"
	_tmp0_ = node_get_tree_size (child);
#line 313 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 313 "../src/Layout.vala"
	result = _tmp1_ / 2;
#line 313 "../src/Layout.vala"
	return result;
#line 2687 "Layout.c"
}

gdouble
layout_get_insert_adjust (Layout* self,
                          Node* child)
{
	LayoutClass* _klass_;
#line 312 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 312 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 312 "../src/Layout.vala"
	if (_klass_->get_insert_adjust) {
#line 312 "../src/Layout.vala"
		return _klass_->get_insert_adjust (self, child);
#line 2703 "Layout.c"
	}
#line 312 "../src/Layout.vala"
	return -1.0;
#line 2707 "Layout.c"
}

static void
layout_real_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos)
{
	gdouble ox = 0.0;
	gdouble oy = 0.0;
	gdouble ow = 0.0;
	gdouble oh = 0.0;
	gdouble adjust = 0.0;
	NodeBounds cb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	NodeSide _tmp6_;
	NodeSide _tmp7_;
	NodeBounds _tmp53_ = {0};
	NodeBounds _tmp54_;
#line 317 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 317 "../src/Layout.vala"
	g_return_if_fail (child != NULL);
#line 322 "../src/Layout.vala"
	layout_update_tree_size (self, child);
#line 324 "../src/Layout.vala"
	node_get_tree_bbox (child, &_tmp0_);
#line 324 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 324 "../src/Layout.vala"
	cb = _tmp1_;
#line 326 "../src/Layout.vala"
	node_bbox (child, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 326 "../src/Layout.vala"
	ox = _tmp2_;
#line 326 "../src/Layout.vala"
	oy = _tmp3_;
#line 326 "../src/Layout.vala"
	ow = _tmp4_;
#line 326 "../src/Layout.vala"
	oh = _tmp5_;
#line 327 "../src/Layout.vala"
	layout_apply_margin (self, child);
#line 328 "../src/Layout.vala"
	adjust = layout_get_insert_adjust (self, child);
#line 334 "../src/Layout.vala"
	_tmp6_ = node_get_side (child);
#line 334 "../src/Layout.vala"
	_tmp7_ = _tmp6_;
#line 334 "../src/Layout.vala"
	if (node_side_count (parent, _tmp7_) == 1) {
#line 2764 "Layout.c"
		gdouble px = 0.0;
		gdouble py = 0.0;
		gdouble pw = 0.0;
		gdouble ph = 0.0;
		gdouble _tmp8_ = 0.0;
		gdouble _tmp9_ = 0.0;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		NodeSide _tmp12_;
		NodeSide _tmp13_;
#line 336 "../src/Layout.vala"
		node_bbox (parent, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 336 "../src/Layout.vala"
		px = _tmp8_;
#line 336 "../src/Layout.vala"
		py = _tmp9_;
#line 336 "../src/Layout.vala"
		pw = _tmp10_;
#line 336 "../src/Layout.vala"
		ph = _tmp11_;
#line 337 "../src/Layout.vala"
		_tmp12_ = node_get_side (child);
#line 337 "../src/Layout.vala"
		_tmp13_ = _tmp12_;
#line 337 "../src/Layout.vala"
		if ((_tmp13_ & node_side_horizontal ()) != 0) {
#line 338 "../src/Layout.vala"
			node_set_posy (child, py + ((ph / 2) - (oh / 2)));
#line 2793 "Layout.c"
		} else {
#line 340 "../src/Layout.vala"
			node_set_posx (child, px + ((pw / 2) - (ow / 2)));
#line 2797 "Layout.c"
		}
	} else {
		gboolean _tmp14_ = FALSE;
		GArray* _tmp15_;
		GArray* _tmp16_;
		gboolean _tmp17_;
#line 347 "../src/Layout.vala"
		_tmp15_ = node_children (parent);
#line 347 "../src/Layout.vala"
		_tmp16_ = _tmp15_;
#line 347 "../src/Layout.vala"
		_tmp17_ = ((guint) (pos + 1)) == _tmp16_->len;
#line 347 "../src/Layout.vala"
		_g_array_unref0 (_tmp16_);
#line 347 "../src/Layout.vala"
		if (_tmp17_) {
#line 347 "../src/Layout.vala"
			_tmp14_ = TRUE;
#line 2816 "Layout.c"
		} else {
			GArray* _tmp18_;
			GArray* _tmp19_;
			Node* _tmp20_;
			NodeSide _tmp21_;
			NodeSide _tmp22_;
			NodeSide _tmp23_;
			NodeSide _tmp24_;
#line 347 "../src/Layout.vala"
			_tmp18_ = node_children (parent);
#line 347 "../src/Layout.vala"
			_tmp19_ = _tmp18_;
#line 347 "../src/Layout.vala"
			_tmp20_ = g_array_index (_tmp19_, Node*, (guint) (pos + 1));
#line 347 "../src/Layout.vala"
			_tmp21_ = node_get_side (_tmp20_);
#line 347 "../src/Layout.vala"
			_tmp22_ = _tmp21_;
#line 347 "../src/Layout.vala"
			_tmp23_ = node_get_side (child);
#line 347 "../src/Layout.vala"
			_tmp24_ = _tmp23_;
#line 347 "../src/Layout.vala"
			_tmp14_ = _tmp22_ != _tmp24_;
#line 347 "../src/Layout.vala"
			_g_array_unref0 (_tmp19_);
#line 2843 "Layout.c"
		}
#line 347 "../src/Layout.vala"
		if (_tmp14_) {
#line 2847 "Layout.c"
			NodeBounds sb = {0};
			GArray* _tmp25_;
			GArray* _tmp26_;
			Node* _tmp27_;
			NodeSide _tmp28_;
			NodeSide _tmp29_;
			NodeBounds _tmp30_ = {0};
			NodeBounds _tmp31_;
			NodeSide _tmp32_;
			NodeSide _tmp33_;
#line 348 "../src/Layout.vala"
			_tmp25_ = node_children (parent);
#line 348 "../src/Layout.vala"
			_tmp26_ = _tmp25_;
#line 348 "../src/Layout.vala"
			_tmp27_ = g_array_index (_tmp26_, Node*, (guint) (pos - 1));
#line 348 "../src/Layout.vala"
			_tmp28_ = node_get_side (child);
#line 348 "../src/Layout.vala"
			_tmp29_ = _tmp28_;
#line 348 "../src/Layout.vala"
			layout_bbox (self, _tmp27_, (gint) _tmp29_, &_tmp30_);
#line 348 "../src/Layout.vala"
			_tmp31_ = _tmp30_;
#line 348 "../src/Layout.vala"
			_g_array_unref0 (_tmp26_);
#line 348 "../src/Layout.vala"
			sb = _tmp31_;
#line 349 "../src/Layout.vala"
			_tmp32_ = node_get_side (child);
#line 349 "../src/Layout.vala"
			_tmp33_ = _tmp32_;
#line 349 "../src/Layout.vala"
			if ((_tmp33_ & node_side_horizontal ()) != 0) {
#line 2882 "Layout.c"
				NodeBounds _tmp34_;
				NodeBounds _tmp35_;
				NodeBounds _tmp36_;
#line 350 "../src/Layout.vala"
				_tmp34_ = sb;
#line 350 "../src/Layout.vala"
				_tmp35_ = sb;
#line 350 "../src/Layout.vala"
				_tmp36_ = cb;
#line 350 "../src/Layout.vala"
				node_set_posy (child, ((_tmp34_.y + _tmp35_.height) + (oy - _tmp36_.y)) - adjust);
#line 2894 "Layout.c"
			} else {
				NodeBounds _tmp37_;
				NodeBounds _tmp38_;
				NodeBounds _tmp39_;
#line 352 "../src/Layout.vala"
				_tmp37_ = sb;
#line 352 "../src/Layout.vala"
				_tmp38_ = sb;
#line 352 "../src/Layout.vala"
				_tmp39_ = cb;
#line 352 "../src/Layout.vala"
				node_set_posx (child, ((_tmp37_.x + _tmp38_.width) + (ox - _tmp39_.x)) - adjust);
#line 2907 "Layout.c"
			}
		} else {
			NodeBounds sb = {0};
			GArray* _tmp40_;
			GArray* _tmp41_;
			Node* _tmp42_;
			NodeSide _tmp43_;
			NodeSide _tmp44_;
			NodeBounds _tmp45_ = {0};
			NodeBounds _tmp46_;
			NodeSide _tmp47_;
			NodeSide _tmp48_;
#line 357 "../src/Layout.vala"
			_tmp40_ = node_children (parent);
#line 357 "../src/Layout.vala"
			_tmp41_ = _tmp40_;
#line 357 "../src/Layout.vala"
			_tmp42_ = g_array_index (_tmp41_, Node*, (guint) (pos + 1));
#line 357 "../src/Layout.vala"
			_tmp43_ = node_get_side (child);
#line 357 "../src/Layout.vala"
			_tmp44_ = _tmp43_;
#line 357 "../src/Layout.vala"
			layout_bbox (self, _tmp42_, (gint) _tmp44_, &_tmp45_);
#line 357 "../src/Layout.vala"
			_tmp46_ = _tmp45_;
#line 357 "../src/Layout.vala"
			_g_array_unref0 (_tmp41_);
#line 357 "../src/Layout.vala"
			sb = _tmp46_;
#line 358 "../src/Layout.vala"
			_tmp47_ = node_get_side (child);
#line 358 "../src/Layout.vala"
			_tmp48_ = _tmp47_;
#line 358 "../src/Layout.vala"
			if ((_tmp48_ & node_side_horizontal ()) != 0) {
#line 2944 "Layout.c"
				NodeBounds _tmp49_;
				NodeBounds _tmp50_;
#line 359 "../src/Layout.vala"
				_tmp49_ = sb;
#line 359 "../src/Layout.vala"
				_tmp50_ = cb;
#line 359 "../src/Layout.vala"
				node_set_posy (child, (_tmp49_.y + (oy - _tmp50_.y)) - adjust);
#line 2953 "Layout.c"
			} else {
				NodeBounds _tmp51_;
				NodeBounds _tmp52_;
#line 361 "../src/Layout.vala"
				_tmp51_ = sb;
#line 361 "../src/Layout.vala"
				_tmp52_ = cb;
#line 361 "../src/Layout.vala"
				node_set_posx (child, (_tmp51_.x + (ox - _tmp52_.x)) - adjust);
#line 2963 "Layout.c"
			}
		}
	}
#line 365 "../src/Layout.vala"
	node_get_tree_bbox (child, &_tmp53_);
#line 365 "../src/Layout.vala"
	_tmp54_ = _tmp53_;
#line 365 "../src/Layout.vala"
	layout_adjust_tree_all (self, child, &_tmp54_, 0 - adjust, "by_insert");
#line 2973 "Layout.c"
}

void
layout_handle_update_by_insert (Layout* self,
                                Node* parent,
                                Node* child,
                                gint pos)
{
	LayoutClass* _klass_;
#line 317 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 317 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 317 "../src/Layout.vala"
	if (_klass_->handle_update_by_insert) {
#line 317 "../src/Layout.vala"
		_klass_->handle_update_by_insert (self, parent, child, pos);
#line 2991 "Layout.c"
	}
}

static void
layout_real_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size)
{
	gdouble adjust = 0.0;
	NodeBounds _tmp25_ = {0};
	NodeBounds _tmp26_;
#line 370 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 372 "../src/Layout.vala"
	adjust = size / 2;
#line 3009 "Layout.c"
	{
		gint i = 0;
#line 375 "../src/Layout.vala"
		i = 0;
#line 3014 "Layout.c"
		{
			gboolean _tmp0_ = FALSE;
#line 375 "../src/Layout.vala"
			_tmp0_ = TRUE;
#line 375 "../src/Layout.vala"
			while (TRUE) {
#line 3021 "Layout.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				gboolean _tmp4_;
				Node* n = NULL;
				GArray* _tmp5_;
				GArray* _tmp6_;
				Node* _tmp7_;
				Node* _tmp8_;
				Node* _tmp9_;
				Node* _tmp10_;
				NodeSide _tmp11_;
				NodeSide _tmp12_;
#line 375 "../src/Layout.vala"
				if (!_tmp0_) {
#line 3036 "Layout.c"
					gint _tmp1_;
#line 375 "../src/Layout.vala"
					_tmp1_ = i;
#line 375 "../src/Layout.vala"
					i = _tmp1_ + 1;
#line 3042 "Layout.c"
				}
#line 375 "../src/Layout.vala"
				_tmp0_ = FALSE;
#line 375 "../src/Layout.vala"
				_tmp2_ = node_children (parent);
#line 375 "../src/Layout.vala"
				_tmp3_ = _tmp2_;
#line 375 "../src/Layout.vala"
				_tmp4_ = !(((guint) i) < _tmp3_->len);
#line 375 "../src/Layout.vala"
				_g_array_unref0 (_tmp3_);
#line 375 "../src/Layout.vala"
				if (_tmp4_) {
#line 375 "../src/Layout.vala"
					break;
#line 3058 "Layout.c"
				}
#line 376 "../src/Layout.vala"
				_tmp5_ = node_children (parent);
#line 376 "../src/Layout.vala"
				_tmp6_ = _tmp5_;
#line 376 "../src/Layout.vala"
				_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
#line 376 "../src/Layout.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 376 "../src/Layout.vala"
				_tmp9_ = _tmp8_;
#line 376 "../src/Layout.vala"
				_g_array_unref0 (_tmp6_);
#line 376 "../src/Layout.vala"
				n = _tmp9_;
#line 377 "../src/Layout.vala"
				_tmp10_ = n;
#line 377 "../src/Layout.vala"
				_tmp11_ = node_get_side (_tmp10_);
#line 377 "../src/Layout.vala"
				_tmp12_ = _tmp11_;
#line 377 "../src/Layout.vala"
				if (_tmp12_ == side) {
#line 3082 "Layout.c"
					gdouble _tmp13_ = 0.0;
					gdouble current_adjust = 0.0;
					Node* _tmp14_;
					NodeSide _tmp15_;
					NodeSide _tmp16_;
#line 378 "../src/Layout.vala"
					if (i >= index) {
#line 378 "../src/Layout.vala"
						_tmp13_ = 0 - adjust;
#line 3092 "Layout.c"
					} else {
#line 378 "../src/Layout.vala"
						_tmp13_ = adjust;
#line 3096 "Layout.c"
					}
#line 378 "../src/Layout.vala"
					current_adjust = _tmp13_;
#line 379 "../src/Layout.vala"
					_tmp14_ = n;
#line 379 "../src/Layout.vala"
					_tmp15_ = node_get_side (_tmp14_);
#line 379 "../src/Layout.vala"
					_tmp16_ = _tmp15_;
#line 379 "../src/Layout.vala"
					if ((_tmp16_ & node_side_horizontal ()) != 0) {
#line 3108 "Layout.c"
						Node* _tmp17_;
						Node* _tmp18_;
						gdouble _tmp19_;
						gdouble _tmp20_;
#line 380 "../src/Layout.vala"
						_tmp17_ = n;
#line 380 "../src/Layout.vala"
						_tmp18_ = n;
#line 380 "../src/Layout.vala"
						_tmp19_ = node_get_posy (_tmp18_);
#line 380 "../src/Layout.vala"
						_tmp20_ = _tmp19_;
#line 380 "../src/Layout.vala"
						node_set_posy (_tmp18_, _tmp20_ + current_adjust);
#line 3123 "Layout.c"
					} else {
						Node* _tmp21_;
						Node* _tmp22_;
						gdouble _tmp23_;
						gdouble _tmp24_;
#line 382 "../src/Layout.vala"
						_tmp21_ = n;
#line 382 "../src/Layout.vala"
						_tmp22_ = n;
#line 382 "../src/Layout.vala"
						_tmp23_ = node_get_posx (_tmp22_);
#line 382 "../src/Layout.vala"
						_tmp24_ = _tmp23_;
#line 382 "../src/Layout.vala"
						node_set_posx (_tmp22_, _tmp24_ + current_adjust);
#line 3139 "Layout.c"
					}
				}
#line 375 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 3144 "Layout.c"
			}
		}
	}
#line 388 "../src/Layout.vala"
	node_get_tree_bbox (parent, &_tmp25_);
#line 388 "../src/Layout.vala"
	_tmp26_ = _tmp25_;
#line 388 "../src/Layout.vala"
	layout_adjust_tree_all (self, parent, &_tmp26_, 0 - (layout_get_adjust (self, parent) / 2), "by_delete");
#line 3154 "Layout.c"
}

void
layout_handle_update_by_delete (Layout* self,
                                Node* parent,
                                gint index,
                                NodeSide side,
                                gdouble size)
{
	LayoutClass* _klass_;
#line 370 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 370 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 370 "../src/Layout.vala"
	if (_klass_->handle_update_by_delete) {
#line 370 "../src/Layout.vala"
		_klass_->handle_update_by_delete (self, parent, index, side, size);
#line 3173 "Layout.c"
	}
}

static void
layout_real_position_root (Layout* self,
                           Node* last,
                           Node* n)
{
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	NodeBounds _tmp4_;
	NodeBounds _tmp5_;
#line 393 "../src/Layout.vala"
	g_return_if_fail (last != NULL);
#line 393 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 394 "../src/Layout.vala"
	node_get_tree_bbox (last, &_tmp0_);
#line 394 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 394 "../src/Layout.vala"
	nb = _tmp1_;
#line 395 "../src/Layout.vala"
	_tmp2_ = node_get_posx (last);
#line 395 "../src/Layout.vala"
	_tmp3_ = _tmp2_;
#line 395 "../src/Layout.vala"
	node_set_posx (n, _tmp3_);
#line 396 "../src/Layout.vala"
	_tmp4_ = nb;
#line 396 "../src/Layout.vala"
	_tmp5_ = nb;
#line 396 "../src/Layout.vala"
	node_set_posy (n, (_tmp4_.y + _tmp5_.height) + self->_rt_gap);
#line 3211 "Layout.c"
}

void
layout_position_root (Layout* self,
                      Node* last,
                      Node* n)
{
	LayoutClass* _klass_;
#line 393 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 393 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 393 "../src/Layout.vala"
	if (_klass_->position_root) {
#line 393 "../src/Layout.vala"
		_klass_->position_root (self, last, n);
#line 3228 "Layout.c"
	}
}

const gchar*
layout_get_name (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Layout.vala"
	_tmp0_ = self->priv->_name;
#line 26 "../src/Layout.vala"
	result = _tmp0_;
#line 26 "../src/Layout.vala"
	return result;
#line 3245 "Layout.c"
}

void
layout_set_name (Layout* self,
                 const gchar* value)
{
	gchar* old_value;
#line 26 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Layout.vala"
	old_value = layout_get_name (self);
#line 26 "../src/Layout.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3259 "Layout.c"
		gchar* _tmp0_;
#line 26 "../src/Layout.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/Layout.vala"
		_g_free0 (self->priv->_name);
#line 26 "../src/Layout.vala"
		self->priv->_name = _tmp0_;
#line 26 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_NAME_PROPERTY]);
#line 3269 "Layout.c"
	}
}

const gchar*
layout_get_icon (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Layout.vala"
	_tmp0_ = self->priv->_icon;
#line 27 "../src/Layout.vala"
	result = _tmp0_;
#line 27 "../src/Layout.vala"
	return result;
#line 3286 "Layout.c"
}

void
layout_set_icon (Layout* self,
                 const gchar* value)
{
	gchar* old_value;
#line 27 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Layout.vala"
	old_value = layout_get_icon (self);
#line 27 "../src/Layout.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3300 "Layout.c"
		gchar* _tmp0_;
#line 27 "../src/Layout.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../src/Layout.vala"
		_g_free0 (self->priv->_icon);
#line 27 "../src/Layout.vala"
		self->priv->_icon = _tmp0_;
#line 27 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_ICON_PROPERTY]);
#line 3310 "Layout.c"
	}
}

gboolean
layout_get_balanceable (Layout* self)
{
	gboolean result;
#line 28 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/Layout.vala"
	result = self->priv->_balanceable;
#line 28 "../src/Layout.vala"
	return result;
#line 3324 "Layout.c"
}

void
layout_set_balanceable (Layout* self,
                        gboolean value)
{
	gboolean old_value;
#line 28 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Layout.vala"
	old_value = layout_get_balanceable (self);
#line 28 "../src/Layout.vala"
	if (old_value != value) {
#line 28 "../src/Layout.vala"
		self->priv->_balanceable = value;
#line 28 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_BALANCEABLE_PROPERTY]);
#line 3342 "Layout.c"
	}
}

static void
layout_class_init (LayoutClass * klass,
                   gpointer klass_data)
{
#line 22 "../src/Layout.vala"
	layout_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Layout.vala"
	g_type_class_adjust_private_offset (klass, &Layout_private_offset);
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->side_mapping = (NodeSide (*) (Layout*, NodeSide)) layout_real_side_mapping;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->initialize = (void (*) (Layout*, Node*)) layout_real_initialize;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->bbox = (void (*) (Layout*, Node*, gint, NodeBounds*)) layout_real_bbox;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->adjust_tree = (void (*) (Layout*, Node*, gint, gint, gdouble)) layout_real_adjust_tree;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->adjust_tree_all = (void (*) (Layout*, Node*, NodeBounds*, gdouble, const gchar*)) layout_real_adjust_tree_all;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->propagate_side = (void (*) (Layout*, Node*, NodeSide)) layout_real_propagate_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->get_side = (NodeSide (*) (Layout*, Node*)) layout_real_get_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->set_side = (void (*) (Layout*, Node*)) layout_real_set_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_edit = (void (*) (Layout*, Node*, gdouble, gdouble)) layout_real_handle_update_by_edit;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_fold = (void (*) (Layout*, Node*)) layout_real_handle_update_by_fold;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->get_insert_adjust = (gdouble (*) (Layout*, Node*)) layout_real_get_insert_adjust;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_insert = (void (*) (Layout*, Node*, Node*, gint)) layout_real_handle_update_by_insert;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_delete = (void (*) (Layout*, Node*, gint, NodeSide, gdouble)) layout_real_handle_update_by_delete;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->position_root = (void (*) (Layout*, Node*, Node*)) layout_real_position_root;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_layout_get_property;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_layout_set_property;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->finalize = layout_finalize;
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_NAME_PROPERTY, layout_properties[LAYOUT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_ICON_PROPERTY, layout_properties[LAYOUT_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_BALANCEABLE_PROPERTY, layout_properties[LAYOUT_BALANCEABLE_PROPERTY] = g_param_spec_boolean ("balanceable", "balanceable", "balanceable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3394 "Layout.c"
}

static void
layout_instance_init (Layout * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 22 "../src/Layout.vala"
	self->priv = layout_get_instance_private (self);
#line 24 "../src/Layout.vala"
	self->_rt_gap = (gdouble) 100;
#line 26 "../src/Layout.vala"
	_tmp0_ = g_strdup ("");
#line 26 "../src/Layout.vala"
	self->priv->_name = _tmp0_;
#line 27 "../src/Layout.vala"
	_tmp1_ = g_strdup ("");
#line 27 "../src/Layout.vala"
	self->priv->_icon = _tmp1_;
#line 28 "../src/Layout.vala"
	self->priv->_balanceable = FALSE;
#line 3417 "Layout.c"
}

static void
layout_finalize (GObject * obj)
{
	Layout * self;
#line 22 "../src/Layout.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LAYOUT, Layout);
#line 26 "../src/Layout.vala"
	_g_free0 (self->priv->_name);
#line 27 "../src/Layout.vala"
	_g_free0 (self->priv->_icon);
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (layout_parent_class)->finalize (obj);
#line 3432 "Layout.c"
}

static GType
layout_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Layout), 0, (GInstanceInitFunc) layout_instance_init, NULL };
	GType layout_type_id;
	layout_type_id = g_type_register_static (G_TYPE_OBJECT, "Layout", &g_define_type_info, 0);
	Layout_private_offset = g_type_add_instance_private (layout_type_id, sizeof (LayoutPrivate));
	return layout_type_id;
}

GType
layout_get_type (void)
{
	static volatile gsize layout_type_id__once = 0;
	if (g_once_init_enter (&layout_type_id__once)) {
		GType layout_type_id;
		layout_type_id = layout_get_type_once ();
		g_once_init_leave (&layout_type_id__once, layout_type_id);
	}
	return layout_type_id__once;
}

static void
_vala_layout_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
#line 22 "../src/Layout.vala"
	switch (property_id) {
#line 22 "../src/Layout.vala"
		case LAYOUT_NAME_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_string (value, layout_get_name (self));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_ICON_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_string (value, layout_get_icon (self));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_BALANCEABLE_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_boolean (value, layout_get_balanceable (self));
#line 22 "../src/Layout.vala"
		break;
#line 3485 "Layout.c"
		default:
#line 22 "../src/Layout.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Layout.vala"
		break;
#line 3491 "Layout.c"
	}
}

static void
_vala_layout_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
#line 22 "../src/Layout.vala"
	switch (property_id) {
#line 22 "../src/Layout.vala"
		case LAYOUT_NAME_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_name (self, g_value_get_string (value));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_ICON_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_icon (self, g_value_get_string (value));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_BALANCEABLE_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_balanceable (self, g_value_get_boolean (value));
#line 22 "../src/Layout.vala"
		break;
#line 3523 "Layout.c"
		default:
#line 22 "../src/Layout.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Layout.vala"
		break;
#line 3529 "Layout.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

