/* Preferences.c generated by valac 0.56.3, the Vala compiler
 * generated from Preferences.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PREFERENCES (preferences_get_type ())
#define PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES, Preferences))
#define PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES, PreferencesClass))
#define IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES))
#define IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES))
#define PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES, PreferencesClass))

typedef struct _Preferences Preferences;
typedef struct _PreferencesClass PreferencesClass;
typedef struct _PreferencesPrivate PreferencesPrivate;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
enum  {
	PREFERENCES_0_PROPERTY,
	PREFERENCES_NUM_PROPERTIES
};
static GParamSpec* preferences_properties[PREFERENCES_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block30Data Block30Data;

#define TYPE_THEMES (themes_get_type ())
#define THEMES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEMES, Themes))
#define THEMES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEMES, ThemesClass))
#define IS_THEMES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEMES))
#define IS_THEMES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEMES))
#define THEMES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEMES, ThemesClass))

typedef struct _Themes Themes;
typedef struct _ThemesClass ThemesClass;

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block31Data Block31Data;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

struct _Preferences {
	GtkDialog parent_instance;
	PreferencesPrivate * priv;
};

struct _PreferencesClass {
	GtkDialogClass parent_class;
};

struct _PreferencesPrivate {
	MainWindow* _win;
	GSettings* _settings;
};

struct _Block30Data {
	int _ref_count_;
	Preferences* self;
	GtkMenuButton* mb;
};

struct _Block31Data {
	int _ref_count_;
	Block30Data * _data30_;
	gchar* name;
	gchar* lbl;
};

static gint Preferences_private_offset;
static gpointer preferences_parent_class = NULL;

VALA_EXTERN GType preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Preferences, g_object_unref)
VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN Preferences* preferences_new (MainWindow* win,
                              GSettings* settings);
VALA_EXTERN Preferences* preferences_construct (GType object_type,
                                    MainWindow* win,
                                    GSettings* settings);
static GtkGrid* preferences_create_behavior (Preferences* self);
static GtkGrid* preferences_create_appearance (Preferences* self);
static void __lambda105_ (Preferences* self);
static void ___lambda105__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static GtkLabel* preferences_make_label (Preferences* self,
                                  const gchar* label);
static GtkSwitch* preferences_make_switch (Preferences* self,
                                    const gchar* setting);
static GtkImage* preferences_make_info (Preferences* self,
                                 const gchar* detail);
static GtkMenuButton* preferences_make_themes (Preferences* self);
static GtkSpinButton* preferences_make_spinner (Preferences* self,
                                         const gchar* setting,
                                         gint min_value,
                                         gint max_value,
                                         gint step);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
VALA_EXTERN GType themes_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Themes, g_object_unref)
VALA_EXTERN Themes* main_window_get_themes (MainWindow* self);
VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN Theme* themes_get_theme (Themes* self,
                         const gchar* name);
VALA_EXTERN const gchar* theme_get_label (Theme* self);
static void _g_free0_ (gpointer var);
static void _vala_gchar_free_function_content_of (gpointer data);
VALA_EXTERN void themes_names (Themes* self,
                   GArray** names);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static void _____lambda104_ (Block31Data* _data31_);
static void ______lambda104__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void preferences_finalize (GObject * obj);
static GType preferences_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
preferences_get_instance_private (Preferences* self)
{
	return G_STRUCT_MEMBER_P (self, Preferences_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 40 "../src/Preferences.vala"
	return self ? g_object_ref (self) : NULL;
#line 189 "Preferences.c"
}

static void
__lambda105_ (Preferences* self)
{
#line 63 "../src/Preferences.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 197 "Preferences.c"
}

static void
___lambda105__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 62 "../src/Preferences.vala"
	__lambda105_ ((Preferences*) self);
#line 206 "Preferences.c"
}

Preferences*
preferences_construct (GType object_type,
                       MainWindow* win,
                       GSettings* settings)
{
	Preferences * self = NULL;
	MainWindow* _tmp0_;
	GSettings* _tmp1_;
	GtkStack* stack = NULL;
	GtkStack* _tmp2_;
	GtkGrid* _tmp3_;
	GtkGrid* _tmp4_;
	GtkGrid* _tmp5_;
	GtkGrid* _tmp6_;
	GtkStackSwitcher* switcher = NULL;
	GtkStackSwitcher* _tmp7_;
	GtkBox* box = NULL;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp10_;
#line 30 "../src/Preferences.vala"
	g_return_val_if_fail (win != NULL, NULL);
#line 30 "../src/Preferences.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 32 "../src/Preferences.vala"
	self = (Preferences*) g_object_new (object_type, "border-width", 5, "deletable", FALSE, "resizable", FALSE, "title", _ ("Preferences"), "transient-for", win, NULL);
#line 40 "../src/Preferences.vala"
	_tmp0_ = _g_object_ref0 (win);
#line 40 "../src/Preferences.vala"
	_g_object_unref0 (self->priv->_win);
#line 40 "../src/Preferences.vala"
	self->priv->_win = _tmp0_;
#line 41 "../src/Preferences.vala"
	_tmp1_ = _g_object_ref0 (settings);
#line 41 "../src/Preferences.vala"
	_g_object_unref0 (self->priv->_settings);
#line 41 "../src/Preferences.vala"
	self->priv->_settings = _tmp1_;
#line 43 "../src/Preferences.vala"
	_tmp2_ = (GtkStack*) gtk_stack_new ();
#line 43 "../src/Preferences.vala"
	g_object_ref_sink (_tmp2_);
#line 43 "../src/Preferences.vala"
	stack = _tmp2_;
#line 44 "../src/Preferences.vala"
	g_object_set ((GtkWidget*) stack, "margin", 6, NULL);
#line 45 "../src/Preferences.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) stack, 18);
#line 46 "../src/Preferences.vala"
	gtk_widget_set_margin_top ((GtkWidget*) stack, 24);
#line 47 "../src/Preferences.vala"
	_tmp3_ = preferences_create_behavior (self);
#line 47 "../src/Preferences.vala"
	_tmp4_ = _tmp3_;
#line 47 "../src/Preferences.vala"
	gtk_stack_add_titled (stack, (GtkWidget*) _tmp4_, "behavior", _ ("Behavior"));
#line 47 "../src/Preferences.vala"
	_g_object_unref0 (_tmp4_);
#line 48 "../src/Preferences.vala"
	_tmp5_ = preferences_create_appearance (self);
#line 48 "../src/Preferences.vala"
	_tmp6_ = _tmp5_;
#line 48 "../src/Preferences.vala"
	gtk_stack_add_titled (stack, (GtkWidget*) _tmp6_, "appearance", _ ("Appearance"));
#line 48 "../src/Preferences.vala"
	_g_object_unref0 (_tmp6_);
#line 50 "../src/Preferences.vala"
	_tmp7_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 50 "../src/Preferences.vala"
	g_object_ref_sink (_tmp7_);
#line 50 "../src/Preferences.vala"
	switcher = _tmp7_;
#line 51 "../src/Preferences.vala"
	gtk_stack_switcher_set_stack (switcher, stack);
#line 52 "../src/Preferences.vala"
	gtk_widget_set_halign ((GtkWidget*) switcher, GTK_ALIGN_CENTER);
#line 54 "../src/Preferences.vala"
	_tmp8_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 54 "../src/Preferences.vala"
	g_object_ref_sink (_tmp8_);
#line 54 "../src/Preferences.vala"
	box = _tmp8_;
#line 55 "../src/Preferences.vala"
	gtk_box_pack_start (box, (GtkWidget*) switcher, FALSE, TRUE, (guint) 0);
#line 56 "../src/Preferences.vala"
	gtk_box_pack_start (box, (GtkWidget*) stack, TRUE, TRUE, (guint) 0);
#line 58 "../src/Preferences.vala"
	_tmp9_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 58 "../src/Preferences.vala"
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) box);
#line 61 "../src/Preferences.vala"
	_tmp10_ = (GtkButton*) gtk_button_new_with_label (_ ("Close"));
#line 61 "../src/Preferences.vala"
	g_object_ref_sink (_tmp10_);
#line 61 "../src/Preferences.vala"
	close_button = _tmp10_;
#line 62 "../src/Preferences.vala"
	g_signal_connect_object (close_button, "clicked", (GCallback) ___lambda105__gtk_button_clicked, self, 0);
#line 66 "../src/Preferences.vala"
	gtk_dialog_add_action_widget ((GtkDialog*) self, (GtkWidget*) close_button, 0);
#line 30 "../src/Preferences.vala"
	_g_object_unref0 (close_button);
#line 30 "../src/Preferences.vala"
	_g_object_unref0 (box);
#line 30 "../src/Preferences.vala"
	_g_object_unref0 (switcher);
#line 30 "../src/Preferences.vala"
	_g_object_unref0 (stack);
#line 30 "../src/Preferences.vala"
	return self;
#line 320 "Preferences.c"
}

Preferences*
preferences_new (MainWindow* win,
                 GSettings* settings)
{
#line 30 "../src/Preferences.vala"
	return preferences_construct (TYPE_PREFERENCES, win, settings);
#line 329 "Preferences.c"
}

static GtkGrid*
preferences_create_behavior (Preferences* self)
{
	GtkGrid* grid = NULL;
	GtkGrid* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkSwitch* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkSwitch* _tmp9_;
	GtkSwitch* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkSwitch* _tmp15_;
	GtkSwitch* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkSwitch* _tmp19_;
	GtkSwitch* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkSwitch* _tmp25_;
	GtkSwitch* _tmp26_;
	GtkImage* _tmp27_;
	GtkImage* _tmp28_;
	GtkGrid* result;
#line 70 "../src/Preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/Preferences.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 72 "../src/Preferences.vala"
	g_object_ref_sink (_tmp0_);
#line 72 "../src/Preferences.vala"
	grid = _tmp0_;
#line 73 "../src/Preferences.vala"
	gtk_grid_set_column_spacing (grid, 12);
#line 74 "../src/Preferences.vala"
	gtk_grid_set_row_spacing (grid, 6);
#line 76 "../src/Preferences.vala"
	_tmp1_ = preferences_make_label (self, _ ("Create new node from edit mode"));
#line 76 "../src/Preferences.vala"
	_tmp2_ = _tmp1_;
#line 76 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp2_, 0, 0, 1, 1);
#line 76 "../src/Preferences.vala"
	_g_object_unref0 (_tmp2_);
#line 77 "../src/Preferences.vala"
	_tmp3_ = preferences_make_switch (self, "new-node-from-edit");
#line 77 "../src/Preferences.vala"
	_tmp4_ = _tmp3_;
#line 77 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp4_, 1, 0, 1, 1);
#line 77 "../src/Preferences.vala"
	_g_object_unref0 (_tmp4_);
#line 78 "../src/Preferences.vala"
	_tmp5_ = preferences_make_info (self, _ ("Specifies if we should create a new node directly from edit mode if Re" \
"turn or Tab is pressed."));
#line 78 "../src/Preferences.vala"
	_tmp6_ = _tmp5_;
#line 78 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp6_, 2, 0, 1, 1);
#line 78 "../src/Preferences.vala"
	_g_object_unref0 (_tmp6_);
#line 80 "../src/Preferences.vala"
	_tmp7_ = preferences_make_label (self, _ ("Automatically make embedded URLs into links"));
#line 80 "../src/Preferences.vala"
	_tmp8_ = _tmp7_;
#line 80 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp8_, 0, 1, 1, 1);
#line 80 "../src/Preferences.vala"
	_g_object_unref0 (_tmp8_);
#line 81 "../src/Preferences.vala"
	_tmp9_ = preferences_make_switch (self, "auto-parse-embedded-urls");
#line 81 "../src/Preferences.vala"
	_tmp10_ = _tmp9_;
#line 81 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp10_, 1, 1, 1, 1);
#line 81 "../src/Preferences.vala"
	_g_object_unref0 (_tmp10_);
#line 82 "../src/Preferences.vala"
	_tmp11_ = preferences_make_info (self, _ ("Specifies if embedded URLs found in node titles should be automaticall" \
"y highlighted."));
#line 82 "../src/Preferences.vala"
	_tmp12_ = _tmp11_;
#line 82 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp12_, 2, 1, 1, 1);
#line 82 "../src/Preferences.vala"
	_g_object_unref0 (_tmp12_);
#line 84 "../src/Preferences.vala"
	_tmp13_ = preferences_make_label (self, _ ("Enable Markdown"));
#line 84 "../src/Preferences.vala"
	_tmp14_ = _tmp13_;
#line 84 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp14_, 0, 2, 1, 1);
#line 84 "../src/Preferences.vala"
	_g_object_unref0 (_tmp14_);
#line 85 "../src/Preferences.vala"
	_tmp15_ = preferences_make_switch (self, "enable-markdown");
#line 85 "../src/Preferences.vala"
	_tmp16_ = _tmp15_;
#line 85 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp16_, 1, 2, 1, 1);
#line 85 "../src/Preferences.vala"
	_g_object_unref0 (_tmp16_);
#line 87 "../src/Preferences.vala"
	_tmp17_ = preferences_make_label (self, _ ("Create connection title on creation"));
#line 87 "../src/Preferences.vala"
	_tmp18_ = _tmp17_;
#line 87 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp18_, 0, 3, 1, 1);
#line 87 "../src/Preferences.vala"
	_g_object_unref0 (_tmp18_);
#line 88 "../src/Preferences.vala"
	_tmp19_ = preferences_make_switch (self, "edit-connection-title-on-creation");
#line 88 "../src/Preferences.vala"
	_tmp20_ = _tmp19_;
#line 88 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp20_, 1, 3, 1, 1);
#line 88 "../src/Preferences.vala"
	_g_object_unref0 (_tmp20_);
#line 89 "../src/Preferences.vala"
	_tmp21_ = preferences_make_info (self, _ ("Specifies if the connection title will be added and put into edit mode" \
" immediately after the connection is made."));
#line 89 "../src/Preferences.vala"
	_tmp22_ = _tmp21_;
#line 89 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp22_, 2, 3, 1, 1);
#line 89 "../src/Preferences.vala"
	_g_object_unref0 (_tmp22_);
#line 91 "../src/Preferences.vala"
	_tmp23_ = preferences_make_label (self, _ ("Select items on mouse hover"));
#line 91 "../src/Preferences.vala"
	_tmp24_ = _tmp23_;
#line 91 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp24_, 0, 4, 1, 1);
#line 91 "../src/Preferences.vala"
	_g_object_unref0 (_tmp24_);
#line 92 "../src/Preferences.vala"
	_tmp25_ = preferences_make_switch (self, "select-on-hover");
#line 92 "../src/Preferences.vala"
	_tmp26_ = _tmp25_;
#line 92 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp26_, 1, 4, 1, 1);
#line 92 "../src/Preferences.vala"
	_g_object_unref0 (_tmp26_);
#line 93 "../src/Preferences.vala"
	_tmp27_ = preferences_make_info (self, _ ("If enabled, selects items when mouse cursor hovers over the item."));
#line 93 "../src/Preferences.vala"
	_tmp28_ = _tmp27_;
#line 93 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp28_, 2, 4, 1, 1);
#line 93 "../src/Preferences.vala"
	_g_object_unref0 (_tmp28_);
#line 95 "../src/Preferences.vala"
	result = grid;
#line 95 "../src/Preferences.vala"
	return result;
#line 494 "Preferences.c"
}

static GtkGrid*
preferences_create_appearance (Preferences* self)
{
	GtkGrid* grid = NULL;
	GtkGrid* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkSwitch* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkMenuButton* _tmp7_;
	GtkMenuButton* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkSwitch* _tmp11_;
	GtkSwitch* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkSwitch* _tmp15_;
	GtkSwitch* _tmp16_;
	GtkSpinButton* _tmp17_;
	GtkSpinButton* _tmp18_;
	GtkImage* _tmp19_;
	GtkImage* _tmp20_;
	GtkGrid* result;
#line 99 "../src/Preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../src/Preferences.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 101 "../src/Preferences.vala"
	g_object_ref_sink (_tmp0_);
#line 101 "../src/Preferences.vala"
	grid = _tmp0_;
#line 102 "../src/Preferences.vala"
	gtk_grid_set_column_spacing (grid, 12);
#line 103 "../src/Preferences.vala"
	gtk_grid_set_row_spacing (grid, 6);
#line 106 "../src/Preferences.vala"
	_tmp1_ = preferences_make_label (self, _ ("Hide themes not matching visual style"));
#line 106 "../src/Preferences.vala"
	_tmp2_ = _tmp1_;
#line 106 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp2_, 0, 0, 1, 1);
#line 106 "../src/Preferences.vala"
	_g_object_unref0 (_tmp2_);
#line 107 "../src/Preferences.vala"
	_tmp3_ = preferences_make_switch (self, "hide-themes-not-matching-visual-style");
#line 107 "../src/Preferences.vala"
	_tmp4_ = _tmp3_;
#line 107 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp4_, 1, 0, 1, 1);
#line 107 "../src/Preferences.vala"
	_g_object_unref0 (_tmp4_);
#line 110 "../src/Preferences.vala"
	_tmp5_ = preferences_make_label (self, _ ("Default theme"));
#line 110 "../src/Preferences.vala"
	_tmp6_ = _tmp5_;
#line 110 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp6_, 0, 1, 1, 1);
#line 110 "../src/Preferences.vala"
	_g_object_unref0 (_tmp6_);
#line 111 "../src/Preferences.vala"
	_tmp7_ = preferences_make_themes (self);
#line 111 "../src/Preferences.vala"
	_tmp8_ = _tmp7_;
#line 111 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp8_, 1, 1, 2, 1);
#line 111 "../src/Preferences.vala"
	_g_object_unref0 (_tmp8_);
#line 113 "../src/Preferences.vala"
	_tmp9_ = preferences_make_label (self, _ ("Enable animations"));
#line 113 "../src/Preferences.vala"
	_tmp10_ = _tmp9_;
#line 113 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp10_, 0, 2, 1, 1);
#line 113 "../src/Preferences.vala"
	_g_object_unref0 (_tmp10_);
#line 114 "../src/Preferences.vala"
	_tmp11_ = preferences_make_switch (self, "enable-animations");
#line 114 "../src/Preferences.vala"
	_tmp12_ = _tmp11_;
#line 114 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp12_, 1, 2, 1, 1);
#line 114 "../src/Preferences.vala"
	_g_object_unref0 (_tmp12_);
#line 116 "../src/Preferences.vala"
	_tmp13_ = preferences_make_label (self, _ ("Text field font size"));
#line 116 "../src/Preferences.vala"
	_tmp14_ = _tmp13_;
#line 116 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp14_, 0, 3, 1, 1);
#line 116 "../src/Preferences.vala"
	_g_object_unref0 (_tmp14_);
#line 117 "../src/Preferences.vala"
	_tmp15_ = preferences_make_switch (self, "text-field-use-custom-font-size");
#line 117 "../src/Preferences.vala"
	_tmp16_ = _tmp15_;
#line 117 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp16_, 1, 3, 1, 1);
#line 117 "../src/Preferences.vala"
	_g_object_unref0 (_tmp16_);
#line 118 "../src/Preferences.vala"
	_tmp17_ = preferences_make_spinner (self, "text-field-custom-font-size", 8, 24, 1);
#line 118 "../src/Preferences.vala"
	_tmp18_ = _tmp17_;
#line 118 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp18_, 2, 3, 1, 1);
#line 118 "../src/Preferences.vala"
	_g_object_unref0 (_tmp18_);
#line 119 "../src/Preferences.vala"
	_tmp19_ = preferences_make_info (self, _ ("Specifies the custom font size to use in text editing fields (i.e, qui" \
"ck entry or notes field)."));
#line 119 "../src/Preferences.vala"
	_tmp20_ = _tmp19_;
#line 119 "../src/Preferences.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp20_, 3, 3, 1, 1);
#line 119 "../src/Preferences.vala"
	_g_object_unref0 (_tmp20_);
#line 121 "../src/Preferences.vala"
	result = grid;
#line 121 "../src/Preferences.vala"
	return result;
#line 619 "Preferences.c"
}

static GtkLabel*
preferences_make_label (Preferences* self,
                        const gchar* label)
{
	GtkLabel* w = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* result;
#line 126 "../src/Preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "../src/Preferences.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 127 "../src/Preferences.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (label);
#line 127 "../src/Preferences.vala"
	g_object_ref_sink (_tmp0_);
#line 127 "../src/Preferences.vala"
	w = _tmp0_;
#line 128 "../src/Preferences.vala"
	gtk_widget_set_halign ((GtkWidget*) w, GTK_ALIGN_END);
#line 129 "../src/Preferences.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 12);
#line 130 "../src/Preferences.vala"
	result = w;
#line 130 "../src/Preferences.vala"
	return result;
#line 647 "Preferences.c"
}

static GtkSwitch*
preferences_make_switch (Preferences* self,
                         const gchar* setting)
{
	GtkSwitch* w = NULL;
	GtkSwitch* _tmp0_;
	GSettings* _tmp1_;
	GtkSwitch* result;
#line 134 "../src/Preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 134 "../src/Preferences.vala"
	g_return_val_if_fail (setting != NULL, NULL);
#line 135 "../src/Preferences.vala"
	_tmp0_ = (GtkSwitch*) gtk_switch_new ();
#line 135 "../src/Preferences.vala"
	g_object_ref_sink (_tmp0_);
#line 135 "../src/Preferences.vala"
	w = _tmp0_;
#line 136 "../src/Preferences.vala"
	gtk_widget_set_halign ((GtkWidget*) w, GTK_ALIGN_START);
#line 137 "../src/Preferences.vala"
	gtk_widget_set_valign ((GtkWidget*) w, GTK_ALIGN_CENTER);
#line 138 "../src/Preferences.vala"
	_tmp1_ = self->priv->_settings;
#line 138 "../src/Preferences.vala"
	g_settings_bind (_tmp1_, setting, (GObject*) w, "active", G_SETTINGS_BIND_DEFAULT);
#line 139 "../src/Preferences.vala"
	result = w;
#line 139 "../src/Preferences.vala"
	return result;
#line 680 "Preferences.c"
}

static GtkSpinButton*
preferences_make_spinner (Preferences* self,
                          const gchar* setting,
                          gint min_value,
                          gint max_value,
                          gint step)
{
	GtkSpinButton* w = NULL;
	GtkSpinButton* _tmp0_;
	GSettings* _tmp1_;
	GtkSpinButton* result;
#line 142 "../src/Preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../src/Preferences.vala"
	g_return_val_if_fail (setting != NULL, NULL);
#line 143 "../src/Preferences.vala"
	_tmp0_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) min_value, (gdouble) max_value, (gdouble) step);
#line 143 "../src/Preferences.vala"
	g_object_ref_sink (_tmp0_);
#line 143 "../src/Preferences.vala"
	w = _tmp0_;
#line 144 "../src/Preferences.vala"
	_tmp1_ = self->priv->_settings;
#line 144 "../src/Preferences.vala"
	g_settings_bind (_tmp1_, setting, (GObject*) w, "value", G_SETTINGS_BIND_DEFAULT);
#line 145 "../src/Preferences.vala"
	result = w;
#line 145 "../src/Preferences.vala"
	return result;
#line 712 "Preferences.c"
}

static GtkImage*
preferences_make_info (Preferences* self,
                       const gchar* detail)
{
	GtkImage* w = NULL;
	GtkImage* _tmp0_;
	GtkImage* result;
#line 149 "../src/Preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "../src/Preferences.vala"
	g_return_val_if_fail (detail != NULL, NULL);
#line 150 "../src/Preferences.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-information-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 150 "../src/Preferences.vala"
	g_object_ref_sink (_tmp0_);
#line 150 "../src/Preferences.vala"
	w = _tmp0_;
#line 151 "../src/Preferences.vala"
	gtk_widget_set_halign ((GtkWidget*) w, GTK_ALIGN_START);
#line 152 "../src/Preferences.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) w, detail);
#line 153 "../src/Preferences.vala"
	result = w;
#line 153 "../src/Preferences.vala"
	return result;
#line 740 "Preferences.c"
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 157 "../src/Preferences.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 157 "../src/Preferences.vala"
	return _data30_;
#line 750 "Preferences.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 157 "../src/Preferences.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 760 "Preferences.c"
		Preferences* self;
#line 157 "../src/Preferences.vala"
		self = _data30_->self;
#line 157 "../src/Preferences.vala"
		_g_object_unref0 (_data30_->mb);
#line 157 "../src/Preferences.vala"
		_g_object_unref0 (self);
#line 157 "../src/Preferences.vala"
		g_slice_free (Block30Data, _data30_);
#line 770 "Preferences.c"
	}
}

static void
_g_free0_ (gpointer var)
{
#line 166 "../src/Preferences.vala"
	var = (g_free (var), NULL);
#line 779 "Preferences.c"
}

static void
_vala_gchar_free_function_content_of (gpointer data)
{
	gchar* self;
#line 166 "../src/Preferences.vala"
	self = *((gchar**) data);
#line 166 "../src/Preferences.vala"
	_g_free0_ (self);
#line 790 "Preferences.c"
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 169 "../src/Preferences.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 169 "../src/Preferences.vala"
	return _data31_;
#line 800 "Preferences.c"
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 169 "../src/Preferences.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 810 "Preferences.c"
		Preferences* self;
#line 169 "../src/Preferences.vala"
		self = _data31_->_data30_->self;
#line 169 "../src/Preferences.vala"
		_g_free0 (_data31_->lbl);
#line 169 "../src/Preferences.vala"
		_g_free0 (_data31_->name);
#line 169 "../src/Preferences.vala"
		block30_data_unref (_data31_->_data30_);
#line 169 "../src/Preferences.vala"
		_data31_->_data30_ = NULL;
#line 169 "../src/Preferences.vala"
		g_slice_free (Block31Data, _data31_);
#line 824 "Preferences.c"
	}
}

static void
_____lambda104_ (Block31Data* _data31_)
{
	Block30Data* _data30_;
	Preferences* self;
	GSettings* _tmp0_;
	const gchar* _tmp1_;
	GtkMenuButton* _tmp2_;
	const gchar* _tmp3_;
#line 173 "../src/Preferences.vala"
	_data30_ = _data31_->_data30_;
#line 173 "../src/Preferences.vala"
	self = _data30_->self;
#line 174 "../src/Preferences.vala"
	_tmp0_ = self->priv->_settings;
#line 174 "../src/Preferences.vala"
	_tmp1_ = _data31_->name;
#line 174 "../src/Preferences.vala"
	g_settings_set_string (_tmp0_, "default-theme", _tmp1_);
#line 175 "../src/Preferences.vala"
	_tmp2_ = _data30_->mb;
#line 175 "../src/Preferences.vala"
	_tmp3_ = _data31_->lbl;
#line 175 "../src/Preferences.vala"
	gtk_button_set_label ((GtkButton*) _tmp2_, _tmp3_);
#line 853 "Preferences.c"
}

static void
______lambda104__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 173 "../src/Preferences.vala"
	_____lambda104_ (self);
#line 862 "Preferences.c"
}

static GtkMenuButton*
preferences_make_themes (Preferences* self)
{
	Block30Data* _data30_;
	GtkMenuButton* _tmp0_;
	GtkMenu* mnu = NULL;
	GtkMenu* _tmp1_;
	GtkMenuButton* _tmp2_;
	MainWindow* _tmp3_;
	Themes* _tmp4_;
	Themes* _tmp5_;
	GSettings* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	Theme* _tmp9_;
	Theme* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GtkMenuButton* _tmp13_;
	GtkMenu* _tmp14_;
	GArray* names = NULL;
	GArray* _tmp15_;
	MainWindow* _tmp16_;
	Themes* _tmp17_;
	Themes* _tmp18_;
	GtkMenu* _tmp40_;
	GtkMenuButton* _tmp41_;
	GtkMenuButton* _tmp42_;
	GtkMenuButton* result;
#line 157 "../src/Preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 157 "../src/Preferences.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 157 "../src/Preferences.vala"
	_data30_->_ref_count_ = 1;
#line 157 "../src/Preferences.vala"
	_data30_->self = g_object_ref (self);
#line 159 "../src/Preferences.vala"
	_tmp0_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 159 "../src/Preferences.vala"
	g_object_ref_sink (_tmp0_);
#line 159 "../src/Preferences.vala"
	_data30_->mb = _tmp0_;
#line 160 "../src/Preferences.vala"
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
#line 160 "../src/Preferences.vala"
	g_object_ref_sink (_tmp1_);
#line 160 "../src/Preferences.vala"
	mnu = _tmp1_;
#line 162 "../src/Preferences.vala"
	_tmp2_ = _data30_->mb;
#line 162 "../src/Preferences.vala"
	_tmp3_ = self->priv->_win;
#line 162 "../src/Preferences.vala"
	_tmp4_ = main_window_get_themes (_tmp3_);
#line 162 "../src/Preferences.vala"
	_tmp5_ = _tmp4_;
#line 162 "../src/Preferences.vala"
	_tmp6_ = self->priv->_settings;
#line 162 "../src/Preferences.vala"
	_tmp7_ = g_settings_get_string (_tmp6_, "default-theme");
#line 162 "../src/Preferences.vala"
	_tmp8_ = _tmp7_;
#line 162 "../src/Preferences.vala"
	_tmp9_ = themes_get_theme (_tmp5_, _tmp8_);
#line 162 "../src/Preferences.vala"
	_tmp10_ = _tmp9_;
#line 162 "../src/Preferences.vala"
	_tmp11_ = theme_get_label (_tmp10_);
#line 162 "../src/Preferences.vala"
	_tmp12_ = _tmp11_;
#line 162 "../src/Preferences.vala"
	gtk_button_set_label ((GtkButton*) _tmp2_, _tmp12_);
#line 162 "../src/Preferences.vala"
	_g_object_unref0 (_tmp10_);
#line 162 "../src/Preferences.vala"
	_g_free0 (_tmp8_);
#line 163 "../src/Preferences.vala"
	_tmp13_ = _data30_->mb;
#line 163 "../src/Preferences.vala"
	_tmp14_ = mnu;
#line 163 "../src/Preferences.vala"
	gtk_menu_button_set_popup (_tmp13_, _tmp14_);
#line 166 "../src/Preferences.vala"
	_tmp15_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
#line 166 "../src/Preferences.vala"
	g_array_set_clear_func (_tmp15_, (GDestroyNotify) _vala_gchar_free_function_content_of);
#line 166 "../src/Preferences.vala"
	names = _tmp15_;
#line 167 "../src/Preferences.vala"
	_tmp16_ = self->priv->_win;
#line 167 "../src/Preferences.vala"
	_tmp17_ = main_window_get_themes (_tmp16_);
#line 167 "../src/Preferences.vala"
	_tmp18_ = _tmp17_;
#line 167 "../src/Preferences.vala"
	themes_names (_tmp18_, &names);
#line 962 "Preferences.c"
	{
		gint i = 0;
#line 169 "../src/Preferences.vala"
		i = 0;
#line 967 "Preferences.c"
		{
			gboolean _tmp19_ = FALSE;
#line 169 "../src/Preferences.vala"
			_tmp19_ = TRUE;
#line 169 "../src/Preferences.vala"
			while (TRUE) {
#line 974 "Preferences.c"
				Block31Data* _data31_;
				GArray* _tmp21_;
				GArray* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				MainWindow* _tmp25_;
				Themes* _tmp26_;
				Themes* _tmp27_;
				const gchar* _tmp28_;
				Theme* _tmp29_;
				Theme* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				GtkMenuItem* item = NULL;
				const gchar* _tmp35_;
				GtkMenuItem* _tmp36_;
				GtkMenuItem* _tmp37_;
				GtkMenu* _tmp38_;
				GtkMenuItem* _tmp39_;
#line 169 "../src/Preferences.vala"
				_data31_ = g_slice_new0 (Block31Data);
#line 169 "../src/Preferences.vala"
				_data31_->_ref_count_ = 1;
#line 169 "../src/Preferences.vala"
				_data31_->_data30_ = block30_data_ref (_data30_);
#line 169 "../src/Preferences.vala"
				if (!_tmp19_) {
#line 1004 "Preferences.c"
					gint _tmp20_;
#line 169 "../src/Preferences.vala"
					_tmp20_ = i;
#line 169 "../src/Preferences.vala"
					i = _tmp20_ + 1;
#line 1010 "Preferences.c"
				}
#line 169 "../src/Preferences.vala"
				_tmp19_ = FALSE;
#line 169 "../src/Preferences.vala"
				_tmp21_ = names;
#line 169 "../src/Preferences.vala"
				if (!(((guint) i) < _tmp21_->len)) {
#line 169 "../src/Preferences.vala"
					block31_data_unref (_data31_);
#line 169 "../src/Preferences.vala"
					_data31_ = NULL;
#line 169 "../src/Preferences.vala"
					break;
#line 1024 "Preferences.c"
				}
#line 170 "../src/Preferences.vala"
				_tmp22_ = names;
#line 170 "../src/Preferences.vala"
				_tmp23_ = g_array_index (_tmp22_, gchar*, (guint) i);
#line 170 "../src/Preferences.vala"
				_tmp24_ = g_strdup (_tmp23_);
#line 170 "../src/Preferences.vala"
				_data31_->name = _tmp24_;
#line 171 "../src/Preferences.vala"
				_tmp25_ = self->priv->_win;
#line 171 "../src/Preferences.vala"
				_tmp26_ = main_window_get_themes (_tmp25_);
#line 171 "../src/Preferences.vala"
				_tmp27_ = _tmp26_;
#line 171 "../src/Preferences.vala"
				_tmp28_ = _data31_->name;
#line 171 "../src/Preferences.vala"
				_tmp29_ = themes_get_theme (_tmp27_, _tmp28_);
#line 171 "../src/Preferences.vala"
				_tmp30_ = _tmp29_;
#line 171 "../src/Preferences.vala"
				_tmp31_ = theme_get_label (_tmp30_);
#line 171 "../src/Preferences.vala"
				_tmp32_ = _tmp31_;
#line 171 "../src/Preferences.vala"
				_tmp33_ = g_strdup (_tmp32_);
#line 171 "../src/Preferences.vala"
				_tmp34_ = _tmp33_;
#line 171 "../src/Preferences.vala"
				_g_object_unref0 (_tmp30_);
#line 171 "../src/Preferences.vala"
				_data31_->lbl = _tmp34_;
#line 172 "../src/Preferences.vala"
				_tmp35_ = _data31_->lbl;
#line 172 "../src/Preferences.vala"
				_tmp36_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp35_);
#line 172 "../src/Preferences.vala"
				g_object_ref_sink (_tmp36_);
#line 172 "../src/Preferences.vala"
				item = _tmp36_;
#line 173 "../src/Preferences.vala"
				_tmp37_ = item;
#line 173 "../src/Preferences.vala"
				g_signal_connect_data (_tmp37_, "activate", (GCallback) ______lambda104__gtk_menu_item_activate, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 177 "../src/Preferences.vala"
				_tmp38_ = mnu;
#line 177 "../src/Preferences.vala"
				_tmp39_ = item;
#line 177 "../src/Preferences.vala"
				gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 169 "../src/Preferences.vala"
				_g_object_unref0 (item);
#line 169 "../src/Preferences.vala"
				block31_data_unref (_data31_);
#line 169 "../src/Preferences.vala"
				_data31_ = NULL;
#line 1082 "Preferences.c"
			}
		}
	}
#line 180 "../src/Preferences.vala"
	_tmp40_ = mnu;
#line 180 "../src/Preferences.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp40_);
#line 182 "../src/Preferences.vala"
	_tmp41_ = _data30_->mb;
#line 182 "../src/Preferences.vala"
	_tmp42_ = _g_object_ref0 (_tmp41_);
#line 182 "../src/Preferences.vala"
	result = _tmp42_;
#line 182 "../src/Preferences.vala"
	_g_array_unref0 (names);
#line 182 "../src/Preferences.vala"
	_g_object_unref0 (mnu);
#line 182 "../src/Preferences.vala"
	block30_data_unref (_data30_);
#line 182 "../src/Preferences.vala"
	_data30_ = NULL;
#line 182 "../src/Preferences.vala"
	return result;
#line 1106 "Preferences.c"
}

static void
preferences_class_init (PreferencesClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/Preferences.vala"
	preferences_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Preferences.vala"
	g_type_class_adjust_private_offset (klass, &Preferences_private_offset);
#line 24 "../src/Preferences.vala"
	G_OBJECT_CLASS (klass)->finalize = preferences_finalize;
#line 1119 "Preferences.c"
}

static void
preferences_instance_init (Preferences * self,
                           gpointer klass)
{
#line 24 "../src/Preferences.vala"
	self->priv = preferences_get_instance_private (self);
#line 1128 "Preferences.c"
}

static void
preferences_finalize (GObject * obj)
{
	Preferences * self;
#line 24 "../src/Preferences.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES, Preferences);
#line 26 "../src/Preferences.vala"
	_g_object_unref0 (self->priv->_win);
#line 27 "../src/Preferences.vala"
	_g_object_unref0 (self->priv->_settings);
#line 24 "../src/Preferences.vala"
	G_OBJECT_CLASS (preferences_parent_class)->finalize (obj);
#line 1143 "Preferences.c"
}

static GType
preferences_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Preferences), 0, (GInstanceInitFunc) preferences_instance_init, NULL };
	GType preferences_type_id;
	preferences_type_id = g_type_register_static (gtk_dialog_get_type (), "Preferences", &g_define_type_info, 0);
	Preferences_private_offset = g_type_add_instance_private (preferences_type_id, sizeof (PreferencesPrivate));
	return preferences_type_id;
}

GType
preferences_get_type (void)
{
	static volatile gsize preferences_type_id__once = 0;
	if (g_once_init_enter (&preferences_type_id__once)) {
		GType preferences_type_id;
		preferences_type_id = preferences_get_type_once ();
		g_once_init_leave (&preferences_type_id__once, preferences_type_id);
	}
	return preferences_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

